3.18.1 (stable):

Gtk:
* CellRendererProgress:_property_renderable(): Avoid infinite loop.
  (Murray Cumming)
* TreeView: Fix a crash in get_tooltip_context_path()
  (Philipp Lenk) Bug #760030.
* TreeView: _auto_store_on_cellrenderer_text_edited_numerical(): Catch exception.
  (Murray Cumming) Bug #765044 (Justinas)

Gdk:
* Screen::get_font_options(): Really take a copy.
  (Kjell Ahlstedt)

Documentation:
* treeview_editable_cells demo: Catch exception from std::stoi.
  (Kjell Ahlstedt)

Build:
* Fix "make check" after sigc::mem_fun(pointer, func) was deprecated.
  (Kjell Ahlstedt)
* MSVC builds: Look for headers in include/gio-win32-2.0 as well
  (Chun-wei Fan)
* Demos, tests: Use nullptr instead of 0.
  (Kjell Ahlstedt)
* Gtk: Use nullptr instead of 0
  (Kjell Ahlstedt)
* Gdk: Use nullptr instead of 0
  (Kjell Ahlstedt)
* Menushell, Widget: Use noexcept on the destructor implementation.
  To match the generated declaration.
  (Emeric Maschino) Bug #759263, Bug #759262


Changes in 3.18 compared to 3.16:

General:
* Use, and require C++11, using features such as move operations, noexcept
  auto, = delete, nulltpr, override, range-based for loops.
  (Murray Cumming, Kjell Ahlstedt)

Gtk:
* C++11: Add move operations to widget classes.
  (Murray Cumming)
* C++11: Point, TimeCoord: Add move operations.
  (Murray Cumming)
* C++11: Mark all _CLASS_OPAQUE_REFCOUNTED classes as final.
  (Murray Cumming)
* Object (and Widget): Add dont_allow_use_in_glib_refptr_.
  (Kjell Ahlstedt, Murray Cumming)
* Actionable: Add keep_return to the _WRAP_VFUNC() for get_action_name.
  (Kjell Ahlstedt) Bug #705124.
* Adjustment: Deprecate changed() and value_changed().
  (Murray Cumming)
* Assistant: Add get/set_page_has_padding().
  (Murray Cumming)
* CellRendererPixbuf: Deprecate property_follow_state().
  (Kjell Ahlstedt)
* Entry: Add grab_focus_without_selecting()
  (Murray Cumming)
* FontChooser: Add get/set_font_map().
  (Murray Cumming)
* IconInfo: Deprecate get_builtin_pixbuf().
  (Kjell Ahlstedt)
* IconTheme: lookup_icon(), choose_icon(): Add default 0 for flags.
  (Murray Cumming)
* LevelBar: Add set_orientation().
  (Murray Cumming) Bug #752568 (Tobias Hoffmann)
* Add ModelButton.
  (Kjell Ahlstedt)
* Notebook: Add detach_tab().
  (Murray Cumming)
* Overlay:
  - Add reorder_overlay() and get/set_overlay_pass_through().
  - Add child properties.
  (Murray Cumming)
* Paned: Add get/set_wide_handle() and property.
  (Murray Cumming)
* PaperSize: Add is_ipp().
  (Murray Cumming)
* PlacesSidebar:
  - Add set_drop_targets_visible().
  (Kjell Ahlstedt)
  - Deprecate set/get_show_connect_to_server() and the property.
  - Add set/get_show_recent(), set/get_show_trash(),
    set/get_show_other_locations() and properties, and the populate_all
    property.
  (Kjell Ahlstedt)
* Popover:
  - Add get/set_default_widget().
  (Murray Cumming)
  - Wrap the pointing-to property.
  (Kjell Ahlstedt) Bug #723394
* Add PopoverMenu.
  (Kjell Ahlstedt)
* Scrollable: Add get_border() and ScrolledWindow::signal_edge_reached()
  (Kjell Ahlstedt)
* ScrolledWindow: Add signal_edge_reached().
  (Kjell Ahlstedt)
* SearchEntry: Add handle_event() and new signals
  (Kjell Ahlstedt)
* StyleContext: Deprecate set_background().
  (Kjell Ahlstedt)
* IconView: Fix a crash in get_tooltip_context_path().
  (Kjell Ahlstedt)
* TreeView, TreeViewColumn: Deprecate SlotCellData, add SlotTreeCellData.
  (Kjell Ahlstedt) Bug #657844
* Widget: Deprecate drag_begin() without coordinates.
  (Kjell Ahlstedt)
* Window:
  - Add fullscreen_on_monitor().
  (Murray Cumming)
  - Add get_titlebar().
  (Murray Cumming)

Gdk:
* Cursor, Pixbuf, Window: Fix use of Cairo::xxx in namespace Gd
  (Kjell Ahlstedt) Bug #755061 (lagerstrom15)
* Window:
  - Add get/set_passthrough().
  (Murray Cumming)
  - Deprecate get/set_composited(), set_static_gravities() and flush().
  (Kjell Ahlstedt)
* Deprecate open_default_libgtk_only() and supports_composite().
  (Kjell Ahlstedt)


Documentation:
* Remove pixbuf-demo because it is already in the main demo.
  (Kjell Ahlstedt)
* Demo: Remove Icon Theme demo, replacing it by a standalone
  Icon Broswer demo.
  (Kjell Ahlstedt)
* Add GLArea and example to gtkmm-demo.
  (Daniel Hams) Bug #752314
* Demo:
  - Show data files in extra tabs in the Gtk::Notebook.
  - Remove the last traces of the UIManager and stock browser demos.
  - Add Builder demo.
  - Use resource files for the source code and data files.


Build:
* MSVC build fixes.
  (Chun-wei Fan)
* Missing GTKMM_API for CellLayout.
  (Mikhail Titov) Bug #748720
* Demo:  Use getc() if HAVE_GETC_UNLOCKED is not defined.
  (Mikhail Titov) Bug #748657
* Don't disable more deprecation warnings than necessary
  (Kjell Ahlstedt) Bug #750379.


3.18.0 (stable):

* Gtk::Object (and Gtk::Widget): Add dont_allow_use_in_glib_refptr_.
  (Kjell Ahlstedt, Murray Cumming)
* Gtk::TreeView, TreeViewColumn: Deprecate SlotCellData, add SlotTreeCellData.
  (Kjell Ahlstedt) Bug #657844
* Gdk::Cursor, Pixbuf, Window: Fix use of Cairo::xxx in namespace Gd
  (Kjell Ahlstedt) Bug #755061 (lagerstrom15)
* MSVC build fixes.
  (Chun-wei Fan)


3.17.90 (unstable):

Gtk:
* Entry: Add grab_focus_without_selecting()
  (Murray Cumming)
* LevelBar: Add set_orientation().
  (Murray Cumming) Bug #752568 (Tobias Hoffmann)
* Notebook: Add detach_tab().
  (Murray Cumming)
* Overlay:
  - Add reorder_overlay() and get/set_overlay_pass_through().
  - Add child properties.
  (Murray Cumming)
* Paned: Add get/set_wide_handle() and property.
  (Murray Cumming)
* PaperSize: Add is_ipp().
  (Murray Cumming)
* Window: Add fullscreen_on_monitor().
  (Murray Cumming)

Build:
* MSVC Build improvements.
  (Chun-wei Fan)
* MSVC Build: Require MSVC .Net 2013 for C++11 support.
  (Chun-wei Fan)


3.17.80 (unstable):

* Rebuilt with latest glibmm,
  whose gmmproc generates C++ move operations.
  (Murray Cumming)
* C++11: Add move operations to widget classes.
  (Murray Cumming)
* C++11: Point, TimeCoord: Add move operations.
  (Murray Cumming)
* C++11: Mark all _CLASS_OPAQUE_REFCOUNTED classes as final.
  (Murray Cumming)
* C++11: Use std::stod() instead of std::strtod()
  and Use std::stoi() instead of atod().
  (Murray Cumming)


3.17.70 (unstable):

Gtk:
* Add GLArea and example to gtkmm-demo.
  (Daniel Hams) Bug #752314
* PlacesSidebar: Add set_drop_targets_visible().
  (Kjell Ahlstedt)

Build:
* Fix the build with -Wshadow compiler warnings.
  (Murray Cumming, Kjell Ahlstedt) Bug #752469


3.17.50 (unstable):

Gtk:
* PlacesSidebar:
  - Deprecate set/get_show_connect_to_server() and the property.
  - Add set/get_show_recent(), set/get_show_trash(),
    set/get_show_other_locations() and properties, and the populate_all
    property.
  (Kjell Ahlstedt)
* Popover: Add get/set_default_widget().
  (Murray Cumming)
* Window: Add get_titlebar().
  (Murray Cumming)

Build:
* gtk_generate_extra_defs.sh: Fix for the patch command, version 2.7.5
  (Kjell Ahlstedt)
* C++11: Use nullptr instead of 0.
  (Murray Cumming)
* C++11: Use of the override keyword.
  (Murray Cumming)
* C++11: Use of auto.
  (Murray Cumming)
* C++11: Use of range-based for loops.
  (Murray Cumming)
* Fix the build when using -Wshadow (now used in --enable-warnings=fatal).
  (Murray Cumming)

Documentation:
* LevelBar: Document how to workaround the lack of Orientation base class.
  (Murray Cumming) Bug #752568 (Tobias Hoffmann)


3.17.41 (unstable):

Gtk:
* StyleContext: Deprecate set_background().
  (Kjell Ahlstedt)
* IconView: Fix a crash in get_tooltip_context_path().
  (Kjell Ahlstedt)

Build:
* Use (and require) C++11.
  (Murray Cumming, Kjell Ahlstedt)

Documentation:
* Remove pixbuf-demo because it is already in the main demo.
  (Kjell Ahlstedt)
* Demo: Remove Icon Theme demo, replacing it by a standalone
  Icon Broswer demo.
  (Kjell Ahlstedt)


3.17.4 (unstable):

Gtk:
* Assistant: Add get/set_page_has_padding().
  (Murray Cumming)
* FontChooser: Add get/set_font_map().
  (Murray Cumming)
* IconInfo: Deprecate get_builtin_pixbuf().
  (Kjell Ahlstedt)
* IconTheme: lookup_icon(), choose_icon(): Add default 0 for flags.
  (Murray Cumming)
* Widget: Deprecate drag_begin() without coordinates.
  (Kjell Ahlstedt)

Gdk:
* Window: Add get/set_passthrough().
  (Murray Cumming)

* Demo: IconTheme: Don't use deprecated builtin-icon API.
  (Murray Cumming)

Build:
* Don't disable more deprecation warnings than necessary
  (Kjell Ahlstedt) Bug #750379.


3.17.3 (unstable):

Gdk:
* Deprecate open_default_libgtk_only() and supports_composite().
  (Kjell Ahlstedt)
* Window: Deprecate get/set_composited(), set_static_gravities() and flush().
  (Kjell Ahlstedt)

Gtk:
* Actionable: Add keep_return to the _WRAP_VFUNC() for get_action_name.
  (Kjell Ahlstedt) Bug #705124.
* Adjustment: Deprecate changed() and value_changed().
  (Murray Cumming)
* CellRendererPixbuf: Deprecate property_follow_state().
  (Kjell Ahlstedt)
* Add ModelButton.
  (Kjell Ahlstedt)
* Popover: Wrap the pointing-to property.
  (Kjell Ahlstedt) Bug #723394
* Add PopoverMenu.
  (Kjell Ahlstedt)
* Scrollable: Add get_border() and ScrolledWindow::signal_edge_reached()
  (Kjell Ahlstedt)
* ScrolledWindow: Add signal_edge_reached().
  (Kjell Ahlstedt)
* SearchEntry: Add handle_event() and new signals
  (Kjell Ahlstedt)

Documentation:
* Demo:
  - Show data files in extra tabs in the Gtk::Notebook.
  - Remove the last traces of the UIManager and stock browser demos.
  - Add Builder demo.
  - Use resource files for the source code and data files.


Build:
* Missing GTKMM_API for CellLayout.
  (Mikhail Titov) Bug #748720
* Demo:  Use getc() if HAVE_GETC_UNLOCKED is not defined.
  (Mikhail Titov) Bug #748657


3.16:

API additions since 3.14:

Gdk:
* Device: Add get_vendor_id() and get_product_id().
  (Murray Cumming)

Gtk:
* CssProvider: Add CssProviderError and signal_parsing_error()
  (Kjell Ahlstedt)
* Add CssSection.
  (Kjell Ahlstedt)
* Dialog: Add constructors with DialogFlags,
  for instance to create a dialog with a header bar.
  (Kjell Ahlstedt) Bug #738513.
* Grid: Add attach_next_to() without the 'sibling' parameter.
  (Kjell Ahlstedt)  Bug #739340.
* Label: Add get/set_xalign/yalign() and properties.
  (Murray Cumming)
* ScaleButton: Add a constructor without the icons.
  (Murray Cumming)
* ScrolledWindow: Add get/set_overlay_scrolling() and property.
  (Juan R. García Blanco)
* SearchEntry: Add the search_changed signal
  (Kjell Ahlstedt)
* Stack: Add hhomogeneous and vhomogeneous properties.
  (Juan R. García Blanco)
* Add StackSidebar.
  (Kjell Ahlstedt)
* StackSwitcher: Add unset_stack().
  (Kjell Ahlstedt)
* Added StyleProperty
  (Mark Vender) Bug #673317.
* TextTag: Add fallback, fallback-set, letter-spacing, and
  letter-spacing-set properties.
  (Juan R. García Blanco)
* TextBuffer:
  - Add insert_markup().
  - Add the copy_target_list and paste_target_list properties.
  - Wrap the serialize()/deserialize() methods.
  (Kjell Ahlstedt)
* TextView: Add monospace property.
  (Juan R. García Blanco)
* Widget: Added get_action_group() and list_action_prefixes().
  (Murray Cumming)


3.16.0 (stable):

Gtk
* Builder: Don't get gtkmm-derived GTypes while parsing TreeModel <columns>
  (Kjell Ahlstedt) Bug #742637.


3.15.10 (unstable);

Gtk:
* Label: Add get/set_xalign/yalign() and properties.
  (Murray Cumming)
* PaperSize: Define the paper name constants in the .cc file
  (Benoît Dejean) Bug #745345

Documentation:
* CssProvider::load_from_data(): Document that this throws an exception.
  (Murray Cumming)
* Icon theme demo: Catch exceptions while loading icons.
  (Kjell Ahlstedt)
* Stock: Mention the named icons for Copy, Cut, Paste and Delete.
  (Murray Cumming) See GTK+ bug #741969


3.15.9 (unstable);

Gtk:
* Add StackSidebar.
  (Kjell Ahlstedt)
* StackSwitcher: Add unset_stack().
  (Kjell Ahlstedt)
* StyleContext: Deprecate list_regions(), add_region(),
  remove_region(), has_region(), get_backgrount_color(), get_border_color(),
  invalidate.
  (Kjell Ahlstedt)
* TextBuffer: Wrap the serialize()/deserialize() methods.
  (Kjell Ahlstedt) Bug #694250
* Widget: Deprecate  Deprecate override_color(), unset_color(),
  override_background_color(), unset_background_color(), override_font(),
  unset_font(), override_symbolic_color(), unset_symbolic_color(),
  override_cursor(), unset_cursor().
  (Kjell Ahlstedt)
* Window: Deprecate Deprecate property_has_resize_grip(),
  property_resize_grip_visible(), set/get_has_resize_grip(),
  get_resize_grip_is_visible(), get_resize_grip_area().
  (Kjell Ahlstedt)
* Fix error messages from gmmproc by removing unnecessary _IGNORES()s.
  (Kjell Ahlstedt)

Gdk:
* Device: Add get_vendor_id() and get_product_id().
  (Murray Cumming)

Documentation:
* demos: Add stacksidebar demo.
  (Kjell Ahlstedt)
* demos: Replace calls to deprecated Widget::override_*() API.
  (Kjell Ahlstedt)
* Container: Remove obsolete comments that confuse doxygen.
  (Kjell Ahlstedt)
* Put DOXYGEN_SHOULD_SKIP_THIS around *_Class prototypes.
  To workaround a doxygen bug, to fix the genereated DevHelp search index.
  (Murray Cumming) Bug #743918


3.15.4 (unstable);

Gtk:
* Builder::get_type_from_name_vfunc(): Call the base class function.
  Instead of jusgin calling g_type_from_name(), in case the base class
  function does more.
  (Kjell Ahlstedt) Bug #742637.
* TextBuffer:
  - Add insert_markup().
  - Add the copy_target_list and paste_target_list properties.
  (Kjell Ahlstedt)

Documentation:
* Pixbuf: Change a mention of Glib::ResourceError to Gio::ResourceError.
  (Kjell Ahlstedt)


3.15.3 (unstable);

Gtk:
* CssProvider: Add CssProviderError and signal_parsing_error()
  (Kjell Ahlstedt)
* Add CssSection.
  (Kjell Ahlstedt)
* Dialog: Fix the constructors with DialogFlags.
  (Kjell Ahlstedt) Bug #738513 (Simonas Kazlauskas)
* ScaleButton:
  - Correct the constructor.
  - Add a constructor without the icons.
  (Murray Cumming)
* ScrolledWindow: Add get/set_overlay_scrolling() and property.
  (Juan R. García Blanco)
* Stack: Add hhomogeneous and vhomogeneous properties.
  (Juan R. García Blanco)
* TextTag: Add fallback, fallback-set, letter-spacing, and
  letter-spacing-set properties.
  (Juan R. García Blanco)
* TextView: Add monospace property.
  (Juan R. García Blanco)
* Widget: Added get_action_group() and list_action_prefixes().
  (Murray Cumming)

Documentation:
* Add an empty line after @newin where it's missing.
  (Kjell Ahlstedt)
* Fix some Doxygen warnings.
  (Kjell Ahlstedt)
* ScaleButton: Document the constructors.
  (Murray Cumming)


3.15.2 (unstable);

Gtk:
* Dialog: Add constructors with DialogFlags,
  for instance to create a dialog with a header bar.
  (Kjell Ahlstedt) Bug #738513.
* Grid: Add attach_next_to() without the 'sibling' parameter.
  (Kjell Ahlstedt)  Bug #739340.
* Overlay:  Correct the "since" documentation.
* SearchEntry: Add the search_changed signal
  (Kjell Ahlstedt)
* Added StyleProperty
  (Mark Vender) Bug #673317.

Gdk
* Curor: Deprecate the constructor that doesn't take a Display parameter.
  (Murray Cumming)
* Pixbuf: Deprecate create_from_inline().
  (Kjell Ahlstedt)


3.14:

API additions since 3.12:

Gdk:
* Device: Add get_last_event_window().
  (Murray Cumming)
* Pixbuf: Add get_byte_length() and create_from_resource().
  (Murray Cumming)
* Window: Add get/set_event_compression(), set_shadow_width(),
  and show_window_menu().
  (Murray Cumming)

Gtk:
* Deprecate Alignment.
  (Murray Cumming)
* Application: Add get_actions_for_accel(), prefers_app_menu(), and
  get_menu_by_id().
  (Murray Cumming)
* Deprecate Arrow.
  (Kjell Ahlstedt)
* Bin: Deprecate add_label(const Glib::ustring& label, bool mnemonic, double x_align, double y_align) and
    add_pixlabel(const std::string& pixfile, const Glib::ustring& label, double x_align, double y_align).
    Add add_pixlabel(const std::string& pixfile, const Glib::ustring& label, Align x_align, Align y_align).
* Box: Wrap child properties
  (Juan R. García Blanco) Bug #140515
* CellArea: Add attribute_get_column().
  (Murray Cumming)
* Container: Deprecate [set|get]_resize_mode() and set_reallocate_redraws().
* EntryCompletion: Add the no_matches signal.
  (Murray Cumming)
* Add EventController and Gesture* classes.
  (Kjell Ahlstedt)
* Grid: Wrap child properties
  (Juan R. García Blanco) Bug #140515
* HeaderBar: Wrap child properties
  (Juan R. García Blanco) Bug #140515
* IconInfo: Deprecate set_raw_coordinates(), get_embedded_rect(),
  get_attach_points() and get_display_name().
  (Murray Cumming)
* IconTheme: Add add_resource_path() and deprecate add_builtin_icon().
  (Murray Cumming)
* Label: Deprecate Label(const Glib::ustring& label, float xalign, float yalign, bool mnemonic).
* ListBox:
  - Add selected_foreach(), get_selected_rows(), unselect_row(), select_all()
  and unselect_all(). Add the selected_rows_changed signal.
  (Murray Cumming)
* ListBoxRow: Add is_selected(), set/get_selectable(), set/get_activatable().
  Add the selectable and activatable properties.
  (Murray Cumming)
* Deprecate Misc (almost - it is still a base class).
  (Kjell Ahlstedt)
* Notebook: Add child properties tab_label, menu_label, position,
  tab_expand, tab_fill, reorderable, and detachable.
  (Juan R. García Blanco)
* Deprecate NumerableIcon.
  (Kjell Ahlstedt)
* Add Overlay.
  (Juan R. García Blanco)
* Paned: Wrap child properties
  (Juan R. García Blanco) Bug #140515
* Settings: Add the gtk_long_press_time property.
  (Murray Cumming)
* Stack: Add child properties name, title, icon_name, position, and
  needs_attention.
  (Juan R. García Blanco)
* StatusIcon:  Deprecate this because it is deprecated in gtk+
  (Kjell Ahlstedt)
* StyleContext: Really add get_scale().
  (Murray Cumming)
* Switch: Add set/get_state(), the state property, and the state_set signal.
* Toolbar: Add child properties expand and homogeneous.
  (Juan R. García Blanco) Bug #140515
* TreeView: Deprecate property_rules_hint().
  (Kjell Ahlstedt)
* Widget:
  - Deprecate get/set_double_buffered() and the property.
  - Deprecate region_intersect(),
  get_root_window(), [set|get]_margin_[left|right](), property_style(),
  property_margin_[left|right]().
  (Kjell Ahlstedt)
  - Add get/set_clip().
  (Murray Cumming)
* WidgetPath:  Deprecate iter_add_region(),
  iter_remove_region(), iter_clear_regions(), iter_list_regions()
  and iter_has_region().
  (Murray Cumming)


3.14.0 (stable):

Documentation:
* Headerbar demo: Update for renamed arrow icons.
  (Kjell Ahlstedt)
    
Build:
* Update and Overhaul Visual Studio 2008 and 2010 Projects.
  (Chun-wei Fan)
* Fix the demos on Windows.
  (Chun-wei Fan)
    

3.13.8 (unstable):

Gdk:
* Window: Add get/set_event_compression(), set_shadow_width(),
  and show_window_menu().
  (Murray Cumming)

Gtk:
* Application: Add get_actions_for_accel(), prefers_app_menu(), and
  get_menu_by_id().
  (Murray Cumming)
* CellArea: Add attribute_get_column().
  (Murray Cumming)
* EntryCompletion: Add the no_matches signal.
  (Murray Cumming)
* ListBox:
  - Add selected_foreach(), get_selected_rows(), unselect_row(), select_all()
  and unselect_all(). Add the selected_rows_changed signal.
  (Murray Cumming)
* ListBoxRow: Add is_selected(), set/get_selectable(), set/get_activatable().
  Add the selectable and activatable properties.
  (Murray Cumming)
* Settings: Add the gtk_long_press_time property.
  (Murray Cumming)
* StatusIcon:  Deprecate this because it is deprecated in gtk+
  (Kjell Ahlstedt)
* StyleContext: Really add get_scale().
  (Murray Cumming)
* Widget: Add get/set_clip().
  (Murray Cumming)


3.13.7 (unstable):

Gtk:
* Box: Wrap child properties
  (Juan R. García Blanco) Bug #140515
* Grid: Wrap child properties
  (Juan R. García Blanco) Bug #140515
* HeaderBar: Wrap child properties
  (Juan R. García Blanco) Bug #140515
* Paned: Wrap child properties
  (Juan R. García Blanco) Bug #140515
* TreeView: Deprecate property_rules_hint().
  (Kjell Ahlstedt)

Documentation:
* Gtk::FileChooser::get_current_folder(): Update documentation from GTK+.
  (Kjell Ahlstedt) Bug #734570 (da_fox)


3.13.5 (unstable):

Gtk:
* Container: Support child properties.
  (Juan R. García Blanco)
* Add EventController and Gesture* classes.
  (Kjell Ahlstedt)
* IconTheme: Add add_resource_path() and deprecate add_builtin_icon().
  (Murray Cumming)
* Notebook: Add child properties tab_label, menu_label, position,
  tab_expand, tab_fill, reorderable, and detachable.
  (Juan R. García Blanco)
* Stack: Add child properties name, title, icon_name, position, and
  needs_attention.
  (Juan R. García Blanco)
* Switch: Add set/get_state(), the state property, and the state_set signal.
* Toolbar: Add child properties expand and homogeneous.
  (Juan R. García Blanco) Bug #140515
* Widget: Deprecate get/set_double_buffered() and the property.
  (Kjell Ahlstedt)

Documentation:
* Demo: Update notebook's tabs style to match the gtk3-demo.
  (Juan R. García Blanco)
* Demo: Add a gestures example, based on the gtk3-demo equivalent.
  (Kjell Ahlstedt)
* Add Gestures group to the reference docs
  (Kjell Ahlstedt)


3.13.3 (unstable):

Gtk:
* Builder: Fix ref count in get_widget() and get_widget_derived() and add test
  case.
  (Kjell Ahlstedt) Bug #731444 (Peter)
* Container: Deprecate [set|get]_resize_mode() and set_reallocate_redraws().
* Widget: Deprecate reparent(), region_intersect(),
  get_root_window(), [set|get]_margin_[left|right](), property_style(),
  property_margin_[left|right]().
  (Kjell Ahlstedt) 
* Add Overlay.
  (Juan R. García Blanco)
* IconInfo: Deprecate set_raw_coordinates(), get_embedded_rect(),
  get_attach_points() and get_display_name().
  (Murray Cumming)
* Widget: Undeprecate and reimplement reparent() because it is still useful in
  gtkmm.
  (Kjell Ahlstedt)
* WidgetPath:  Deprecate iter_add_region(),
  iter_remove_region(), iter_clear_regions(), iter_list_regions()
  and iter_has_region().
  (Murray Cumming)

Documentation:
* Application: Add documentation concerning the use of quit()
  (Kjell Ahlstedt) Bug #731126 (Glenn Rice)
* Builder: Add documentation about widget and window lifetimes.
  (Kjell Ahlstedt) Bug #731444 (Peter)
* Add Overlay demo.
  (Juan R. García Blanco)
* demo: Avoid use of deprecated API.
  (Murray Cumming)
* demo: Make side bar scrollable as in the C version.
   (Juan R. García Blanco)   


3.13.2 (unstable):

Gtk:
* Don't assert argc/argv are non-null in Application::run()
  (Jonathon Jongsma) Bug #729212.
* Deprecate Alignment.
  (Murray Cumming)
* Deprecate Arrow.
  (Kjell Ahlstedt)
* Bin: Deprecate add_label(const Glib::ustring& label, bool mnemonic, double x_align, double y_align) and
    add_pixlabel(const std::string& pixfile, const Glib::ustring& label, double x_align, double y_align).
    Add add_pixlabel(const std::string& pixfile, const Glib::ustring& label, Align x_align, Align y_align).
* Label: Deprecate Label(const Glib::ustring& label, float xalign, float yalign, bool mnemonic).
* MenuItem: Don't use deprecated Misc property.
* Deprecate Misc (almost - it is still a base class).
  (Kjell Ahlstedt)
* Deprecate NumerableIcon.
  (Kjell Ahlstedt)

Documentation:
* gtkmm-demo: use HeaderBar in main window.
  (Juan R. García Blanco)
* Fix a segfault in the Drawing Area demo
  (Kjell Ahlstedt )
* Update documentation of Gtk::Dialog::run()
  (Kjell Ahlstedt)
*  Remove unnecessary parts of the docs_override.xml files
  (Kjell Ahlstedt)


3.12:

API additions since 3.10:

Gtk:
* Add ActionBar.
  (Juan R. García Blanco) Bug #723124
* Application:
  - Added set_accel_for_action(), get/set_accels_for_action() and
  list_action_descriptions().
  (Murray Cumming)
  - Add set_accels_for_action(), deprecating add_accelerator().
  (Murray Cumming)
* Assistant: Add use-header-bar property.
  (Juan R. García Blanco)
* Box: Add get/set_center_widget() and unset_center_widget().
  (Juan R. García Blanco)
* Builder: Add expose_[object|widget](), [set|get]_application().
  (Kjell Ahlstedt)
* Button: Add set_image_from_icon_name() with a use_fallback argument.
  (Kjell Ahlstedt)
* CellArea: Add signal_apply_attributes().
  (Kjell Ahlstedt)
* Dialog: Add get/set_header_bar() and the
  use_header_bar property.
  (Juan R. García Blanco)
* Entry:
  - Add the max-width-chars property.
  - Add get/set_max_width_chars() and the property.
  (Juan R. García Blanco)
  - Add set/get_attributes() and the property.
  (Kjell Ahlstedt)
* Add FlowBox and FlowBoxChild.
  (Juan R. García Blanco) Bug #723801
* HeaderBar: Addd get_decoration_layout(), get_has_subtitle(),
  set_decoration_layout() and set_has_subtitle() and properties.
  (Juan R. García Blanco) Bug #723199
* IconInfo: Add is_symbolic().
  (Juan R. García Blanco)
* MenuButton:
  - Add get/set_popover() and unset_popover() and the property.
  - Add get/set_use_popover() and the property.
  (Juan R. García Blanco)
* PlacesSidebar: Add local-only object property and get/set methods.
  (Juan R. García Blanco) Bug #723893
* Add Popover.
  (Juan R. García Blanco) Bug #723058
* SelectionData: Add get_data(int& length).
  (Kjell Ahlstedt)
* Settings: Add gtk-decoration-layout, gtk-shell-shows-desktop
  and gtk-dialogs-use-header properties.
  (Juan R. García Blanco) Bug #723397
* Stack: Add get_transition_running(), get_child_by_name() and
  the transition-runnning property.
  (Juan R. García Blanco) Bug #723397
* ToolItem: Add unset_proxy_menu_item().
  (Kjell Ahlstedt)
* Widget:
  - Added get/set_margin_start/end() and properties.
  (Murray Cumming)
  - Added scale-factor property.
  (Murray Cumming)
* Window: Add is_maximized() and the is-maximized property.
  (Juan R. García Blanco)


Gdk:
* Device: Add get_last_event_window().
  (Murray Cumming)
* Pixbuf:
  - Add get_byte_length() and create_from_resource().
  (Murray Cumming)


3.12.0 (stable):

* Application: Add set_accels_for_action(), deprecating add_accelerator().
  (Murray Cumming)
* Button: Add set_image_from_icon_name() with a use_fallback argument.
  (Kjell Ahlstedt)
* demo:
  - Add the FlowBox demo part.
  (Juan R. Garcia Blanco, Murray Cumming)
  - Add HeaderBar demo.
  (Juan R. Garcia Blanco)

3.11.10 (unstable):

Gdk:
* Pixbuf: Add get_byte_length().
  (Murray Cumming)

Gtk:
* Dialog: Deprecate the const version of get_action_area() too.
  (Kjell Ahlstedt)  

Build:
* Update Visual Studio Projects
  (Chun-wei Fan)

3.11.9 (unstable):

Gdk:
* Device: Add get_last_event_window().
  (Murray Cumming)

Gtk:
* Application: Added set_accel_for_action(), get/set_accels_for_action() and
  list_action_descriptions().
  (Murray Cumming)
* Widget:
  - Added get/set_margin_start/end() and properties.
  (Murray Cumming)
  - Added scale-factor property.
  (Murray Cumming)


3.11.8 (unstable):

Gtk:
* Window: Add is_maximized() and the is-maximized property.
  (Juan R. García Blanco)
* IconInfo: Add is_symbolic().
  (Juan R. García Blanco)
* Assistant: Add use-header-bar property.
  (Juan R. García Blanco)
* ActionBar:
  - Now inherits from GtkBin
  - spacing and center-widget properties removed.
  - Add unset_center_widget() method.
  (Juan R. García Blanco)
* Box: Add get/set_center_widget() and unset_center_widget().
  (Juan R. García Blanco)
* Dialog: Add get/set_header_bar() and the
  use_header_bar property.
  (Juan R. García Blanco)
* Entry:
  - Add the max-width-chars property.
  - Add get/set_max_width_chars() and the property.
  (Juan R. García Blanco)
* MenuButton:
  - Add get/set_popover() and unset_popover() and the property.
  - Add get/set_use_popover() and the property.
  (Juan R. García Blanco)
* Popover: Add constructor that takes a model and
  add bind_model().
  (Juan R. García Blanco)


3.11.7 (unstable):

* MessageDialog: Deprecate get/set_image() and the property.
  (Murray Cumming)
* Popover:
  - Add closed signal.
  (Juan R. García Blanco)
  - Add closed signal.
  Correct the type of the pointing_to property and method parameter.
  (Juan R. García Blanco)
* FlowBoxChild: Add activate signal.
  (Juan R. García Blanco)


3.11.5 (unstable):

Gtk:
* Add ActionBar.
  Bug #723124
  (Juan R. García Blanco)
* Builder: Add expose_[object|widget](), [set|get]_application().
  (Kjell Ahlstedt)
* Dialog: Deprecate set_alternative_button_order_from_array(),
  and alternative_button_order().
  (Murray Cumming)
* Entry: Add set/get_attributes() and the property.
  (Kjell Ahlstedt)
* Add FlowBox.
  Bug #723801
  (Juan R. García Blanco)
* HeaderBar: Added decoration-layout, decoration-layout-set and
  has-subtitle object properties.
  Addd get_decoration_layout(), get_has_subtitle(),
  set_decoration_layout() and set_has_subtitle().
  Bug #723199
  (Juan R. García Blanco)
* Main: Undeprecate add_gtk_option_group(), because it is still needed.
  (Murray Cumming)
* PlacesSidebar: Add local-only object property and get/set methods.
  Bug #723893
  (Juan R. García Blanco)
* Add Popover.
  Bug #723058
  (Juan R. García Blanco)
* Settings: Add gtk-decoration-layout, gtk-shell-shows-desktop
  and gtk-dialogs-use-header properties.
  Bug #723397
  (Juan R. García Blanco)
* Stack: Add get_transition_running(), get_child_by_name() and
  the transition-runnning property.
  Bug #723397
  (Juan R. García Blanco)

Documentation:
* Update the Doxygen configuration.
  (Kjell Ahlstedt)


3.11.4 (unstable):

Gtk:
* Action, Activatable: Undeprecate methods that don't use a StockID.
  We didn't mean to leave them deprecated.
  (Kjell Ahlstedt)
* CellArea: Add signal_apply_attributes().
  (Kjell Ahlstedt)
* SelectionData: Add get_data(int& length).
  (Kjell Ahlstedt)
* ToggleAction: Deprecate the create() that uses (deprecated) StockID
  (Kjell Ahlstedt)
* ToolItem: Add unset_proxy_menu_item().
  (Kjell Ahlstedt)
* UIManager: Deprecate the add-tearoffs property.
  (Kjell Ahlstedt)

Gdk:
* Pixbuf: Add create_from_resource() methods.
* RGBA, Color: Fix set_hsl(), improve documentation.
  (Kjell Ahlstedt) Bug #720258

Build:
* CellArea: Fix documentation of typedef SlotForeachAlloc
  An extra '>' in the docs trapped doxygen 1.8.4 in an infinite loop.
  (Kjell Ahlstedt)
* Fix the build with --disable-deprecated-api
  (Kjell Ahlstedt)

Documentation:
* Add missing widget images.
  (Kjell Ahlstedt)
* AppChooser*: Improve documentation.
  (Kjell Ahlstedt) Bug #650012
* ColorChooser::get_rgba(): Add documentation
  (Kjell Ahlstedt)
* SelectionData: Add methods docs.
  (Kjell Ahlstedt)
* ToolItem: Add class docs.
  (Kjell Ahlstedt)


3.10.1 (stable):

Gtk:
* Avoid including deprecated stockid.h.
  This lets applications build with deprecated API disabled.
  (Murray Cumming)
* RadioAction, RecentAction: Deprecate constructors and methods that
  take StockID.
  StockID was already deprecated so this should not affect
  application builds.
  (Kjell Ahlstedt)

Changes in 3.10 compared to 3.8:

Gtk
* Added HeaderBar.
  (Juan Rafael García Blanco) Bug #708194
* Added ListBox and ListBoxRow,
  (Kjell Ahlstedt) Bug #708115
* Added PlacesSidebar.
  (Juan Rafael García Blanco) Bug #705642
* Add Revealer.
  (Juan R. García Blanco) Bug #705460
* Added Stack and StackSwitcher,
  (Andrew Potter) Bug #704964
* Deprecate Table.
  (Kjell Ahlstedt)
* Deprecate StockID, StockItem, BuiltinStockID, namespace Gtk::Stock.
  (Kjell Ahlstedt)
* Deprecate Gtk::IconFactory, IconSet, IconSource.
  (Kjell Ahlstedt)
* Application:
  - add/remove_accelerator(): Add overloads without the variant parameter.
  (Murray Cumming)
  - Add missing gtk_init() call in one of the constructors.
  (Murray Cumming)
* Button: Add constructor that takes an icon_name and size.
  (Murray Cumming)
* CellRenderer: Deprecate property_cell_background_gdk().
  (Kjell Ahlstedt)
* CellRendererPixbuf: Add the surface property.
  (Murray Cumming)
* CellView: Deprecate property_background_gdk().
  (Kjell Ahlstedt)
* ColorButton: Deprecate get_alpha().
  (Kjell Ahlstedt)
* Container: deprecate resize_children().
  (Kjell Ahlstedt)
* Box: Add get/set_baseline_position() and property.
  (Murray Cumming)
* Entry: Add get/set_tabs() and property.
  (Murray Cumming)
* FileChooser: Add get_current_name().
  (Murray Cumming)
* HeaderBar: Make get_show_close_button() const.
  (Juan Rafael García Blanco)
* Grid:
  - Add get/set_row_baseline_position()
  and get/set_baseline_row(), and baseline-row property.
  (Murray Cumming)
  - Add remove_row() and remove_column().
  (Murray Cumming) 
* Image: Add set(Cairo::Surface)
  (Murray Cumming)
* InfoBar: Add get/set_show_close_button() and
  the property.
  (Murray Cumming)
* IconInfo: Add load_surface() and get_base_scale().
  (Murray Cumming)
* IconTheme:  Add lookup_icon() method overloads that
  take a scale parameter.
  Add choose_icon() method overload that take a scale
  parameter.
  Add load_icon() method overload that takes a scale parameter.
  Add load_surface().
  (Murray Cumming) 
* IconView: set_cursor(): Add a version with no cell parameter
  (Murray Cumming)
* Image: Deprecate methods that take an IconSet or a StockID parameter.
* Label: Add get/set_lines() and property.
  (Murray Cumming)
* Menu, MenuBar: Add constructors that take Gio::MenuModels.
  (Murray Cumming)
* Menu: Make attach_to_widget() public.
  (Murray Cumming)
* MenuButton: Deprecate unset_menu().
  (Kjell Ahlstedt)
* MenuShell: bind_model(): Add a method overload without the
  action_namespace parameter.
  (Murray Cumming)
* PlacesSidebar: Fix crash with the drag_* signals,
  correct some OWNERSHIP_*s, pass vectors by reference in signals
  (Murray Cumming) Bug #705642
* RadioAction: Deprecate the constructor that uses StockID.
  (Murray Cumming)
* RadioToolButton: Fix set_group(). Add reset_group().
  (Kjell Ahlstedt)
* Scale: Constructor: Remove the default parameter value
  to avoid ambiguity.
  (Murray Cumming) Bug #707810 (cheshirekow)
* Add SearchBar.
  (Juan Rafael Garcia Blanco)
* ScrolledWindow: Deprecate property_window_placement_set().
* Settings:
  - Deprecate ignored settings.
    (Murray Cumming)
  - Add create_action().
    (Murray Cumming)
* StyleContext: Deprecate [set|get]_direction() and render_icon_pixbuf().
  (Kjell Ahlstedt)
* ToggleAction: Deprecate the constructor that uses StockID
  (Murray Cumming)
* Widget:
  - Make insert_action_group() public.
    (Murray Cumming)
  - Add remove_action_group()
    (Murray Cumming)
  - Add get_scale_factor().
    (Murray Cumming)
  - Add drag_begin() that takes x and y coordinates.
    (Murray Cumming)
  - Widget Add get_preferred_height_for_width(),
    get_allocated_baseline() and get_valign_with_baseline().
    (Murray Cumming)
  - Deprecate [un]set_composite_name(),
    [push|pop]_composite_child(), get_requisition() and methods that take a
    StockID parameter.
    (Kjell Ahlstedt)
* Window:
  - get_frame_extents(): Add const version.
    (Murray Cumming)
  - Add close().
    (Murray Cumming)
  - Deprecate reshow_with_initial_size().
    (Kjell Ahlstedt)
* Add missing includes in gdkmm.h and gtkmm.h.
  (Kjell Ahlstedt) Bug #699993.

Gdk:
* Deprecate Color.
  (Murray Cumming)
* Cursor: Wrap some new functions.
  (Murray Cumming)
* Device: Add get_position() that uses doubles.
  (Murray Cumming)
* Display: Deprecate get_n_screens().
  (Murray Cumming)
* Screen: Add get_monitor_scale_factor().
  (Murray Cumming)
* Window:
  - Add get_scale_factor().
  - Add get_device_position() taking doubles.
  - Add create_similar_image_surface().
  - Add set_opaque_region().
    (Murray Cumming)

Build:
* Update Visual Studio Projects
  (Chun-wei Fan)
* Update gtk-demo MSVC Projects
  (Chun-wei Fan)
* Move to a generated ChangeLog.
  (José Alburquerque)

Documentation:
* Demos: Catch Glib::FileError from demo_find_file().
  (Kjell Ahlstedt)
* Demos: Add IconTheme demo.
  (Kjell Ahlstedt)
* Demos: Fix calls to Gtk::Grid::attach().
  (Kjell Ahlstedt)



3.10.0 (stable):

Gtk

* Undeprecate UIManager, Action, ActionGroup,
  ToggleAction, RadioAction and RecentAction,
  though they are still deprecated in the C API:
  See https://mail.gnome.org/archives/gtkmm-list/2013-October/msg00003.html
  (Murray Cumming)
* RadioAction: Deprecate the constructor that uses StockID.
  (Murray Cumming)
* ToggleAction: Deprecate the constructor that uses StockID
  (Murray Cumming)
* Application:
  - add/remove_accelerator(): Add overloads without the variant parameter.
  (Murray Cumming)
  - Add missing gtk_init() call in one of the constructors.
  (Murray Cumming)
* Button: Remove unnnecessary BuiltinStockID declaration.
  (Murray Cumming)
* HeaderBar: Make get_show_close_button() const.
  (Juan Rafael García Blanco)
* IconView: set_cursor(): Add a version with no cell parameter
  (Murray Cumming)
* PlacesSidebar: Fix crash with the drag_* signals,
  correct some OWNERSHIP_*s, pass vectors by reference in signals
  (Murray Cumming) Bug #705642
* Settings: Add create_action().
* SearchBar: handle_event(): Take a GdkEventKey instead of GdkEvent.
  (Murray Cumming)
* Window: get_frame_extents(): Add const version.
  (Murray Cumming)

Gdk:
* Deprecate Color.
  (Murray Cumming)

Build:
* Update gtk-demo MSVC Projects
  (Chun-wei Fan)


3.9.16 (unstable):

Gtk:
* Added HeaderBar.
  (Juan Rafael García Blanco) Bug #708194
* Added ListBox and ListBoxRow,
  (Kjell Ahlstedt) Bug #708115
* Added PlacesSidebar.
  (Juan Rafael García Blanco) Bug #705642
* Added Stack and StackSwitcher,
  (Andrew Potter) Bug #704964
* Widget:
  * Make insert_action_group() public.
  (Murray Cumming)
  * Add remove_action_group()
  (Murray Cumming)

3.9.14 (unstable):

Gtk:
* Add SearchBar.
  (Juan Rafael Garcia Blanco)
* Button: Replace the icon_name ctor by set_image_from_icon_name().
  (Kjell Ahlstedt)  Bug #707791
* Scale: Constructor: Remove the default parameter value
  to avoid ambiguity.
  (Murray Cumming) Bug #707810 (cheshirekow)

Gdk:
* Window: Add set_opaque_region().
  (Murray Cumming)

Tools:
* gtk_generate_extra_defs.sh: Add --make-patch option.
  (Kjell Ahlstedt)

Build:
* Update Visual Studio Projects
  (Chun-wei Fan)


3.9.12 (unstable):

Gtk:
* Button: Add constructor that takes an icon_name and size.
  (Murray Cumming)
* Entry: Add get/set_tabs() and property.
  (Murray Cumming)
* Label: Add get/set_lines() and property.
  (Murray Cumming)
* Add Revealer.
  (Juan R. García Blanco) Bug #705460
* Widget:
  - add get_scale_factor().
    (Murray Cumming)
  - Widget: Add drag_begin() that takes x and y coordinates.
    (Murray Cumming)

Gdk:
* Cursor: Wrap some new functions.
  (Murray Cumming)


3.9.10 (unstable):

Gdk:
* Device: Add get_position() that uses doubles.
  (Murray Cumming)
* Screen: Add get_monitor_scale_factor().
  (Murray Cumming)
* Window: Add get_scale_factor().
  Add get_device_position() taking doubles.
  Add create_similar_image_surface().
  (Murray Cumming)

Gtk:
* CellRendererPixbuf: Add the surface property.
  (Murray Cumming)
* Box: Add get/set_baseline_position() and property.
  (Murray Cumming)
* FileChooser: Add get_current_name().
  (Murray Cumming)
* Image: Add set(Cairo::Surface)
  (Murray Cumming)
* InfoBar: Add get/set_show_close_button() and
  the property.
  (Murray Cumming)
* IconInfo: Add load_surface() and get_base_scale().
  (Murray Cumming)
* IconTheme:  Add lookup_icon() method overloads that
  take a scale parameter.
  Add choose_icon() method overload that take a scale
  parameter.
  Add load_icon() method overload that takes a scale parameter.
  Add load_surface().
  (Murray Cumming) 
* Grid:
  - Add get/set_row_baseline_position()
  and get/set_baseline_row(), and baseline-row property.
  (Murray Cumming)
  - Add remove_row() and remove_column().
  (Murray Cumming) 
* Menu, MenuBar: Add constructors that take Gio::MenuModels.
  (Murray Cumming)
* Menu: Make attach_to_widget() public.
  (Murray Cumming)
* MenuShell: bind_model(): Add a method overload without the
  action_namespace parameter.
  (Murray Cumming)
* RadioToolButton: Fix set_group(). Add reset_group().
  (Kjell Ahlstedt)
* Widget Add get_preferred_height_for_width(),
  get_allocated_baseline() and get_valign_with_baseline().
  (Murray Cumming)
* Window: Add close().
  (Murray Cumming)

Documentation:
* Demos: Catch Glib::FileError from demo_find_file().
  (Kjell Ahlstedt)
* Demos: Add IconTheme demo.
  (Kjell Ahlstedt)


3.9.8 (unstable):

Gdk:
* Display: Deprecate get_n_screens().
  (Murray Cumming)

Gtk:
* Action: Deprecate all methods, signals and properties, but not yet the 
  class itseld, because it is still used in not-yet-deprecated API.
  Also deprecated RadioACtion, RecentAction, ToggleAction.
  (Kjell Ahlstedt)
* Deprecate ActionGroup.
  (Kjell Ahlstedt)
* CellRenderer: Deprecate property_cell_background_gdk().
  (Kjell Ahlstedt)
* CellView: Deprecate property_background_gdk().
  (Kjell Ahlstedt)
* ColorButton: Deprecate get_alpha().
  (Kjell Ahlstedt)
* Container: deprecate resize_children().
  (Kjell Ahlstedt)
* Deprecate Gtk::IconFactory, IconSet, IconSource.
  (Kjell Ahlstedt)
* Image: Deprecate methods that take an IconSet or a StockID parameter.
* StyleContext: Deprecate [set|get]_direction() and render_icon_pixbuf().
* Deprecate StockID, StockItem, BuiltinStockID, namespace Gtk::Stock.
* MenuButton: Deprecate unset_menu().
  (Kjell Ahlstedt)
* MenuButton: Deprecate unset_menu().
  (Kjell Ahlstedt)
* ScrolledWindow:  Deprecate property_window_placement_set().
* Settings: Deprecate ignored settings.
* Deprecate Table.
  (Kjell Ahlstedt)
* Deprecate UIManager.
  (Kjell Ahlstedt)
* Widget: Deprecate [un]set_composite_name(),
  [push|pop]_composite_child(), get_requisition() and methods that take a
  StockID parameter.
  (Kjell Ahlstedt)
* Window: Deprecate reshow_with_initial_size().
  (Kjell Ahlstedt)
* Add missing includes in gdkmm.h and gtkmm.h.
  (Kjell Ahlstedt) Bug #699993.

Build:
* Move to a generated ChangeLog.
  (José Alburquerque)

Documentation:
* Demos: Fix calls to Gtk::Grid::attach().
  (Kjell Ahlstedt)


3.8.1 (stable):

Gtk:
* Widget: Don't call signal_hide handlers on a widget being deleted,
  to fix a crash in some applications.
  (Kjell Ahlstedt) Bug #605728

Changes in 3.8 compared to 3.6:

Gtk:
* AccelLabel: Add set_accel().
  (Murray Cumming)
* ActionGroup: Add get/set_accel_group()
  and the accel-group property.
  (Murray Cumming)
* Bin, Container::remove(): Restore the floating ref of a managed widget.
  (Kjell Ahlstedt) Bug #685739 (Jonas Platte)
* Builder:
  - Add const versions of get_object() and get_widget[_derived]().
  (Kjell Ahlstedt) Bug #666823 (Hubert Figuière)
  - Add get_objects().
  (Hubert Figuière) Bug #666823
* Entry: Add the populate_all property.
  (Murray Cumming)
* Image: Add the resource property.
  (Murray Cumming)
* IconInfo: Add load_icon_async(),
  load_symbolic_async(), load_symbolic_for_context().
  (Murray Cumming)
* IconView:
  - Add get/set_activate_on_single_click().
  and the activate-on-single-click property.
  - Add get_cell_rect().
  (Murray Cumming)  
* LevelBar: Add get/set_inverted().
  (Murray Cumming)
* MenuShell: Add bind_model().
  (Murray Cumming)
* ScrolledWindow: Add remove_with_viewport().
  (Kjell Ahlstedt) Bug #685739 (Jonas Platte)
* Settings: Add the  gtk-recent-files-enabled
  and gtk-primary-button-warps-slider
  properties.
  (Murray Cumming)
* TextView: Add the populate_all property.
  (Murray Cumming)
* TreeView: Add get/set_activate_on_single_click()
  and the activate-on-single-click property.
  (Murray Cumming
* Widget:
  - Add is_visible(), register_window() and
  unregister_window().
  (Murray Cumming)
  - Add get/set_opacity(),
  set_opacity() and the opacity property.
  (Murray Cumming)
* Window: Deprecate get_opacity(),
  set_opacity() and the opacity property.
  (Murray Cumming)
* Window: Add set_titlebar().
  (Murray Cumming)
* Modify the deletion of widgets.
  (Kjell Ahlstedt) Bug #605728 (Murray Cumming) and Bug #315874 (Philip Langdale)

Gdk:
* PixbufAnimation: Fix refcounting on get_iter().
  (Andrew Potter) Bug #688686
* Rectangle: Add Gdk::join() and Gdk::intersect() nonmember functions.
  (Kjell Ahlstedt) Bug #452130 (Jonathon Jongsma)
* Window: Add get/set_fullscreen_mode().
  (Murray Cumming)

Build:
* Fix and Update the Visual Studio Solution Files
  for MSVC.Net 2005, 2008 and 2010.
  (Chun-wei Fan)
* Fix the build with the lastest GTK+ from git master,
  to cope with the slightly-changed GTK+ API caused by this commit:
  https://git.gnome.org/browse/gtk+/commit/?id=88623b98a7ca0afca08ac21bc3aa662c6ed3ab7f
  Bug #695305 (Cosimo Cecchi, mussadek)
* Preserve our generated API/ABI after GTK+ API-compatible changes.
  (Kjell Ahlstedt)
* Gtk::ScrolledWindow: Do not use a deprecated function.
  (Murray Cumming)
* Gtk::IconInfo: Do not use deprecated copy/free functions.
  (Murray Cumming)
* gen_scripts: Get information from gdk-pixbuf.
  (Kjell Ahlstedt)

Documentation:
* Update generated documentation.
  (Kjell Ahlstedt)
* Small correction to TreeModel::set_value_impl().
  (Murray Cumming)
* Fix many warnings from Doxygen.
  (Kjell Ahlstedt)      


3.8.0 (stable):

Changes since 3.7.12:

Gtk:
* AccelLabel: Add set_accel().
  (Murray Cumming)
* ActionGroup: Add get/set_accel_group()
  and the accel-group property.
  (Murray Cumming)
* Entry: Add the populate_all property.
  (Murray Cumming)
* Image: Add the resource property.
  (Murray Cumming)
* IconInfo: Add load_icon_async(),
  load_symbolic_async(), load_symbolic_for_context().
  (Murray Cumming)
* IconView:
  - Add get/set_activate_on_single_click().
  and the activate-on-single-click property.
  - Add get_cell_rect().
  (Murray Cumming)  
* LevelBar: Add get/set_inverted().
  (Murray Cumming)
* MenuShell: Add bind_model().
  (Murray Cumming)
* Settings: Add the  gtk-recent-files-enabled
  and gtk-primary-button-warps-slider
  properties.
  (Murray Cumming)
* TextView: Add the populate_all property.
  (Murray Cumming)
* TreeView: Add get/set_activate_on_single_click()
  and the activate-on-single-click property.
  (Murray Cumming
* Widget: Add is_visible(), register_window() and
  unregister_window().
  (Murray Cumming)
* Window: Add set_titlebar().
  (Murray Cumming)

Gdk:
* Window: Add get/set_fullscreen_mode().
  (Murray Cumming)

Build:
* Fix and Update the Visual Studio Solution Files
  for MSVC.Net 2005, 2008 and 2010.
  (Chun-wei Fan)



3.7.12 (unstable):

Gtk:
* Modify the deletion of widgets.
  (Kjell Ahlstedt) Bug #605728 (Murray Cumming) and Bug #315874 (Philip Langdale)

Build:
* Fix the build with the lastest GTK+ from git master,
  to cope with the slightly-changed GTK+ API caused by this commit:
  https://git.gnome.org/browse/gtk+/commit/?id=88623b98a7ca0afca08ac21bc3aa662c6ed3ab7f
  Bug #695305 (Cosimo Cecchi, mussadek)
* Preserve our generated API/ABI after GTK+ API-compatible changes.
  (Kjell Ahlstedt)

Documentation:
* Update generated documentation.
  (Kjell Ahlstedt)


3.7.10 (unstable):

Gdk:

* PixbufAnimation: Fix refcounting on get_iter().
  (Andrew Potter) Bug #688686
* Rectangle: Add Gdk::join() and Gdk::intersect() nonmember functions.
  (Kjell Ahlstedt) Bug #452130 (Jonathon Jongsma)

Gtk:
* Bin, Container::remove(): Restore the floating ref of a managed widget.
  (Kjell Ahlstedt) Bug #685739 (Jonas Platte)
* Builder:
  - Add const versions of get_object() and get_widget[_derived]().
  (Kjell Ahlstedt) Bug #666823 (Hubert Figuière)
  - Add get_objects().
  (Hubert Figuière) Bug #666823
* ScrolledWindow: Add remove_with_viewport().
  (Kjell Ahlstedt) Bug #685739 (Jonas Platte)
* Widget: Add get/set_opacity(),
  set_opacity() and the opacity property.
  (Murray Cumming)
* Window: Deprecate get_opacity(),
  set_opacity() and the opacity property.
  (Murray Cumming)

Documentation:
* Small correction to TreeModel::set_value_impl().
  (Murray Cumming)
* Fix many warnings from Doxygen.
  (Kjell Ahlstedt)	

Build:
* Gtk::ScrolledWindow: Do not use a deprecated function.
  (Murray Cumming)
* Gtk::IconInfo: Do not use deprecated copy/free functions.
  (Murray Cumming)
* gen_scripts: Get information from gdk-pixbuf.
  (Kjell Ahlstedt)


Changes in 3.6 compared to 3.4:

Gtk:
* Application:
 - Added get_active_window() and get_window_by_id().
   (Murray Cumming)
* ApplicationWindow: Add get_id().
  (Murray Cumming)
* Builder: Add create_from_resource() and add_from_resource().
  (Kalev Lember) Bug #674545
* Button: Addedset/get_always_show_image() and the property.
* CellRendererText: Added the placeholder_text property.
  (Murray Cumming)
* ComboBox: Add set_active_id(), deprecating get_active_id(string).
  (Murray Cumming) Bug #685801 (Phil Wolff)
* Container: Add forall(), propagate_draw(),
  get_focus_child() and get_path_for_child().
  (Murray Cumming)
* Entry:
  - Add input purpose and input hints methods.
    (Murray Cumming)
  - Undeprecate the activate signal.
    (Murray Cumming) Bug #655500 (Kjell Ahlstedt)
* IconView: Add get_item_row() and get_item_column()
  and reorderable, tooltip-column and item-padding properties.
  (Murray Cumming)
* Added the LevelBar widget.
  (Murray Cumming)
* Added MenuButton.
  (Murray Cumming)
* PrintJob: Added get/set_page_ranges().
  (Murray Cumming)
* Added SearchEntry.
  (Murray Cumming)
* Settings: Added the enable_primary_paste property.
  (Murray Cumming)
* StyleContext:
  - Add render_icon() and render_insertion_cursor() and deprecate some 
    functions.
    (Kjell Ahlstedt) Bug #675632
  - Add get_style_property().
    (Mark Vender) Bug #674746
* TargetList: Add some add_*_targets() methods.
  (Murray Cumming)
* TextView: Added input purpose and input hints methods.
  (Murray Cumming)
* UIManager: Add add_ui_from_resource().
  (Kalev Lember) Bug #674545
* Widget: Add has_visible_focus() and insert_action_group().
  (Murray Cumming)
* WidgetPath: Added to_string(), iter_get_siblings() and 
  iter_list_regions().
  (Murray Cumming)
* Window: Add set_startup_id(), is_active(), 
  has_toplevel_focus(), set_default_geometry(), 
  resize_to_geometry(), has_group().
  Add the focus-visible and attached-to properties.
  (Murray Cumming)
* WindowGroup: Add list_windows() and get_current_grab().
  (Murray Cumming)

Gdk:
* Pixbuf: Added  const version of save() and friends
  (Mark Vender) Bug #678886.
* Screen: Added get_monitor_workarea().
  (Murray Cumming)
	

3.6.0 (stable):

Gtk:
* ComboBox: Add set_active_id(), deprecating get_active_id(string).
  (Murray Cumming) Bug #685801 (Phil Wolff)
* TargetList: Add some add_*_targets() methods.
  (Murray Cumming)
* WindowGroup: Add list_windows() and get_current_grab().
  (Murray Cumming)

3.5.13 (unstable):

Gtk:
* ApplicationWindow: Add get_id().
* Container: Add forall(), propagate_draw(),
  get_focus_child() and get_path_for_child().
* IconView: Add get_item_row() and get_item_column()
  and reorderable, tooltip-column and item-padding properties.
* LevelBar: Added properties and signal.
* PrintJob: Added get/set_page_ranges().
* Settings: Added the enable_primary_paste property.
* Widget: Add has_visible_focus().
* Window: Add set_startup_id(), is_active(), 
  has_toplevel_focus(), set_default_geometry(), 
  resize_to_geometry(), has_group().
  Add the focus-visible and attached-to properties.
  (Murray Cumming)

Build:
* Use std::time_t instead of ::time_t.
* Use std::size_t and std::ptrdiff_t.
  (Kjell Ahlstedt)

3.5.12 (unstable):

Gtk:
* Added the LevelBar widget.
  (Murray Cumming)
* Application:
  - Added get_active_window().
    (Murray Cumming)
  - Don't call add_window() before the application is registered.
    (Kjell Ahlstedt) Bug #681323 (Gregory Martin)
* CellRendererText: Added the placeholder_text property.
* Entry: Add input purpose and input hints methods.
* MenuButton: Added get/set_popup(), deprecated get/set_menu().
* Settings: Deprecate the gtk-touchscreen-property.
* TextView: Added input purpose and input hints methods.
* Widget: Added insert_action_group().
  (Murray Cumming)

Documentation:
* Show the get_type() methods in the API documentation.
  (Murray Cumming) Bug #670212 (Mark Vender).

3.5.6 (unstable):

Gtk:
* AppChooserDialog: Fix property name in constructors.
  (Kjell Ahlstedt)
* Application:
  - run(): Do not show the window until activation, fix a crash.
  - Added get_window_by_id().
* Button: Addedset/get_always_show_image() and the property.
* Added Gtk::MenuButton.
* Added Gtk::SearchEntry.
* WidgetPath: Added to_string(), iter_get_siblings() and 
  iter_list_regions().
  (Murray Cumming)
* Fix wrap_init() for Quartz (MacOS).
  (Kjell Ahlstedt) Bug #678883.

Gdk:
* Pixbuf: Added  const version of save() and friends
  (Mark Vender) Bug #678886.
* Screen: Added get_monitor_workarea().

3.5.4 (unstable):

* Application:
  - Document that ID may now be empty.
  - Pass 0 (NULL) rather than "" to GApplication.
* Builder: Add create_from_resource() and add_from_resource().
  (Kalev Lember) Bug #674545
* Entry: Undeprecate the activate signal.
  (Murray Cumming) Bug #655500 (Kjell Ahlstedt)
* StyleContext:
  - Add render_icon() and render_insertion_cursor() and deprecate some 
    functions.
    (Kjell Ahlstedt) Bug #675632
  - Add get_style_property().
    (Mark Vender) Bug #674746
* UIManager: Add add_ui_from_resource().
	(Kalev Lember) Bug #674545
* Widget: Deprecate draw_insertion_cursor().
  (Kjell Ahlstedt) Bug #675632
* Documentation:
  - Application: add_window(): Correct the documentation.
	  (Murray Cumming) Noticed by Mateusz Marzantowicz.
  - Container: Document several rarely used virtual functions
    (Mark Vender) Bug #670206
  - Widget: Document get_style_property_value() and get_style_property().
    (Mark Vender) Bug #673303
* Build: Make the list of gdk targets non-automagic. Otherwise, it is difficult
  e.g. to build a wayland-only gtkmm on a build machine that has gdk with both 
  x11 and wayland targets installed.
  (Alexandre Rostovtsev) Bug #673963
	
3.4.0 (stable):

Gtk:
* CellArea: Add signals.
  (Murray Cumming)
* TreePath: Guarantee that all constructors make gobject_ != 0.
  (Kjell Ahlstedt) Bug #511136 (Tom Jaeger)
* Window: Add begin/move_resize_drag() overloads that take a Device.
  (Murray Cumming)

Build:
* Remove the Maemo Extensions API.
  (Adrian Bunk)

Documentation:
* Gtk::Widget: add documentation for the destructor.
  (Mark Vender) Bug #670275


3.3.20 (unstable):

Gdk:
* Added AppLaunchContext.
* Device: Added list_axes().
  (Murray Cumming)
* Display: Deprecate the set_double_click_[time|distance]() methods.
  (Kjell Ahlstedt)
* RGBA: set_grey(), set_grey_u(): Correct the default alpha values.
  (Murray Cumming) Bug #671573 (Mark Vender)

Gtk:
* Actionable: Ensure virtual functions don't return freed memory.
  (José Alburquerque)
* Button:
  -  Deprecate the activate signal.
    ( Kjell Ahlstedt)
  - Deprecated signal_pressed(), signal_released(), signal_enter() 
    and signal_leave().
    (Murray Cumming)
* CellArea: Added foreach() and some properties. 
* ColorChooser: Added add_palette().
* ComboBox: Added signal_format_entry_text().
* Entry: Deprecate the activate signal.
* FontChooser: Added set_filter().
* MenuItem:
  - Deprecated get/set_right_justified().
  - Added signal_select() and signal_deselect().
* MenuShell: Added Add signal_insert().
* Notebook: Deprecated get_tab_hborder() and get_tab_vborder().
* ScrolledWindow: Added get/set_kinetic_scrolling(),
  get/set_capture_button_press() and the kinetic-scrolling property.
* Scale: Added set/get_has_origin() and property.
* Settings: Added several new properties.
* StyleContext: Added list_classes() and get_parent().
* TreeView: Added get_n_columns().
* Widget:
  - Deprecated get/set_state() and 
  signal_state_changed(), adding signal_state_flags_changed().
  - Added signal_touch_event().
  (Murray Cumming)
* Undeprecate init_gtkmm_internals()
  (Murray Cumming)

Build:
* Fix warnings found by clang++.
  (Murray Cumming)
* TreeView: Work around a HP-UX aCC compiler error.
  (Albert Chin)


3.3.18 (unstable):

Gtk:
* AboutDialog: Added add_credits_section().
* Application: Added get/set_app_menu(), get/set_menubar(),
  add/remove_accelerator(), inhibit(), uninhibit(), is_inhibited(),
  properties and signals.
* Add ApplicationWindow.
* Add ColorChooser and ColorChooserDialog.
* ColorSelection*: Document these as deprecated.
* EntryCompletion: Added compute_prefix().
* FontChooser: Add properties and signals.
* Image: Add set_from_resource().
* Main: Deprecate (most of) this in favor of Gtk::Application.
* StyleContext: Added set_parent() and unset_parent().
* Widget: Add get_modifier_mask().
* Window: Add unset/set/get_attached_to(),
  get/set_hide_titlebar_when_maximized() and property.
  (Murray Cumming)

* gmmproc: _CLASS_GTKOBJECT: Include destructor documentation.
  (José Alburquerque) Bug #668918.

3.3.16 (unstable):

Gtk:
* Add the Actionable interface.
  However, we cannot make it a base class of existing classes because that
  would break ABI. We can use it for new classes, or use it after a future
  ABI break.
  (José Alburquerque) Bug #637445.
* Application:
  - Constructor: Receive argc and argv params by reference.
  - Initialize gtkmm early enough for successful construction.
  (José Alburquerque) Bug #637445.
  - Avoid the need to use Gtk::Main.
  - Make the create() methods static.
  (Murray Cumming)
* Border: Add reference documentation.
  (Murray Cumming) Bug #669907 (Mark)
* ColorButton: set_color(), set_alpha(), constructor: Deprecate
  these, as they are deprecated in the C API.
  (Murray Cumming)
* EntryBuffer: Correct the EntryBuffer(name) constructor.
  Bug #670784 (Marcus Yass)
* Grid: Add get_child_at(), insert_row(),
  insert_row(), insert_column(), insert_next_to().
  (Mark Vender) Bug #670238
* TextTag: Add RGBA versions of the properties.
  (Murray Cumming)
* Window: set_background(Color): Deprcate this.
  (Murray Cumming)
* Deprecate some properties that use Gdk::Color.
  (Murray Cumming)
* Documentation: Add documentation for signals, based on the C
  documentation.
  (José Alburquerque) Bug #668918.

3.3.14 (unstable):

Gtk:
* AboutDialog: Add unset_license() and set_logo_default().
  (Kjell Ahlstedt) Bug #616769
* Application: Add back Application, though it is not ready yet.
  (Murray Cumming) Bug #637445#c29
* Deprecate some methods using Gdk::Color, to fix the build.
  (Murray Cumming)
* Entry: Deprecate [set|get]_inner_border().
	(José Alburquerque) Bug #669190.
* IconView: Implement IconView::IconView(Gtk::CellArea). 
	(Hub Figuière) Bug #665361
* Main: Deprecate signal_key_snooper().
	(Murray Cumming)
* Settings: Add missing properties.
  (Hub Figuière) Bug #665264
* Widget: Deprecate get_pointer().
  (Murray Cumming)

Build:
* Fix the build for Quartz (MacOS).
  (John Ralls) Bug #662975
* Fix configure.ac that had a broken shell syntax.
  (Hub Figuière) Bug #665267
* Fix namespacing for Cairo
  (Hub Figuière) Bug #663303

3.3.2. (unstable):

* Avoid some more deprecation warnings with the recent GTK+.
* Deprecate HandleBox.
* Deprecate TearOffMenuItem.
* Deprecate Gtk::Table in favour of Gtk::Grid.
* Add #includes needed with the latest glibmm.
* Build: make check: Use xmllint to check the generated .html documentation.
  (Murray Cumming)

3.2.0 (stable):

Gtk:
* Remove Application, because it is still not ready.
  See bug #637445#c29
* Assistant: Deprecate get/set_page_header_image() and get/set_page_side_image().
* TreeView: Added unset_row_separator_func().
	
3.1.90.1 (unstable):

Gdk:
* Device: Added get_n_keys() and list_slave_devices().
* Pixbuf: Added properties.
* Window: Added get_drag_protocol().
  (Murray Cumming)
Documentation:
* Avoid invalid HTML in link titles (hopefully).
  (José Alburquerque) Bug #650544 (Hubert Figuiere)
* Remove collaboration diagrams.
  (Murray Cumming)
    
3.1.90 (unstable):

Gtk:
* FontChooser is now an interface, like AppChooser and
* FontChooserDialog: Derive from FontChooser, removing some methods.
* FontChooserWidget: A new widget derived from FontChooser.
* FontButton: This should now derive from FontChooser but 
	we cannot do that without breaking ABI because FontButton was in gktmm 3.0.
  (Murray Cumming)
* TreeView: Make append_column_numeric_editable() work for [unsigned] short.
  (Kjell Ahlstedt) Bug #655416 (Morpheus)
* Widget::get_allocation(): Add the newer documentation from the C docs.
  (Murray Cumming)

3.1.18 (unstable):

Gtk:
* Assistant: Added remove_page().
  (Murray Cumming)
* Dialog::get_content_area(): Avoid infinite loop.
  (Kjell Ahlstedt)
* Added FontChooser and FontChooserDialog, deprecating old widgets.
  (Murray Cumming)
* PrintUnixDialog::get_selected_printer(): ref-counting correction.
  (Kjell Ahlstedt) Bug #657751.
* TreeView: Added unset_drag_dest_row().
 (Murray Cumming) Bug #577986 (Hubert Figuiere, Johannes Schmid)

Build:
* Updated Visual C++ Projects
	(Chun-wei Fan)

3.1.16 (unstable):

* Added Gtk::FontChooser and Gtk::FontChooserDialog, deprecating old widgets.
  (Murray Cumming)
* Updated Visual C++ Projects
	(Chun-wei Fan )

3.1.10 (unstable):

Gtk:
* Adjustment: Added get_minimum_increment().
* ButtonBox: Added get_child_non_homogeneous() and
	set_child_non_homogeneous().
* CellArea: Added get_focus_siblings().
* CssProvider: Added to_string(), 
* Entry: Added get_placeholder_text(), set_placeholder_text(),
	and placeholder-text property.
* Expander: Added set_resize_toplevel(), get_resize_toplevel() 
	and resize-toplevel property.
* PrintJob: Added set/get_pages(), set/get_page_set(), 
	set/get_num_copies(), set/get_scale(), set/get_n_up(), set/get_n_up_layout(),
	set/get_rotate(), set/get_collate(), set/get_reverse().
	(Murray Cumming)
* Tooltip: Add unset_*() methods.
  (Jonathon Jongsma) Bug #541296
* TreeViewColumn: Added get_x_offset().
* Added several other properties to various classes.
  (Murray Cumming)
	
3.1.8 (unstable):

* Gtk:
- ComboBoxText: Constructor: Set entry-text-column and id-column.
  Bug #653579 (Glus Xof)
	
3.1.6 (unstable):

Gtk:
* All H* or V* specialized classes have been deprecated, to 
  match the deprecations in the GTK+ C API. You should now 
  set the orientation instead.
  This includes HBox, VBox, HButtonBox, VButtonBox, HPaned, VPaned, HScale, 
  VScale,  HSeparator, VSeparator, HScrollbar and VScrollbar.
  HBox and VBox are not protected by ifdefs because they are used as base 
  classes for several other widgets, and we can't change that without breaking 
  ABI.
* Dialog: Deprecate get_vbox(), replacing with get_content_area(), 
  to match the C function name.

3.0.1 (stable):

Gtk:
* EntryCompletion: signal_cursor_match_info(): Fix this.
  (Murray Cumming) Noticed by Andrew E. Makeev.
* MessageDialog: Correct the get_message_area() return type.
  (Murray Cumming) Noticed by Kjell Ahlstedt.
* ScrolledWindow: Correct the get_v/hscrollbar() return types.
  (Murray Cumming) Noticed by Andrew E. Makeev.
* Fix the --enable-warnings=fatal build with GTK+ 3.1.x.
  (Murray Cumming)

gtkmm 3.0:

To port to gtkmm-3.0 you should first try to build your application with
gtkmm-2.4 but without using deprecated API. For instance:
http://www.murrayc.com/blog/permalink/2011/01/18/avoiding-use-of-deprecated-api/

The deprecated API generally has documentation suggesting what new API you
should use instead:
http://developer.gnome.org/gtkmm/2.24/deprecated.html

These hints might also be helpful:
http://live.gnome.org/gtkmm/PortingToGtkmm3

Some new/changed API in gtkmm-3.0:

Gtk:
* Adjustment is now used via RefPtr.
* AppChooser, AppChooserButton, AppChooserDialog.
* Box, ButtonBox, IconView, Paned, ProgressBar, ScaleButton, ScrollBar,
  and Separator now derive from Orientable.
* All widgets derive from Buildable.
* Several widgets derive from Scrollable.
* CellArea and CellAreaBox
* ComboBox now derives from CellLayout.
* IconSet is now used via RefPtr.
* StyleContext, StyleProvider, and CssProvider, replacing Style and Rc.
* Grid
* NumerableIcon.
* Switch
* Widget::on_expose_event() is now Widget::on_draw().

Gdk:
* Added DeviceManager.
* Removed Drawable, Pixmap and Bitmap.
* Cursor is now used via RefPtr.
* RGBA replaces Color, though Color still exists because it is used by TextView.
  We hope to deprecated Color completely in gtkmm 3.2.
* Removed Colormap and its general awkardness.

General:
* Use std::vector in several methods instead of the intermediate *Handle types,
  to make the API clearer.
* Change all operator void* to operator const void*, with a BoolExpr typedef
  and extra documentation.
  This avoids an unintentional implicit cast to int, and is generally
  considered good practice in C++. The new C++ standard allows the use of
  the explicit keyword here instead, but that is not yet widespread.
* Many existing classes have many new methods.
* gtkmm-3.0 currently has no deprecated API.
  Not even API that was added and then deprecated during GTK+ 3.0.

See also the list of new API in gtkmm 3.0:
http://developer.gnome.org/gtkmm/unstable/since_3_0.html

3.0.0 (stable):

Gtk:
* Change all operator void* to operator const void*, with a BoolExpr typedef
  and extra documentation.
  This avoids an unintentional implicit cast to int, and is generally
  considered good practice in C++. The new C++ standard allows the use of
  the explicit keyword here instead, but that is not yet widespread.
  (Murray Cumming, Daniel Elstner)
* NumerableIcon: Really add get_background_gicon() const.
  (Murray Cumming, Kjell Ahlstedt)
* StateFlags: Added missing STATE_FLAG_NORMAL enum value.
  (Kalev Lember)

2.99.9 (unstable):

* Avoid a tarball dependency on mm-common.
  (Murray Cumming)

2.99.7 (unstable):

Gtk:
* Removed Application until later because the API was not finished in time.
  (Murray Cumming)

2.99.6 (unstable):

Gtk:
* CssProvider: load_from_data(): Remove the size parameter.
	(Fabien Parent)
* Main: Added a constructor with no argc and argv.
  (Murray Cumming)
* TreeView::add_column_editable(): Make this work for TreeModelFilter models.
  (Luca Wehrstedt) Bug #582981
* Window: Added unset_application.
  (Murray Cumming)

2.99.5 (unstable):

Gtk:
* ButtonBox, Separator, Scale, Scrollbar: Add public constructors.
  (Murray Cumming)
* CellArea, CellRenderer: Added get_request_mode(),
  get_preferred_[width|height_for_width|height|width_for_height] vfuncs.
  (Kjell Ahlstedt) Bug #639073,
* CellView: Derive from Orientable and add set/get_draw_sensitive(),
	set/get_fit_model() and the new properties.
* EntryCompletion: Derive from Buildable and add the cell-area
	property.
* IconView: Added the cell_area property.
* Image: Added the set_fallback property.
* Paned: Constructor: Add an optional orientation parameter.
* Widget: Added should_draw_window() and transform_cairo_context_to_window().
  (Murray Cumming)

2.99.4 (unstable):

Gtk:
* Added AppChooser, AppChooserButton, AppChooserDialog and AppChooserWidget.
* Button: Restore the clicked() method.
	Thanks to Aurimas Černius.
* CellArea: Added constructor that takes a CellArea.
  (Murray Cumming)
* Entry: Added unset_icon().
  (Murray Cumming) Bug #621742 (feuloren)

Documentation:
* ComboBoxText: Add warning about not confusing these.
	Bug #619656 (JimO, Kjell Ahlstedt)

2.99.3 (unstable):

Gdk:
* Display:
  - selection_send_notify(): This now takes a
	Gdk::Window instead of a (now removed) GdkNativeWindow.
	- Removed get_protocol() and add_client_message_filter().
* Screen: Removed send_client_message().
  (Murray Cumming)
* Use std::vector in several methods instead of the intermediate *Handle types,
  to make the API clearer.
  (Krzesimir Nowak)

Gtk:
* Application: Try to make this a replacement for Gtk::Main, though this
 work is not finished yet.
  (Murray Cumming)
* Button: Restore the clicked() method.
  Thanks to Aurimas Černius.
* CellArea: Remove set_style_detail() and get_style_detail().
* CellRenderer: Added get_state().
  (Murray Cumming)
* ComboBoxText: Remove the constructor that takes a model.
* CssProvider:
 - Add a create() method.
 - get_default() and get_named(): fixed the reference counting.
 (Kjell Ahlstedt)
* IconSet: Use this via a RefPtr.
* LisViewText: Rename append_text(), insert_text(), and
	prepend_text() to append(), insert() and prepend() because that is what
	ComboBoxText now uses (because it has other append overloads).
* Added NumerableIcon.
* Range: Added get/set_round_digits() and property.
* TextView: Added get_cursor_locations().
* Widget:
  - Removed client_event signal.
  - Added set_state_flags(), get_state_flags(),
	reset_state_flags(), set_device_enable(), get_device_enabled(), and
	reset_style().
  (Murray Cumming)
  - Added get_request_mode_vfunc(),
	get_preferred_[width|height_for_width|height|width_for_height]_vfunc().
	Bug #639073.
	(Kjell Ahlstedt)
	- Wrap the style-updated signal.
	(Armin Burgmeier)
	- set_window(), set_has_window(), and get_requisition() are now protected.
	(Murray Cumming)
	- set_window(): Increase the ref count of the Gdk::Window because GTK+ does
	not, and will not, though we think we may need to do more work to fix this
	properly.
  (Kjell Ahlstedt) Bug #606903 (Hammered)

2.99.1 (unstable):

Gdk:
* Cursor: Add create() methods, making the constructors protected,
	because this should now be used via RefPtr.
  (Murray Cumming)
* Device:
  - Added get_history().
  - Added grab() overload.
  - Added Added get_position() and get_window_at_position().
  - Removed set_source().
  (Krzesimir Nowak)
  - Added get_window_at_position() with no parameters.
  - Added warp().
  (Murray Cumming)
* Display:
  - Removed Remove get_device_state() and get_window_at_device_position()
  (Krzesimir Nowak)
  - Added has_pending() and notify_startup_complete().
  - Removed pointer_ungrab(),  keyboard_ungrab(), pointer_is_grabbed(),
  device_is_grabbed(), get_pointer(), get_window_at_pointer(), warp_pointer,
  set_pointer_hooks(), unset_pointer_hooks(), set_device_hooks(),
  unset_device_hooks().
  (Murray Cumming)
* DisplayManager.hg: Added open_display().
* DragContext: find_window_for_screen():
  - Use a reference for the protocol parameter, instead of a pointer.
	- Added get_dest_window() and get_protocol().
* Pixbuf: Added set_option() and apply_embedded_orientation().
* Screen: The monitors_changed() signal was wrapping the
	size_changed signal. Fixed.
* Window: Added get_device_cursor().
  (Murray Cumming)

Gtk:
* Adjustment: Fix the reference counting of Adjustment.
  (Kjell Ahlstedt)
* MenuItem: Added get/set_reserve_indicator().
* MenuShell: Added get_selected_item() and get_parent_shell().
* Range: Remove get/set_update_policy(), to fix the build.
* StyleContext: Added get/set_path() and get_screen().
* TreeModel::iterator::operator--(): Use gtk_tree_model_iter_previous().
* TreeView: Added is_blank_at_pos().
* Widget: Removed style_attach().
* Window: Removed set_frame_event(), get_frame_event(),
	set_frame_dimensions(), get_frame_dimensions() and the frame_event signal.
  (Murray Cumming)

2.91.7 (unstable):

Gtk:
* Fix the build with latest glibmm after gmmproc m4 changes.
* Application: Added a protected constructor so oeople can derive from this.
	Bug #637445 (Yannick Guesnet)
* Added CellArea, CellAreaBox, and CellAreaContext.
* CellLayout: Added get_area().
* CellRenderer: Added is_activatable() and get_aligned_area().
* IconInfo:
  - Renamed load_icon_symbolic() to load_symbolic()
  - Added load_icon_symbolic(StyleContext, bool&).
* Switch: Fix the type registration to avoid breaking Widget's type
  registration completely, which probably broke everything.
* TreeViewColumn: Added get_button().
* Widget:
  - Removed reset_shapes() and get_default_visual().
  - Added unset_color/font() methods.
  - Removed render_icon(), adding render_icon_pixbuf().
* WidgetPath: Renamed get_widget_type() to get_object_type() and
	renamed iter_get/set_widget_type() renamed to iter_get/set_object_type().
* Window: Added get/set_application().
  (Murray Cumming)

Gdk:
* Cursor should now be used via RefPtr.
* Display: Removed warp_device().
* Pixbuf: Derive from Gio::Icon.
  (Murray Cumming)

2.91.6 (unstable):

Gtk:
* Added the StyleContext, StyleProvider, and CssProvider classes,
  removing the Style and RC classes.
* Added Gdk::Cairo::set_source_rgba().
* Widget: Added get_style_context().
* Cellrenderer, Cellrenderertext, Cellview, Colorbutton, TextTag:
  Added RGBA versions of color properties. We expect to remove Gdk::Color
  in future, maybe then renaming all uses of RGBA to Color.
* ColorSelection: Added get/set_current_rgba() and get/set_previous_rgba().
* ComboBoxText:
  - Renamed append_text(), prepend_text() and insert_text() to append(),
  prepend() and insert().
  - Added extra append()/prepend()/insert() overloads that also take an id.
  - Added get/set_id_column(), get/set_active_id() and properties.
* Widget:
  - Removed the style_changed signal because it used GtkStyle, though
  we might bring this back when the GTK+ code is completely ported to
  GtkStyleContext.
  - Added get_path(), removing path().
  - Removed the no_expose_event signal.
* Added WidgetPath.
* Window: get_geometry(): Removed the depth parameter.

Gdk:
* Removed Drawable.
* RGBA: Rename set_rgb_p(double) to set_rgba(dobule) and rename the old
  set_rgb(gushort) to set_rgb_u(gushort). Likewise for other methods.
  This makes it more like GdkRGBA, which uses double instead of the gushort
  that GdkColor used.
* Window:
  - Added set_background(RGBA) and renamed  set_background_pattern() to
  set_background(Pattern).
	- Added set_clip_region() and get_visible_region() and create_cairo_context(),
	which were previously in the (now removed) base Drawable class.

2.91.5.1 (unstable):

Fix the build with GTK+ 2.91.5 by removing some newer GtkComboBox methods.

2.91.5 (unstable):

Gdk:
* Device: get_n_axes() now returns an int instead of a guint.

Gtk:
* ComboBox: Added get/set_id_column(), get/set_active_id() and
	properties.
* Scrollable, ScrolledWindow: Fix Adjustment reference counting.
* Added Switch widget.
* Removed Ruler, with no replacement in gtkmm itself, because it
  was not used generally enough.
  (Murray Cumming)

2.91.4 (unstable):

Gtk:
* Dialog: get_vbox(): Return a Box instead of a VBox.
* Added Grid container.
  (Murray Cumming)
* Style: Fixed the clone_vfunc() implementation's reference-counting.
  (José Alburquerque)
* Widget: Removed the deprecated size-request signal.
  (Murray Cumming)

Build:
* Fix the refcount-debug-warnings build.
  (Krzesimir Nowak)
* Windows Installer:
  - Make sure libintl-8.dll gets cleaned up correctly on uninstall.
  - Add the lib\cairomm-1.0 directory to the installed files.
  (Armin Burgmeier)

2.91.3 (unstable):

Gtk:
* Assistant: Added next_page() and previous_page().
* Box: Added a public constructor.
* RecentInfo: Added create_app_info().
* Scrollable: Added get/set_h/vscroll_policy().
* Widget: Added in_destruction().
  (Murray Cumming)
* Style: Correct the reference counting when deriving.
  (José Alburquerque)

2.91.2 (unstable):

Gdk:
* Added RGBA class.
* Display: Added set/unset_device_hooks().
* IconInfo: load_icon_symbolic(): Change the parameters from
	Color to RGBA.

Gtk:
* AboutDialog: Add activate_link signal.
* Application: Several methods removed.
* Entry:
  - Removed get_text_window() and get_icon_window().
  - Added get_text_area() and get_icon_area().
* CellView: Added set_background_rgba().
	* tools/m4/convert_gdk.m4: Added necessary conversion.
* ColorButton: Added a constructor taking a Gdk::RGBA, and
	get/set_rgba().
* ComboBoxText: Add remove_all(), replacing clear_items().
* LinkButton: Add activate_link signal.
* RecentInfo: Add get_gicon().
* Added Scrollable interface.
* IconView, Layout, TextView, ToolPallete, TreeView, ViewPort:
  Derive from Scrollable, removing their get/set/unset_h/vadjustment() methods
  and set_scroll_adjustments signals, because they are now in the base Scrollable.
* Widget:
  - Added queue_draw_region(), set/get_hexpand(),
	set/get_hexpand_set(), set/get_vexpand(), set/get_vexpand_set(),
	queue_compute_expand(), compute_expand(), shape_combine_region(),
	input_shape_combine_region()
  - Removed hide_all().

2.91.1.1 (unstable):

* Fix the build with GTK+ 2.91.1.
  (Murray Cumming) Bug #632694 (David Ronis)
* ComboBoxText: Add clear_items() and set_active_text().

2.91.1 (unstable):

* Remove ComboBoxEntry and ComboBoxEntryText.
* ComboBox:
  - Add a has_entry bool to the constructors, replacing use of GtkComboBoxEntry.
  - Added set_entry_text_column(), get_entry() and get_entry_text(),
  - Added set_popup_fixed_width()
* ComboBoxText: Re-implemented with GtkComboBoxText.
  As a bonus this means that insert_text() will now work, and we can now
  define this widget and its data items in Glade.
* Main: Remove signal_run() and signal_quit().
* RadioButton: Added join_group().
* StatusBar: Remove get/set_has_resize_grip().
* Window: Added get/set_has_resize_grip(), get_resize_grip_is_visible(), get_resize_grip_area().
* Remove WrapBox.

2.91.0 (unstable):

Gdk:
* Drawable: Removed get_size(), get_depth(), set_colormap(),
  get_colormap(), get_visual(), get_screen() and get_display().
* Window:
  - Added get_visual(), get_screen(), get_display(),
  set_backround_pattern(), get_offscreen_surface(), get_width(), get_height().
  - Remove redirect_to_drawable(), remove_redirection, clear(),
  clear_area_a().
  (Murray Cumming)

Gtk:
* Adjustment, FileFilter and RecentFilter must now be used via RefPtr.
* Removed SizeRequest and CellSizeRequest, putting the methods in Widget and
  CellRenderer instead.
* Widget::on_expose_event() (the expose_event signal) is now on_draw(),
  which takes a pre-clipped Cairo::Context.
  (Murray Cumming)

Build:
* Adapted to the latest GTK+ 3, which has no GtkObject.
  (Murray Cumming)
* Added support for MSVC 2010 and 64 bit.
  (Armin Burgmeier)

2.90.7 (unstable):

Gdk:
* Bitmap: Remove the constructors. This whole class may be removed soon,
* Color: Remove rgb_find_color().
* Cursor: Added get_cursor_type().
* Device:
  - Added get_key(), get_axis_use(), get_n_axes(),
	get_axis_value(), get_display(), get_associated_device(), get_device_type(),
	grab(), ungrab().
  - get_key(): Make this const.
* Display: Added device_is_grabbed(), get_device_state(),
	get_window_at_device_position(), warp_device(), set_device_hooks(),
	get_device_manager()
* Added DeviceManager.
* Drawable: Removed draw_*() methods. We should use cairo now instead.
* Pixbuf:
  - Added constructor (and create) that takes a Cairo::Surface.
  - Removed constructors and create*() methods that took a Gdk::Image.
* Pixmap: Remove some constructors. This whole class may be removed soon.
* Removed RgbCmap.
* Window: Added set_device_cursor(), get_device_position(),
	get_device_events(), set_device_events(), get_support_multidevice(),
	set_support_multidevice(), get_composited(), is_input_only(), is_shaped(),
  has_native(), get_modal_hint(), get_background_pattern(),
  coords_to_parent(), coords_from_parent(),
  get_effective_parent(), get_effective_toplevel(), create_similar_surface(),
  get_accept_focus(), get_focus_on_map().
  (Murray Cumming)
* Gdk::Cairo: set_source_pixmap(): Added default parameter values
  for pixmap_x and pixmap_y.

Gtk:
* AboutDialog: Added get/set_license_type().
* Added Application, wrapping GtkApplication.
* Removed AnchorType enum.
* CellView: Added get_desired_width_of_row() and
  get_desired_height_for_width_of_row().
* Dialog:
  - Remove get/set_has_separator() and property.
  - Constructors: Remove use_separator parameters.
* Expander: Added get/set_label_fill() and property.
* FileChooserButton: Remove the constructor that lets us set
  the backend.
* IconInfo: Added load_icon_symbolic().
* IconView: Rename get/set_orientation() (and property) to
  get/set_item_orientation().
* Image: Removed get_image() and set(Gdk::Image).
* Removed Item, replaced by use of MenuItem.
* MenuItem: Added unset_submenu().
* MenuShell: Removed items() and the MenuHelper namespace.
* MessageDialog: Removed the buttons property.
* Notebook:
  - Added get_tab_hborder() and get_tab_vborder().
  - Removed Notebook::pages().
* PaperSize: Added get_paper_sizes().
* ProgressBar:
  - Added get/set_inverted() and get/set_show_text().
  - Remove get/set_orientation(), deriving from Orientable instead.
* PrintOperation: Added run_page_setup_dialog() overloads
  with no PageSetup parameter.
* PrintUnixDialog: Added get_manual_capabilities().
* RadioAction: Added join_group().
* RecentManager: Removed get/set_limit() and the property.
  RecentChooser still has these.
* Added SizeRequest.
* StatusBar: Rename remove_all() to remove_all_messages().
* StatusIcon:  Removed get/set_blinking().
* Style:
  - Removed get*_gc() and paint_polygon().
  - Added copy().
* Table:
  - Removed children(). This used API in GTK+ that has been removed.
  - Added get_size().
* Viewport: Added get_view_window().
* Widget:
  -  Added device_is_shadowed(), set_device_events(),
  add_device_events(), set/get_support_multidevice(), get_device_event().
  - Added send_focus_change().
  - Added const version of get_accessible().
* Added WrapBox.
  (Murray Cumming)

General:
* Windows build fixes.
  (Armin Burgmeier)
* API reference documentation improvements.
  (Murray Cumming)

2.90.5 (unstable):

Gdk:
* Remove Gdk::Region, using Cairo::Region instead.
  This requires the latest cairomm.
* DragContext: Added get_source_window() and get_selected_action().
  (Murray Cumming)

2.90.4 (unstable):

Gtk:
* Button: Added get_event_window().
* Table: Added get_size().
* StatusBar: Added remove_all().
* TextView:  Added get_hadjustment(), get_vadjustment(),
  im_context_filter_keypress(), and reset_im_context().

2.90.3.1 (unstable):

Build:
* Split atkmm of into a separate tarball, like pangomm.
  This allows gtkmm-2.4 and gtkmm-3.0 to use the same atkmm ABI.
  (Daniel Elstner)
* Build against gtk+ from git master too.
  (Chris Kühl)

Gtk:
* StatusBar: Added remove_all()
* TextView: Added get_hadjustment(), get_vadjustment(),
  im_context_filter_keypress(), and reset_im_context().
  (Murray Cumming)

2.90.3 (unstable):

Gtk:
* Assistant: Added commit().
* Calednar: select_month, mark_day(), unmark_day(): Remove the bool return value.
* ComboBox::popup(): Added optional device parameter.
* Entry: Added im_context_filter_keypress() and reset_im_context().
* IconTheme: Add back get_for_screen().
* Menu: popup(): Add optional device parameter.

2.90.2 (unstable):

Gdk:
* Display: Remove list_devices() and get_core_pointer() because
  they are now deprecated in GTK+.
* DragContext: Rename get_targets() to list_targets().
  Remove accessors for some (now hidden) struct fields.
* Image:
  - Rename get_bpp() to get_bytes_per_pixel().
  - Rename get_bpl() to get_bytes_per_line().
  - Added get_depth().
  (Murray Cumming)

Gtk:
* Box: Remove the children() list because it used a struct field and struct type
  that are now hidden.
* ProgressBar: Remove the unnused ProgressBarStyle enum.
  (Murray Cumming)

2.90.0 (unstable):

* Renamed ABI from gtkmm-2.4 to gtkmm-3.0.
  This requires applications to change their pkg-config check to gtkmm-3.0
  when they wish to use gtkmm-3.0 instead of gtkmm 2.x.
* Use gtk+ 3.0 instead of gtk+ 2.0.
* Removed deprecated API.
* Remove support for these glibmm build options via ifdefs:
  --enable-api-exceptions
  --enable-api-properties
  --enable-api-default-signal-handlers
  (All this gtkmm API is now always present.)
* Added Border and used it in Entry and Range.
  (Krzesimir Nowak)
* FileChooser:
  Use std::string for filenames, instead of ustring, fixing bug #142138.
* Action, ActionGroup, ListStore, SizeGroup, TreeStore, Widget:
  Inherit and Implement Buildable.
* Button, EntryCompletion, MenuItem, RecentChooserMenu, ToolButton, ToolItem,
  IconView: Inherit and implement Activatable.
  TreeViewCOlumn,
* Box, ButtonBox, Paned, Ruler, ScaleButton, ScrollBar, Separator, SpinButton:
  Inherit and implement Orientable.
* ComboBox: Inherit and implement CellEditable.
* EntryCompletion, IconView, TreeViewColumn: Inherit and implement CellLAyout.
* Add default signal handlers for several signals.

2.20.3 (stable):

* Documentation: Added main page text at index.html.
  (David King, Murray Cumming)

2.20.2 (stable):

* Documentation: Strip out the gobject-introspection annotations, and use
  other improvements made to docextract_to_xml.py
  (José Alburquerque)

2.20.1 (stable):

Gtk:
* RecentAction: Fix the constructor that takes a RecentManager.
  Bug #612900 (Morten Skaaning)
* TreeRowReference::get_model(): Correct the reference counting.
  Bug #611814 (Kamil Renczewski)
  (Murray Cumming)

Documentation:
* Builder: Complete the exceptions thrown documentation.
  Bug #548022 (Alexander Shaduri)
* Remove gobject-introspection annoations.
* Correct some newin/since doyxgen tags.
  (Murray Cumming)

Build:
* Updates for the Windows installer.
  (Armin Burgmeier)

2.20.0 (stable):

New API in gtkmm 2.20:

Gtk:
* Added CellRendererSpin, Spinner, OffscreenWindow, ToolPalette, ToolItemGroup.
* Action: Added get/set_always_show_image() and property.
* Dialog: Added get_widget_for_response().
* Entry:
  - Allow use of a shared EntryBuffer.
  - Added get_text_window() and get_icon_window().
* FontSelection:
  - Added get_family() and get_face(), get_family_list(),
  get_face_list().
* Paned: Added get_handle_window()
* PrintContext: Added get_hard_margins().
* Printer: get_hard_margins().
* Range: Added get/set_slider_size_fixed(),
  get/set_min_slider_size(), get_slider_range(), get_range_rect().
* StatusBar: Added get_message_area().
* StatusIcon: Added set_name().
* ToolItem: Added get_ellipsize_mode(), get_text_alignment(),
  get_text_orientation() and get_text_size_group().
* ToolItemGroup: Added get_label_widget().
* ToolPalette: Make  get_expand() and get_icon_size() const.
* ToolShell: Added  get_text_orientation(), get_text_alignment(),
  get_ellipsize_mode(), get_text_size_group().
* ToolTip: Added set_icon(Gio::Icon).
* Viewport: Added get_bin_window().
* Widget:
  - Added set/get_realized(), set/get_mapped() and style_attach().
  - Added has_rc_style(), deprecating rc_style().
* Window:
  - Added get_window_type(), deprecating get_is_toplevel() and get_is_popup().
  Removed get_is_dialog() because it never had any implmentation anyway.
  - Added unset_transient_for().
  - Added get_icon_name() and icon_name property.
  - Added get/set_mnemonics_visible() and property.
  - Added accept-focus, and focus-on-map properties.
  (Murray Cumming)

 Gdk:
* Screen: Added get_primary_monitor().
* Window:
* PixbufAnimationIter: Make the methods public.
* Window: Added flush(), get/set_offscreen_embedder() and
  get_offscreen_pixmap().


Since 2.19.7 (unstable):

* ToolPalette
  - Derive from ToolShell.
  - Added a const version of get_drop_item().
  - Added properties.
* ToolItemGroup: Added properties.
* OffscreenWindow:
  - Added const versions of get_pixbuf() and
    get_pixmap()
  - Added properties.
* Range: Make get_slider_range() const.
  (Murray Cumming, Jonathan Jongsma)
* Demos: Don't use deprecated API.
  (Murray Cumming)


2.19.7 (unstable):

Gdk:
* Screen: Added get_primary_monitor().
* Window: Added flush().

Gtk:
* StatusBar: Added get_message_area().
* Printer: get_hard_margins().
* ToolItem: Added get_ellipsize_mode(), get_text_alignment(),
  get_text_orientation() and get_text_size_group().
* ToolItemGroup: Added get_label_widget().
* ToolPalette: Make  get_expand() and get_icon_size() const.
* ToolShell: Added  get_text_orientation(), get_text_alignment(),
  get_ellipsize_mode(), get_text_size_group().
* Viewport: Added get_bin_window().
* Window:
  - Added get_window_type(), deprecating get_is_toplevel() and get_is_popup().
  Removed get_is_dialog() because it never had any implmentation anyway.
  - Added unset_transient_for().
  (Murray Cumming)

2.19.6 (unstable):

Gtk:
* Action: Do not deprecate connect_proxy(), disconnect_proxy(),
  block_activate_from() and unblock_activate_from(), because we cannot yet derive
  existing classes from Activatable until we can break ABI.
  Bug #608109 (David Trowbridge)
* EntryBuffer: Actually use GtkEntryBuffer.
* Paned: Added get_handle_window().
* ToolTip: Added set_icon(Gio::Icon).
* Widget:
  - Added set/get_realized(), set/get_mapped() and style_attach().
  - get_requisition(): Reimplemented with the new
  gtk_widget_get_requisition() function.
  - Un-deprecate get_action() because we cannot yet derive
  existing classes from Activatable until we can break ABI.
* Use Glib::wrap() instead of ->gobj() in some places, so we are generally
  more forgiving of null RefPtrs<>.
  (Murray Cumming)

2.19.4 (unstable);

Gtk:
* Action: Added get/set_always_show_image() and property.
* EntryBuffer: Added this class.
* Entry:
  - Use EntryBuffer in a constructor and get/set_buffer() and property.
  - Added get_text_window() and get_icon_window().
* FontSelection.hg:
  - Added get_family() and get_face(), get_family_list(), get_face_list(),
  get_size_list().
  - Reimplemented get_size_entry() and get_preview_entry() using new functions.
* OffscreenWindow: Added this class.

	* gtk/src/offscreenwindow.[hg|ccg]: Added this, wrapping
	GtkOffscreenWindow.
	* gtk/gtkmm.h: Include offscreenwindow.h.
	* gtk/src/window.hg: Added get/set_mnemonics_visible().
	Added mnemonics, accept-focus, and focus-on-map properties.
* PrintContext: Added get_hard_margins().
* Range: Added get/set_slider_size_fixed(), get/set_min_slider_size(),
  get_slider_range(), get_range_rect().
* ToolItememGroup: Added insert() with no position parameter and made
  get_item_position() const.
* ToolPalette: set_drag_source(), add_drag_dest(): Add suitable default parameter values.
* StatusIcon: Added set_name().
* Widget: Added has_rc_style(), deprecating rc_style().
* Window:
  - Added get_icon_name() and icon_name property.
  - Added get/set_mnemonics_visible() and property.
  - Added accept-focus, and focus-on-map properties.

2.19.2 (unstable):

Gdk:
* PixbufAnimationIter: Make the methods public.
  (Benjamin Herr)
* Window: Added get/set_offscreen_embedder() and
  get_offscreen_pixmap(), suggested by Oscar Lazzarino.
  (Murray Cumming, Krzesimir Nowak)

Gtk:
* Added CellRendererSpin and Spinner.
  (Debarshi Ray) Bug #598715
* Added ToolPalette.
  (Murray Cumming)
* Dialog: Added get_widget_for_response().
  (Debarshi Ray) Bug #600411
* Move the Gtk::Border typedef into its own header and add a Glib::Value
  specialization.
  (Krzesimir Nowak) Bug #603926
* Gdk::Window: get_default_root_window(): Correct the reference counting.
  (Murray Cumming) Bug #603852 (Mikko Rasa).
* Windows build fixes.
  (Armin Burgmeier)
* Fix the build when exceptions, vfuncs, etc. are disabled.
  (José Alburquerque)

2.18.2 (stable):

* Reintroduce accidentally removed API methods Gtk::Widget::can_default()
  and Gtk::Widget::can_focus(). (Daniel Elstner; bug #597022 reported by
  Markus Kanet and Hubert Figuiere)
* Include infobar.h from main gtkmm.h header. (José Alburquerque)

2.18.1 (stable):

* RecentManager: Undeprecate get_default().

2.18.0 (stable):

* Clipboard: wait_for_targets): Fix a crash.
  (Daniel Elstner) Bug #586626 (Peter Clifton)
* Window: Added set_icon_name().

Build:
* Require a recent pangomm. Bug #593049 (Frederic Peters).
* Style: Fix a compiler error with the Intel C++ compiler.
  (Murray Cumming) Bug #594171 (Alexander Shaduri).
* Fix recently-introduced problems with disable-deprecated options.
  (Daniel Elstner)

2.17.11 (unstable):

Gdk:
* Window: Added redirect_to_drawable(),
  remove_redirection(), geometry_changed(), get_root_coords(), restack().
Gtk:
* Range: Added get/set_flippable().
* Widget: Added get_is_toplevel(), get_is_drawable(),
  get/set_receives_default(), wrapping the new C functions,
  deprecating the hand-coded non get-prefixed versions.

2.17.9.3 (unstable):

* Change public documentation location to library.gnome.org for the
  pkg-config files as well.  (Daniel Elstner)

2.17.9.2 (unstable):

* Change public documentation location to library.gnome.org.
  (Daniel Elstner)

2.17.9.1 (unstable):

* Reenable the per-class hierarchy graphs in the reference documentation.
  (Daniel Elstner)
* Drop the custom HTML header and footer, and use the shared doxygen.css
  file from mm-common. (Daniel Elstner)

2.17.9 (unstable):

Gtk:
* Added InfoBar widget.
* Builder: get_widget(): Fix a crash when the widget is not found.
  Bug #589267 (Alexander Shaduri)
* CellRenderer: Added get/set_alignment(),  get/set_padding(), get/set_visible(),
  get/set_sensitive().
* CellRendererToggle: Added set/get_activatable().
* FileChooser: Added get/set_create_folders() and property.
* Label: Added get/set_track_visited_links() and property.
* Menu: Added get/set_reserve_toggle_size() and property.
* PrintOperation:
  - Added update_custom_widget signal.
  - Added get/set_embed_page_setup() and get_n_pages_to_print() and properties.
* PrintUnixDialgo: Added set/get_support_selection(),
  set/get_support_selection(), set/get_has_selection(),
  set/get_embed_page_setup(), s/get_embed_page_setup(), and
  et_page_setup_set().
* RecentInfo::get_application_info(): Change the app_exec parameter to a
ustring& instead of a container. This could not have been used before.
* StatusIcon: Added get/set_title() and property.
* Widget: Added some get*() methods, deprecating old methods without the get prefix.
  (Murray Cumming)

* Build: Reworked build system to improve the build and installation and
  interlinking of reference documentation.
  (Daniel Elstner)

2.17.2 (unstable):

Gtk:
* Containter: Avoid unnecessary warnings about an unimplemented remove vfunc
  in custom container widget classes.
  (Daniel Elstner)

Gdk:
* Pixbuf: Added create_for_stream() and create_for_stream_at_scale()
  for reading pixbufs from Gio file streams.
  (Jonathan Jongsma)

2.17.1 (unstable):

Gtk:

* IconView: get_model(): Correct the reference-counting.
	(Murray Cumming) Bug #583037 (Santanu Sinha).
* Added InfoBar
* RecentManager::add_item(): Fixed a crash.
  (Hubert Figuiere) Bug #585521.
* TextBuffer: Actually implement the get_text(bool) const method.
	method. These fix undefined symbol linker errors.
  (Murray Cumming)
* TreeModel::Path::empty(): Correct the check for a NULL underlying GtkTreePath.
  (Hubert Figuiere)
* StatusIcon:get_geometry(): Correct the reference-counting.
  (Johannes Schmid) Bug #575268 (Hubert Figuiere)
* StockID: Actually implement operator bool().
* Fix the build with GTK+ 2.17 (A const change in the
  gtk_recent_info_get_application_info() API).
  (Murray Cumming)
* Fix the build when exceptions are disabled in glibmm.
* Win32 installer fixes.
  (Armin Burgmeier)
* Documentation: Stock API documentation improvements.
  (Johannes Schmid) Bug #506885.

2.16.0 (stable):

Gtk:
* Builder:
  - get_widget_derived(): Reference-counting correction.
  - create_from_file(), add_from_file(), create_from_string(),
    add_from_string(): Add method overloads that take a char* for the object
    ID, to avoid ambiguity with the two other overloads that take ustring or
    StringArrayHandle.
* Entry:
  - *_icon_* methods(): Rearrange parameters to make these consistent and
  so we can have more default parameter values.
  - Added icon_press and icon_release signals.
* FileChooserButton: Added the file_set signal, noticed by Damon Register.
* Stock: Added CAPS_LOCK_WARNING.
* Style: Added get_style_property_value() and templated get_style_property().
* Added Orientable and Activatable interfaces, though they cannot be used yet
  because that would break ABI of existing classes.
  (Murray Cumming)

Gdk:
* PixbufAnimation: create_from_file(): Throw an exception when the GError is
  not null. (Murray Cumming)

Maemo-specific API:
* TextBuffer: get/set_rich_text_format(), set_rich_text_format_all(),
  get/set_can_paste_rich_text(): Remove these Maemo-specific methods which have
  been superseded by the generic TextBuffer serialization functions.
  (Daniel Elstner, Openismus)
* Enums
  - Added Maemo-specific Gtk::HildonSizeType, wrapping HildonSizeType,
  which was inexplicably added to GTK+ in Maemo 5.
  - Likewise added Gtk::Hildon::InputMode, wrapping HildonGtkInputMode.
  (Daniel Elstner, Openismus)

2.15.5 (unstable):
(2.15.4 was skipped)

* Activatable: reset_vfunc() renamed to sync_action_properties_vfunc().
  (Murray Cumming)
* Builder:
  - create_from_file(), add_from_file(), create_from_string(): Add method
  overloads that take char* to avoid ambiguity.
  - get_widget_derived(): Correct reference-counting.
  (Murray Cumming)
* FileChooserButton: Add file_set signal.
  (Murray Cumming)
* Stock: Added CAPS_LOCK_WARNING.
* Added interfaces, but we can't use them yet without breaking ABI:
  Activatable, Orientation.

2.15.3 (unstable):
(2.15.2 was skipped)

Gtk:
* Action: Reimplemented set_tooltip() with the new C
  gtk_action_set_tooltip() function. Added get/set_label(),
  get/set_short_label(), get_tooltip(), get/set_stock_id(),
  get/set_gicon(), get/set_icon_name(), get/set_visible_horizontal(),
  get/set_visible_vertical(), get/set_is_important(), which are new
  accessors for the properties. Added the gicon property.
  Added block_activate() and unblock_activate().
* ImageMenuItem: Added get/set_always_show_image() and property.
* Scale: Added add_mark() and clear_marks().
* TreeView: Added a get_path_at_pos() overload that takes less parameters.
  (Murray Cumming)

Build:
* Allow pangomm to build outside the source tree.
  (Theppitak Karoonboonyanan) Bug #570325
* MSVC++: Disabled compiler warning 4250 also for MSVC2005.
  (Armin Burgmeier) Bug #568083 (Tao Wang).

* Documentation:
  Reference documetnation: Unescape some < and > characters.
  (Daniel Elstner, Murray Cumming) #568485 (Mihai Niculescu)


2.15.1 (unstable):

Gtk:
* CellView: Added get_model() and some new properties.
* Entry: Added unset_invisible_char(), get_invisible_char().
  Added the new progress and icon methods and the properties,
  including the new im-module property.
* ImageMenuItem: Added get/set_use_stock(), set_accel_group().
* MenuItem: Added get/set_label(), get/set_use_underline() and properties.
* PaperSize: Constructor: Remove the default value for the name parameter,
  because there is already a default constructor,
  This caused MSVC++ warning C4520 with Visual Studio 2008.
  (Tao Wang) Bug #568074.
* PrintOperation: Added draw_page_finish(),  set_defer_drawing().
* PrintSettings: Added get_resolution_x(), get_resolution_y(),
  set_resolution_xy(), get/set_printer_lpi().
* SelectionData:  Reimplement get_selection() using the new C getter method.
* StatusIcon: Added button_press_event, button_release_event and scroll_event
  signals. Added get/set_has_tooltip(), get/set_tooltip_text(),
  get/set_tooltip_markup().
* Stock: ORIENTATION_PORTRAIT, ORIENTATION_LANDSCAPE,
  ORIENTATION_REVERSE_LANDSCAPE, and ORIENTATION_REVERSE_PORTRAIT,
  avoiding undefined reference errors when trying to use these.
  (Murray Cumming) Bug #568416 (Tao Wang).
* TextBuffer: Added the paste_done signal.
* TextView: Added im-module property.
* TreeModel::Path::empty(): Also check for a null underlying
  GtkTreePath. Added operator bool() to do the same, just calling !empty().
  (Murray Cumming)

Gdk:
* Drawable::draw_pixbuf(): Add an override without a GC parameter, becauase it
  can be NULL in C.
* Screen: Added get_monitor_width_mm(), get_monitor_height_mm(),
  get_monitor_plug_name().

* Windows build:
  - Disabled MSVC++ compiler warning 4250
  (Armin Burgmeier) Bug #568083 (Tao Wang).
  - Installer: Added Simplified Chinese translation. (Tao Wang)

2.15.0 (unstable):

* CellRendererPixbuf: Added the icon-name and follow-state
  properties, noticed by Mathias Hasselmann.
  (Murray Cumming)
* Printer::enumerate_printers(): Fix a refcounting problem found by Tor Krill.
  (Armin Burgmeier)
* Gdk::Window: Added an invalidate() that takes no rect
  parameter because it can be NULL in C.
  (Murray Cumming)
* Cleaned up gtk includes to use only toplevel headers, as may be required by
  a future GTK+ version.
  (Przemysław Grzegorczyk) Bug #564006
* Container: Use GType instead of GtkType for the  child_type_vfunc() return type
  This should allow soure code to use gtkmm if it declares GTK_DISABLE_DEPRECATED.
  (Murray Cumming) Bug #562893 (Dénes Faluvégi)
* Documentation:
  TreeModel: set_value_impl() documentation: Mention row_changed(),
  not set_row_changed(). Bug #562505 (Bohumir Zamecnik)
* HandleBox: Restore the child-attached property, which was lost at some point
  during 2.14.
* LinkButton: Resore the visited property definition, which was lost at some
  point during 2.14.
  (Murray Cumming)
* CellView, ComboBox, EntryCompletion, IconView: Added unset_model().
  (Alexander Shaduri) Bug #555268

2.14.2 (stable):

* Remove some ;s to avoid warnings.
  Ubuntu Bug: https://bugs.launchpad.net/bugs/275397 (William)
  (Murray Cumming)
* Windows build:
  - Use the new naming convention, similar to boost.
  - installer-creation script improvements.
  (Armin Burgmeier)
* Documentation:
  - EntryCompletion: signal_match_selected: Mention that custom signal handlers
    should connect before the default one.
    (Marko Anastasov)
  - TreeView reference documentation corrections.
    (Murray Cumming) Bug #547787 (John Hobbs)
  - Corrected the index page for DevHelp.
    (Deng Xiyue) Bug #559900

2.14.1 (stable):

* Another Windows build fix.
  (Armin Burgmeier)

2.14.0 (stable):

* Windows build fixes.
  (Armin Burgmeier)

2.13.8 (unstable):

* PrintSettings: Added get/set_number_up_layout(), using the
  new NumberUpLayout enum.
* SelectionData: Changed get_data() to not return a length too,
  and added get_length(), as it was in gtkmm 2.12, to match latest GTK+.
* Widget: Changed the get_allocation() implementation back to
  direct struct field access, to match latest GTK+.
  (Murray Cumming)
* Restored maemo-only (ifdefed) API that had been removed accidentally a while ago.
  (Murray Cumming)
* Added a COPYING.tools file because a small gmmproc utility is GPL.
  Bug #550789 (Michael Casadevall, Deng Xiyue)
* Windows build fixes.
  (Armin Burgmeier)

2.13.7 (unstable):

* ComboBox: Added get/set_button_sensitivity().
* FileChooser: Added set_file(), select_file(), unselect_file(),
  taking a Gio::File. Added get_files(), set_current_folder_file(),
  get_current_folder_file(), get_file(), gtk_file_chooser_get_file()
  get_file(), get_preview_file().
* LinkButton: Added get/set_visited() and the property.
* StatusIcon: Added set() taking a Gio::Icon. Added get_icon()
  and gicon property. Added constructor taking a Gio::Icon.
* Adjustment, StatusIcon: Reimplement some get_*() functions with
  new C functions instead of direct struct access.
  (Murray Cumming)
* Build: Updated the MS Visual Studio 2005 build
  and added a script to create an installer.
  (Armin Burgmeier)

2.13.6 (unstable):

* ComboBoxEntry: Added get_active_text().
* Widget: Added the drag_failed signal, with no default signal handler.\
  (Murray Cumming)
* Build:
  - Correct the C++ compiler check for autogening with libtool 2.2.
  (Rémi Cardona)
  - Calendar: Removed spurious ; characters.
  (Benjamin Herr) Bug #544848.

2.13.5 (unstable):

Gtk:
* Builder: Added versions of create_from_file(),
  create_from_string(), add_from_file(), and add_from_string()
  that take an ID or array of IDs, to allow building of only a part of
  the file, as was already possible with libglade.
* CellRendererCombo: Wrapped the changed signal.
  (Murray Cumming)
* FileChooser: get_preview_widget(): Avoid an endless loop.
  Bug #543288 (Jens Georg)
* Printer: Added is_paused() and is_accepting_jobs().
  (Murray Cumming)

Build:
* pangomm is now in its own tarball.
  (Murray Cumming)
* MSVC_Net2003 project files: Mention new source files
  for builder, scalebutton, tooltip, and volumebutton.
  (Jens Georg) Bug #543294.

2.13.4 (unstable):

Gtk:
* Added the ToolShell interface, though it is not used yet,
  to avoid breaking ABI.
* AccelGroup: Added get_is_locked() and  get_modifier_mask().
* CellRendererPixbuf: Added gicon property.
* Clipboard: Added request_uris(), wait_for_uris(),
  wait_is_uris_available().
* Entry: Added get/set_overwrite_mode().
  Added overwrite_mode and text_length properties.
* Dialog: Reimplemented get_action_area() and
  get_content_area() with the new accessor functions.
* Entry: Reimplemented get_text_length() with the new accessor
  functions.
* HandleBox: Reimplemented is_child_detached() with
* IconInfo: Added IconInfo(icon_theme, pixbuf) constructor
* Image: Added a set() overload that takes a Gio::Icon.
  Added get_gicon() and gicon property.
* Layout: Reimplemented get_bin_window() with the new accessor
  function.
* Menu: Added get_accel_path() and get_monitor() and many
  new properties.
* MenuItem: Added get_accel_path().
  Added right-justified and submenu properties.
* MessageDialog: Added get_image().
* Printer: Added get_default_page_size().
* PageSetup: Added load_from_file() and  load_from_key_file().
  Added create_from_file() and create_from_key_file()
* Plug: Added get_embedded() and get_socket_window().
  Added embedded and socket_window properties.
* PrinterSettings: Added load_from_file() and
  load_from_key_file(). Added create_from_file() and
  create_from_key_file().
* ScaleButton: Added set/get_orientation(),
  get_plus_button(), get_minus_button(), get_popup().
  Added orientation property.
* SelectionData: Reimplemented get_data(), get_data_type(),
  get_format(), and get_display() with the new accessor functions.
* ScaleButton: Added set/get_orientation(),
  get_plus_button(), get_minus_button(), get_popup().
  Added orientation property.
* Settings: Added many properties.
* Socket: Added get_plug_window().
* StatusIcon: Added get_x11_window_id().
* Stock: Added PAGE_SETUP, PRINT_ERROR, PRINT_REPORT,
  PRINT_WARNING.
* ToolItem: Added toolbar_reconfigured().
* Tooltip: Added set_icon_from_icon_name().
* TreeViewColumn: Added get_tree_view().
  Deprecated the existing cell_get_size() and added another,
  because the cell_area parameter has changed to a const in
  gtk_tree_view_column_cell_get_size().
* Widget: Added damage_event signal.
  Added window property.
  Added get_snapshot().
  Reimplemented get_allocation() and get_window() with the new C
  accessor functions instead of direct struct field access.


(Skipped the other version numbers, to be in sync with the GTK+ version number.)

2.13.1:

Gtk:
* Bin: add_label(): Correct the order of parameters to the Label constructor.
  (Peter Wainright) Bug #534685.
* Entry: Added the shadow_type property (added to GTK+ in 2.12).
  (Gennaro Bellizio) Bug #532744.
* RecentInfo: Added a specialization for
  Glib::Value<Glib::RefPtr<Gtk::RecentInfo> > so that
  Glib::RefPtr<Gtk::RecentInfo> can be used with Glib::Value<> and
  Gtk::TreeModelColumn<>.
  (Armin Burgmeier)
* Widget: get_direction():  Add a const version and deprecated the non-const
  version.
  (Andreas Klaedtke) Bug #526742.
* Window: Added unset_back_pixmap().
  (Murray Cumming). Bug #525967 (Jonathon Jongsma).

Gdk:
* PixbufAnimationIter: Added get_pixbuf(), get_delay_time(), advance(),
  on_currently_loading_frame().
  (Murray Cumming). Bug #528037 (Balazs Tirpak).

Pango:
* Attributes: gobj(): Correct the const qualifier. We don't think this will affect
  ABI, but please tell us if it does.
  (Dodji Seketeli)

Documentation:
* Image: Document the constructors.


2.13.0:

Gtk:
* Action, RadioAction, ToggleAction: Added create_with_icon_name() functions,
  allowing IconTheme icon names to be used instead of stock IDs.
  (Christian Hammond) Bug #437041.
* Action: Added the icon_name, visible_overflown, and  action_group properties.
* Calendar: Added set_detail_func(), set_detail_width_chars(),
  set_detail_height_rows(), get_detail_width_chars(), and
  get_detail_height_rows(), and these properties.
* EntryCompletion:
  - Added set_popup_single_match(), deprecating the wrongly-named
    set_popup_single_width().
    Bug #473750 (Kevin Daughtridge).
  - Added a const version of get_text_column() and deprecated the
    non-const version.
* IconInfo, IconTheme, AttrList: Deprecated the non-const
  operator bool()s and added const versions.
* PageSetup:
  - Added copy(), wrapping gtk_page_setup_copy().
  - Added const version of save_to_key_file() and deprecated the non-const one.
* PrintSettings:
  - Added copy(), wrapping gtk_print_settings_copy().
  - Added const version of save_to_key_file() and deprecated the non-const one.
* StockID: Added operator bool().
* TreeView: set_headers_visible(): Added default parameter value.
* Widget:
  - drag_data_get(): Deprecated the current version and added a version
  that takes a const Glib::ustring& for the target.
  - Added the grab_broken_event signal
    (with no_default_handler, to preserve ABI).
    Bug #473465 (Balazs Scheidler).
  - Added the popup_menu signal, now that we know that it is public API.
    (with no_default_handler, to preserve ABI).
    Bug #304103 (Philip Langdale).
  (Murray Cumming)

Gdk:
* Color
  - Added to_string().
  - Deprecated the non-const operator bool()s and added a const version.
* Drawable: dAdded a const override of get_size() and deprecated the non-const
  version.
  Bug #467539 (Bobby DaSilva).

Build:
* Removed the tutorial and examples. They are now in the gtkmm-documentation
  module.

2.12.7:

* UIManager: add_ui_from_string():
  Fix a problem with use of non-ASCII text in UI markup.
  (Murray Cumming)
* TreeModel::Path (TreePath):
  TreePath(In pbegin, In pend) constructor:
  Initialize gobject_ to avoid a crash.
  (Svetlozar Argirov) Bug #50043.

2.12.6:

* Container: Avoid a useless warning about remove() with custom containers.
  (Murray Cumming) Bug #518002 (Jonathon Jongsma).
* Build: Fixed a warning from g++ 4.3.
  (Tim Retout) Bug #524874.
* Documentation: Correct the debian/Ubuntu package name.
  (Deng Xiyue)

2.12.5:

* Documentation:
  - Show stock icon images in the API reference again.
  - Show some pictures of widgets in the API reference.
  (Jonathon Jongsma)

* Build:
  - Fix header inclusion and use using directive for C functions to
    fix build on gcc-4.3 (pre-releases) and Solaris.
    (Deng Xiyue, Tim Mooney, Kjartan Maraas, Bug #498438, #517530)
  - Install and find all needed files for gtkmm-demo, and correct the
    executable name.
    (Chris Wang. Bug #516602, #516600)

2.12.4:

* Gtk::RecentAction: Derive from RecentChooser - this class was
  unusable before and we didn't want to wait for the next
  major GTK+ and gtkmm versions to fix it.
* Build fix with gcc 4.3 pre-releases.
  (Sebastien Bacher)

2.12.3:

* Documentation: Improved the devhelp file to
  - show the full method name, including the class name.
  - really jump to the method's anchor on the page.
  (Jonathon Jongsma) Bug #488261
* Build: Fix the win32 build.
  (Yevgen Muntyan)

2.12.2:

* IconView: set_cursor(): Actually implement this.
  (Murray Cumming)
* LinkButton: Correct the implementation of the
  constructor that takes just the URI. Bug #492200
  (Marko Anastasov)
* Build: Fix the build on MacOS X. Bug #493057.
  (Alberto Ruiz)

2.12.1:

* PrintOperation: Corrected a reference-counting problem that caused
  crashes.

2.12:

Changes since gtkmm 2.10:

Gtk:
* New classes: Builder, RecentAction, Tooltip, VolumeButton.
* Deprecated the Tooltips class.
* AboutDialog: Added set/get_program_name() and deprecated
  set/get_name().
* Action: Action: Added create_menu().
* Calendar: Added a get_date() method using Glib::Date.
* CellLayout: Added get_cells().
* CellRendererProgress: Added pulse, text-xalign, and
  text-yalign properties.
* Entry: Added set_cursor_hadjustment(), get_cursor_hadjustment().
* EntryCompletion: Added set_inline_selection() and
  get_inline_selection(), and Added cursor_on_match signal.
* IconTheme: Added choose_icon(), list_contexts().
* IconView: Added set_tooltip_item(), set_tooltip_cell(),
  get_tooltip_context_path() and get_tooltip_context_iter(),
  convert_widget_to_bin_window_coords()
* LinkButton: Added set_uri_hook() and unset_uri_hook().
* MenuToolButton: Added set_arrow_tooltip_text() and
  set_arrow_tooltip_markup().
* Notebook: Added set/get_group() and deprecated set/get_group_id().
* PageSetup: Added to_file(), to_key_file().
* PaperSize: Added get_paper_sizes(), get_capabilities().
* Printer: Added list_papers().
* PrintSettings: Added to_file(), to_key_file().
* Range: Added set_show_fill_level(), get_show_fill_level(),
  set_restrict_to_fill_level(), get_restrict_to_fill_level(),
  set_fill_level(), get_fill_level().
* RecentAction: Added class.
* ScaleButton: Added class.
* StatusIcon: Added set_screen() and get_screen() and
  popup_menu_at_position().
  Added popup and activate signals.
* Stock IDs: Added DISCARD, ORIENTATION_PORTRAIT,
  ORIENTATION_LANDSCAPE, ORIENTATION_REVERSE_LANDSCAPE,
  ORIENTATION_REVERSE_PORTRAIT, SELECT_ALL
* Style: Added attach() detach().
* TextBuffer: Addded add_mark(), and cursor-position property.
* TextMark: Added constructor and create() method, though these
  are usually created via TextBuffer.
* Toolbar: Added set_icon_size(), unset_icon_size().
* TreeView: Added is_rubber_banding_active(),
  convert_widget_to_tree_coords(),
  convert_tree_to_widget_coords(), convert_widget_to_bin_window_coords(),
  convert_bin_window_to_widget_coords(), convert_tree_to_bin_window_coords(),
  convert_bin_window_to_tree_coords(),
  set_tooltip_row(), set_tooltip_cell(), set_tooltip_column(),
  get_tooltip_column(), get_tooltip_context_path() and
  get_tooltip_context_iter().
* Widget: Added keynav_failed(), error_bell(),
  modify_cursor(), unset_cursor(),
  set_has_tooltip(), get_has_tooltip().
* Window: Added set_opacity(), get_opacity(),
  set_default_icon_name(), set_accept_focus(),
  get_accept_focus(), set_focus_on_map() and get_focus_on_map().

Gdk:
* Display: Added supports_shapes(), supports_input_shapes(),
  supports_composite().
* Pixbuf:
  - Added constructors that do not take dest_x
  and dest_y (which are ignored in this case).
* Screen: Added is_composited(), set_font_options(),
  get_font_options(), set_resolution(), get_resolution(),
  get_active_window().
* Window: Added set_composited(), input_shape_combine_mask(),
  input_shape_combine_region(), set_child_input_shapes(),
  merge_child_input_shapes(), get_type_hint(), set_startup_id(), beep(),
  set_opacity().

Pango:
* Color: Added to_string().
* Context: Added set_base_gravity(), get_base_gravity(),
  get_gravity(), set_gravity_hint(), get_gravity_hint().
* FontDescription: Added set_gravity() and get_gravity().
* FontFace: Added is_synthesized().
* GlyphString: Added get_width().
* Layout: Added is_wrapped(), is_ellipsized() and
  get_unknown_glyphs_count().

Thanks to Marko Anastasov, Murray Cumming, Daniel Elstner,
Jonathon Jongsma, Johannes Schmid, and Kalle Vahlman.

2.12.0:

* RecentAction: Rearrange the constructor parameters, to match the other Action classes.
  Added more default parameters.

2.11.8:

* Gdk::Cairo::set_source_color(), set_source_pixbuf(), set_source_pixmap():
  Deprecated the existing versions of these methods and added overloads that
  take a const RefPtr& instead.
  (Jonathan Jongsma)
* Deprecated Gdk::Cairo::rectangle(), replacing it with add_rectangle_to_path().
  and deprecated Gdk::Cairo::region(), replacing it with add_region_to_path(),
  because these names are clearer.
  (Jonathan Jongsma)
* Documentation: Tutorial: DrawingArea: Corrected a mention of
  PixBuf to Pixbuf. Bug #465961 (Jonathan Jongsma)

2.11.7:

* Some build fixes for some compilers/setups.
 (Daniel Elstner)
* Documentation markup change for future appearance
  in library.gnome.org. (Jonathon Jongsma)

2.11.6:

Gdk:
* Pixbuf:
  - Added constructors that do not take dest_x
  and dest_y (which are ignored in this case).
  - get_formats(): Corrected the reference counting.

Pango:
* Color: Added to_string().
* Context: Added set_base_gravity(), get_base_gravity(),
  get_gravity(), set_gravity_hint(), get_gravity_hint().
* FontDescription: Added set_gravity() and get_gravity().
* FontFace: Added is_synthesized().
* GlyphString: Added get_width().
* Layout: Added is_wrapped(), is_ellipsized() and
  get_unknown_glyphs_count().

Gtk:
* Builder: Removed get_type_from_name().
* IconView:
  - set_tooltip_item(), set_tooltip_cell():
  Use Tooltip only via a RefPtr.
  (Murray Cumming)
  - Added get_tooltip_context_path()
  and get_tooltip_context_iter().
  (Marko Anastasov)
* LinkButton: Added set_uri_hook() and unset_uri_hook().
* PrintJob: Added a const version of get_surface()
* PrintSettings: Corrected the typedef for SlotForeach -
  the ustring&s should be const. I do not believe that anybody could
  have been using this, so I think it is OK to change it.
* Tooltip: Added set_tip_area().
* TreeView:
  - Added convert_widget_to_tree_coords(),
    convert_tree_to_widget_coords(), convert_widget_to_bin_window_coords(),
    convert_bin_window_to_widget_coords(), convert_tree_to_bin_window_coords(),
    convert_bin_window_to_tree_coords(),
    set_tooltip_row(), set_tooltip_cell(), set_tooltip_column(),
    get_tooltip_column().
  (Murray Cumming)
  - Added get_tooltip_context_path() and get_tooltip_context_iter().
  (Marko Anastasov)
* Widget: Added keynav_failed(), error_bell(),
  modify_cursor(), unset_cursor(),
  set_has_tooltip(), get_has_tooltip().
  (Murray Cumming)
* Documentation:
  - Corrected lots of API reference documentation.
  (Murray Cumming, Marko Anastasov, Jonathan Jongsma)
  - Added a Tooltip example. (Marko Anastasov)

2.11.5:

Pango:
* Color: Added to_string().
* Context: Added set_base_gravity(), get_base_gravity(),
  get_gravity(), set_gravity_hint(), get_gravity_hint().
* FontDescription: Added set_gravity() and get_gravity().
* FontFace: Added is_synthesized().
* GlyphString: Added get_width().
* Layout: Added is_wrapped(), is_ellipsized() and
  get_unknown_glyphs_count().


Gdk:
* Screen: Added is_composited(), set_font_options(),
  get_font_options(), set_resolution(), get_resolution(),
  get_active_window().

Gtk:
* IconView:
  Added set_tooltip_item(), set_tooltip_cell(),
  convert_widget_to_bin_window_coords().
* MenuToolButton.hg: Added set_arrow_tooltip_text() and
  set_arrow_tooltip_markup().
* StatusIcon: Added set_screen() and get_screen().
  (Murray Cumming)
* TextBuffer: Addded cursor-position property.
  (Marko Anastasov)
* TreeVIew: Added is_rubber_banding_active()
  (Murray Cumming)

2.11.4:

Gtk:
 * Added Builder, which will eventually replace use of libglade.
 (Murray Cumming)
 * Added Tooltip, which replaces the deprecated Tooltips class.
 (Marko Anastasov)
 * RecentAction: Added constructor and create() method and an example.
 (Murray Cumming)
 * Documentation: Added lots of class overview documentation.
 (Johannes Schimd)

2.11.3:

Gtk:
* Action: Added create_menu().
* CellRendererProgress: Added pulse, text-xalign, and
  text-yalign properties.
  (Murray Cumming)
* DragContext::get_targets(), SelectionData::get_targets():
  Use the correct intermediate return type, to correct memory
  management problems. This technically breaks ABI of these two
  functions, but we believe that it was impossible to use them before,
  so no applications should be broken by this improvement.
  (Murray Cummng, Daniel Elstner) Bug #399403 (Yannick Guesnet)
* EntryCompletion: Added set_inline_selection() and
  get_inline_selection().
  Added cursor_on_match signal, though without a default signal
  handlers, to preserve ABI.
  Added inline-selection property.
* Notebook: Added const versions of get_n_pages() and page_num(),
  deprecating the non-const methods. Bug #442284 (Tomasz Ostrowski).
* Printer: Added list_papers().
* Range: Added set_show_fill_level(), get_show_fill_level(),
  set_restrict_to_fill_level(), get_restrict_to_fill_level(),
  set_fill_level(), get_fill_level().
  Added show-fill-level, restrict-to-fill-level, and
  fill-level properties.
* RecentAction: Added class.
* ScaleButton: Added class.
* VolumeButton: Added class.
* Stock IDs: Added DISCARD, ORIENTATION_PORTRAIT,
  ORIENTATION_LANDSCAPE, ORIENTATION_REVERSE_LANDSCAPE,
  ORIENTATION_REVERSE_PORTRAIT, SELECT_ALL
  (Murray Cumming)

* Build fix when disabling properties.
  (Kalle Vahlman)
* Documentation:
  - Improved gmmproc chapter.
  (Murray Cumming)
  - Improved internationalization chapter.
  (Jonathan Jongsma)

2.11.2:

Gdk:
* Display: Added supports_shapes(), supports_input_shapes(),
  supports_composite().
* Window: Added set_composited(), input_shape_combine_mask(),
  input_shape_combine_region(), set_child_input_shapes(),
  merge_child_input_shapes(), get_type_hint(), set_startup_id(), beep(),
  set_opacity().

Gtk:
* AboutDialog: Added set/get_program_name() and deprecated
  set/get_name().
  (Murray Cumming)
* CellLayout: Added get_cells().
* Entry: Added set_cursor_hadjustment(), get_cursor_hadjustment().
* IconTheme: Added choose_icon(), list_contexts().
* Notebook: Added set/get_group() and deprecated set/get_group_id().
* PageSetup: Added to_file(), to_key_file().
* PaperSize: Added get_paper_sizes().
  get_capabilities().
* PrintSettings: Added to_file(), to_key_file().
  (Murray Cumming)
* TextBuffer: Added add_mark().
* TextMark.ccg: Added constructor and create() method, though these
  are usually created via TextBuffer.
* Toolbar: Added set_icon_size(), unset_icon_size().
* Window:
  - Added set_opacity(), get_opacity().
  - Added transient_for, and opacity properties.
  (Murray Cumming)

Documentation:
* Fixed some wrong mentions of g_free().
  (Jonathon Jongsma)

2.11.1:

Gtk:
* Calendar: Added a get_date() method using Glib::Date.
  (Johannes Schmid) Bug #350584
* StatusIcon:
  - Added popup and activate signals
  (without default signal handlers, to preserve ABI) though we
  still cannot get any answer from the GTK+ maintainers about whether
  these are public API.
  - Added popup_menu_at_position().
  (Murray Cumming)
* Style: Added attach() detach().
  (Jonathan Jongsma) Bug #351336
* Window:
  - Added set_default_icon_name()
    (Johannes Schmid) Bug #364395 (Yuriy Syrota)
  - Added set_accept_focus(), get_accept_focus(),
    set_focus_on_map() and get_focus_on_map().
    (Murray Cumming) Bug #421936

* Documentation:
  - Book: Improvements to allow easier pdf generation.
    (Jonathan Jongsma)
  - Book: More help with headers and linking, also for libglademm.
    (Murray Cumming)
  - Examples: custom/custom_widget/: Now uses cairo instead of the
    GDK drawing functions.
 (Jonathan Jongsma)

2.10.10:

* RadioAction: Correct a reference-counting error in the "changed" signal.
  (Armin Burgmeier, Openismus)
  Bug #350734 (Johnathon Jongsma, "pjdavis" Paul Davis)
* RecentManager: Allow Gtk::RecentManager::Data to be instantiated, for use with
  the full version of add_item(). (Armin Burgmeier, Openismus)
  Bug #388086 (Grant Patterson)
* Menu: Fix memory problems during destruction by handling attached widgets as
  we already handle child widgets. (Johannes Schmid, Openismus)
  Bug #339791 ("pjdavis" Paul Davis, Andrew E. Makeev)
* Correctly ifdef-out initialization of deprecated classes.
  (Johannes Schmid, Openismus)
* Build: Cope with newer m4 versions. (Yselkowitz)
* Documentation:
  FAQ: Emphasize that libglademm is preferred to glademm. (Marko Anastasov)
  Bug #429043.

2.10.9:

* Depend on glibmm 2.10.9, which has some slight performance optimization for
  default signal handlers and vfuncs.
  (Murray Cumming, openismus)
* TreeView: Fix memory leak in get_cursor().
  Bug #417539 (Andrew E. Makeev)
* IconTheme::get_example_icon_name() documentation fix.
  (Jonathon Jongsma)

2.10.8:

* ActionGroup::add(): Avoid a problem on 64-bit systems due to 0/NULL confusion.
  (Daniel Elstner)
* Documentation:
  - Updated the Internationalization chapter. (Marko Anastasov)
  - Added appendix about Visual Studio 2005. (Alan Ott, bug #409102)

2.10.7:

* Main: Cleanup data structures in the destructor, preventing leaks, and allowing
  a second instantiation. (Bug #383340 from Christopher Raine).
* Build: Fix build with SUN Workshop 11
  (Marko Anastasov, Bug #395572 from Tim Mooney)
* Documentation:
  - glade/libglade tutorial section: Clarification.
  (Martin Nordholts, Bug #387708)
  - Added SizeGroup documentation.
  (Murray Cumming)

2.10.6:

* Gdk::Drawable::create_cairo_context(),
  Gtk::PrintContext::get_cairo_context(),
  Gtk::PrintJob::get_surface(): Fix memory leak caused by doing
  an extra reference.
  Bug #362181 from austinf.

2.10.5:

* UIManager: Fix crash when built without exceptions support.
  (Johannes Schmid)
* Style: lookup_icon_set(): Memory-management correction.
  Bug #374094 (patch from Nate Nielsen)
* Build:
  - Windows:  Do not check for gtk+-unix-print-2.0 on as it is not
  always included in GTK installers and/or binary archives (like in Tor's binaries).
  Bug #371882 from Alexis Wilke.
  (Cedric Gustin)

2.10.4:

* Build:
  - Omit the atkmm dependency from the gtkmm pkg-config .pc file
  when atkmm was optionally disabled. (Rémi Cardona)
  Bug #366930 from John N. Laliberte.
  - Added --enable-api-maemo-extensions configure option,
  to optionally provide C++ wrappers for the additional GtkTextBuffer
  functions in the Maemo version of GTK+.
  (Johannes Schmid, Murray Cumming)

* Documentation:
  - Drawable: Add comment paragraph about using cairo.
  (Ralf Stephan)

2.10.3:

* Adjustment: Preventing the value from being ignored.
  Bug #369335 from Daniel Holbach, via Vincent Levesque,
  with help from Paul Davis.
* Build:
  - ListViewText:
  Fix an odd build problem with gcc 3.3.6.
  Bug #352226. (Thomas Zajic)
* Documentation:
  - Explain the optional (at build-time) API for
  reduced resources environments.
  - Correct the links to the Memory Management and libglademm chapters.
  - Drawable::get_image(), Container::remove(), Widget::add_mnemonic_label:
  avoid mentioning a functions that do not exist in gtkmm.
  Bug #358268 from Evgeny Rippi, and  Nickolai Dobrynin.

2.10.2:

*  Added --enable-atk=no option, to disable the build and use
  of the atkmm API, for use in embedded environments.
  (Johannes Schimd, Murray Cuming, Openismus)
* Documentation:
  - Book: Added Plug and Socket chapter to book, with example.
  (Jonathon Jongsma)

2.10.1:

* Button: fix typo in get_image_position()
* Added MSVC support for 2.10

2.10.0:

Changes since 2.8:

gtkmm now depends on cairomm.

* AccelMap: Added lookup_entry() (Paul Davis)
* Button: Added get/set_image_position().
* Added CellRendererAccel (Murray Cumming)
* Added CellRendererSpin (Marko Anastasov)
* CellRendererToggle: Added "indicator-size" property.
* Clipboard: Added request_rich_text(), wait_for_rich_text(),
  and wait_rich_text_is_available().
* Entry:
  - Added get/set_inner_border().
  - Added xalign and truncate-multiline properties.
* FileChooserButton: Added set/get_focus_on_click()
* MessageDialog: Added properties.
* Menu: Add attach_to_widget() overload without a destroy callback.
* Label: Added get/set_line_wrap_mode() and property.
* Added LinkButton.
* Added ListViewText very simple text-based convenience class for TextView.
  (J. Baltasar García Perez-Schofield)
* MenuShell: Added get/set_take_focus() and property.
* MessageDialog: Added set_image() and property.
* Notebook:
  - Added page_reordered, page_removed, and
  page_added signals.
  - Added set_group_id(), get_group_id(),
  get_tab_reorderable(), set_tab_reorderable(),
  get_tab_detachable(), set_tab_detachable().
* Added Printing support, via PrintOperation, PrintContext, PrintJob, PrintSettings,
  Printer, PageSetup. (Marko Anastasov, Murray Cumming)
* Added Recent Files support, via RecentChooser, RecentChooserWidget, RecentChooserMenu,
  RecentChooserDialog, RecentInfo, RecentManager
  (Armin Burgmeier, Marko Anastasov, Jonathon Jongsma)
* RadioAction: Added set_current_value().
* Range: Added get/set_lower_stepper_sensitivity(),
  get/set_upper_stepper_sensitivity() and properties.
* SectionData: Added Added targets_include_uri.
* SizeGroup: Added get_widgets().
* Style:
  - Added overload set_bg_pixmap() that takes const Pixmap.
  (Michael Hofmann)
  - Added Added lookup_color().
* SelectionData: Added targets_include_rich_text().
* SizeGroup: Added get/set_ignore_hidden().
* SpinButton: Added "wrapped" signal, without a default signal handler, to
  preserve ABI. (Murray Cumming)
* ToggleButton: Added constructor that takes a stock item.
* TreeView:
  - Added get/set_rubber_banding(),
  get/set_grid_lines(), get/set_enable_tree_lines(),
  get_search_entry(), set_search_position_func(),
  get_headers_clickable().
  - Added properties for show-expanders, level-indentation,
  rubber-banding, enable-grid-lines, and enable-tree-lines.
  (Murray Cumming)
* Widget:
  - Added composited_changed signal. (Murray Cumming)
  - Added input_shape_combine_mask(). (Marko Anastasov)
  - Added is_composited(), input_shape_combine_mask(),
  unset_input_shape_combine_mask(), and the "composited_changed" signal.
  (Jonathon Jongsma)
  - Added get_action().
  - Made map() public, because custom containers sometimes
    (e.g. GtkNotebook) need to call it on their child widgets,
    though we are not sure when.
* Window: Added get_group(), and get/set_deletable(),
  set_urgency_hint()
  (Murray Cumming)

Pango:
* AttrList: Added operator bool.
* Context: Added get_matrix(), update_from_cairo_context(),
  set_cairo_font_options(), set_cairo_font_options(), get_font_options(),
  set_resolution(), get_resolution().
* Font: Added describe_with_absolute_size(), get_font_map().
* FontDescription: Added set_absolute_size(), get_size_is_absolute().
* Layout: Added get_font_description(), index_to_line_x(),
  create(Cairo::Context), update_from_cairo_context(),
  add_to_cairo_context().
* LayoutLine: Added show_in_cairo_context(), add_to_cairo_context().
  (Murray Cumming)
* Renderer: Added get_matrix().
(Murray Cumming)

Gdk:
* GC: Added set_clip_rectangle() overload that takes const argument.
  (Michael J M Thompson)
* Added static functions for using Cairo, in general.h.
  (Murray Cumming)

Documentation:
* Stylesheet improvements, to improve the appearance. (Jonathon Jongsma)
* Printing Chapter, with example (Marko Anastasov)
* Recent Files chapter, with example (Armin Burgmeier, Jonathon Jongsma)
* "Wrapping C libraries" appendix (Murray Cumming)
* DrawingArea chapter updated for Cairo. (Jonathan Jongsma)
* Added ComboBox chapter and removed Combo section. (Murray Cumming)
* Improved RadioButton example. (Pierre Thierry)
* Added an example that uses events_pending()
  to update the UI (Gareth Foster, Murray Cumming)
* Added IconView example. (R. Douglas Barbieri)

Win32 build: Plug and Socket added. (Cedric Gustin)

Other bug fixes from Paul Davis, Gezim Hoxha.


2.9.10:

Gtk:
* FontButton: Fix the constructor that takes a font_name.
(Armin Burgmeier)
* PrintOperationPreview: Fix some reference-counting issues to
fix a crash. (Marko Anastasov)
* RecentManager: Fix get_items() memory management.

Documentation:
* Recent Files chapter: Started this chapter, with a screenshot.
  (Jonathon Jongsma)

Examples:
* printing/advanced: Various bugfixing, though it might
  still have problems on amd64. Do test. See bug #347857.
  (Marko Anastasov, Murray Cumming)
* recent files: Actually show a dialog, and add _mnemonics to
  menu items.
  (Jonathon Jongsma)

2.9.9:

Gtk:
* PrintOperation: get_print_settings(): Ref the return to avoid a crash.
  (Marko Anastasov)
* RecentManager: Change add_fullI to add_item(), overloading according to the
  parameters. (Jonathon Jongsma)
* SpinButton: Added "wrapped" signal, without a default signal handler, to
  preserve ABI. (Murray Cumming)
* Widget:
  - Correct the new composited_changed signal to avoid breaking ABI.
  (Murray Cumming)
  Bug #348241 from Daniel Holbach.
  - Fixed a typo so that input_shape_combine_mask() is really wrapped.
  (Marko Anastasov)
* Build: Build with the new glibmm --enable-api-default-signal-handlers=no
  option for reduced-resources embedded devices. (Murray Cumming)

Documentation:
* Printing examples: Use the new gdkmm cairo methods instead of the
  C functions. (Marko Anastasov)

2.9.8:

Gtk:
* Printing API mostly finished. (Marko Anastasov)
* TextBuffer: Added register_serialize_tagset(), unregister_serialize_format(),
  unregister_deserialize_format(), set_can_create_tags(), get_can_create_tags(),
  get_serialize_formats(), get_deserialize_formats(). There's more to do.
  (Murray Cumming)
* ToggleButton: Added constructor that takes a stock item.
* Widget: Added is_composited(), input_shape_combine_mask(),
  unset_input_shape_combine_mask(), and the "composited_changed" signal.
  (Jonathon Jongsma)

Documentation:
* Added Printing chapter and printing example. (Marko Anastasov)
* Added "Wrapping C libraries" appendix. (Murray Cumming)
* Style updated to match the new website. (Jonathon Jongsma)

2.9.7:

Gtk:
* Notebook: Added page_reordered, page_removed, and
  page_added signals.
* PrintContext: Renamed the const get_cairo()
  to get_cairo_context(), to match the original.
* PrintOperation: run(): Added a default value.
  (Marko Anastasov)
* SelectionData: Added targets_include_rich_text().
* SizeGroup: Added get/set_ignore_hidden().
* StatusIcon: Added size_changed signal.
  (Murray Cumming)

Documentation:
* Add links to gtkmm_hello and gnomemm_hello programs.
* Fixed the sentence explaining disconnect() in the Timeouts chapter.
* Typo correction in the Clipboard chapter
  (Gezim Hoxha)

2.9.6:

Gtk:
* Label: Added get/set_line_wrap_mode() and property.
* MenuShell: Added get/set_take_focus() and property.
* MessageDialog: Added set_image() and property.
* StatusIcon: Added get_geometry().
* TreeView: Added get/set_rubber_banding(),
  get/set_grid_lines(), get/set_enable_tree_lines().
  Added properties for show-expanders, level-indentation,
  rubber-banding, enable-grid-lines, and enable-tree-lines.
  (Murray Cumming)
* PrintJob: send_job(): No longer throws an exception.
* PrintUnixDialog: Added add_custom_tab() overload that takes a ustring.
* Printer: Added get_job_count(), and enumerate_printers(), and others.
* Printsettings:
  - Put the standard settings in a member class  so they can be
  used as Gtk::PrintSettings::Keys::SOMETHING.
  -  Remove get/set_print_to_file().
* PrintOperation: Added a version of run() without the Window parameter.
* PrintOperationPreview: New class.
  (Most printing stuff: Marko Anastasov)

2.9.5:

Gtk:
* Assistant: Added update_buttons_state().
* Button: Added get/set_image_position().
* Clipboard: Added request_rich_text(), wait_for_rich_text(),
  and wait_rich_text_is_available().
* Entry: Added get/set_inner_border().
* Notebook: Added set_group_id(), get_group_id(),
  get_tab_reorderable(), set_tab_reorderable(),
  get_tab_detachable(), set_tab_detachable().

* PrintContext: Added set_cairo_context().
* Printoperation:
  - run(): Added PrintOperationAction parameter.
  - Removed set_show_dialog(), set_pdf_target(),
    set_track_print_status(), run_async().
  - Added set_export_filename(), set_track_print_status(),
   set_show_progress(), set_allow_async(), set_custom_tab_label().
* Fixed warnings (Elijah Newren, Jonathon Jongsma)

Pango:
* Context: Added get_matrix().
* Font: Added describe_with_absolute_size(), get_font_map().
* FontDescription: Added set_absolute_size(), get_size_is_absolute().
* Layout: Added get_font_description(), index_to_line_x().
* Renderer: Added get_matrix().


2.9.4:

Gtk:
* PrintContext:
  - Added set_track_print_status() and cancel(), paginate signal.
  (Marko Anastasov)
  - get_cairo() renamed to get_cairo_context(),
  - get_fontmap() renamed to get_pango_fontmap(),
  - create_context() renamed to create_pango_context(),
  - create_layout() renamed to create_pango_layout().
  (Murray Cumming)
* PrintJob:
  - Added set/get_track_print_status().
  (Marko Anastasov)

Pango:
* Added CairoFontMap. (Might be removed later)
* Context: Added update_from_cairo_context(),
  set_cairo_font_options(), set_cairo_font_options(), get_font_options(),
  set_resolution(), get_resolution().
* Layout: Added create(Cairo::Context), update_from_cairo_context(),
  add_to_cairo_context().
* LayoutLine: Added show_in_cairo_context(), add_to_cairo_context().
  (Murray Cumming)

2.9.3:

* Fixed regressions from 2.9.1 and 2.8.6:
  - Regenerated with latest glibmm to fix several empty methods.
  - ActionGroup:add(): Fix crash in alternate property get.
  - Gdk::PixbufLoader: Correct the vfunc sequence to avoid the ABI break.
  (Murray Cumming)
* Added Printer, PrintJob, PageSetupUnixDialog, PrintUnixDialog
  (Marko Anastasov)
* Table: Fix crash in Table_Helpers::TableList.erase(). Bug #341962
  (Paul Davis)
* Documentation:
  - Fix stylesheet installation.
  - Fix some links
  (Jonathon Jongsma)

2.9.2:

* Fixed a typo to fix the build when not disabling exceptions.

2.9.1:

Gtk:
* Depends on cairomm.
* gtkmm.h: Include menutoolbutton.h and tearoffmenuitem.h.
  (Michael J M Thomson)
* Added ListViewText very simple text-based convenience class for TextView.
  (J. Baltasar García Perez-Schofield)
* New classes:
  - Assistant, CellRendererAccel, LinkButton, StatusIcon.
    (Murray Cumming, Armin Burgmeier)
  - CellRendererSpin (Marko Anastasov)
  - PageSetup, PaperSize, PrintContext, PrintOperation, PrintSettings
    (Marko Anastasov)
  - RecentChooser, RecentChooserWidget, RecentChooserMenu,
    RecentChooserDialog. (Armin Burgmeier)
  - RecentInfo, RecentManager (Marko Anastasov)
* AccelMap: Added lookup_entry() (Paul Davis)
* CellRendererToggle: Added "indicator-size" property.
* Entry: Added xalign and truncate-multiline properties.
* FileChooserButton: Added set/get_focus_on_click()
* MessageDialog: Added properties.
* Menu: Add attach_to_widget() overload without a destroy callback.
* RadioAction: Added set_current_value().
* Range: Added get/set_lower_stepper_sensitivity(),
  get/set_upper_stepper_sensitivity() and properties.
* SectionData: Added Added targets_include_uri.
* SizeGroup: Added get_widgets().
* Style: Added overload set_bg_pixmap() that takes const Pixmap.
  (Michael Hofmann)
* TextBuffer: Added get_has_selection() and
  property. Added text property.
* TextBuffer: Added const overloads of get_text() and get_slice().
* TreeModel: Added rows_reordered() overload without the iter.
* TreeView: get_search_entry(), set_search_position_func(),
  get_headers_clickable().
* Style: Added Added lookup_color().
* Widget:
  - Added get_action().
  - Made map() public, because custom containers sometimes
    (e.g. GtkNotebook) need to call it on their child widgets,
    though we are not sure when.
* Window: Added get_group(), and get/set_deletable(),
  set_urgency_hint()
  (Murray Cumming)
* Win32 build: Plug and Socket added. (Cedric Gustin)
* Fix the build when using --enable-api-properties, --enable-api-vfuncs, or
  --enable-api-exceptions when configuring glibmm.
  When using these, the API, and any API generated by gmmproc, will be
  changed. This allows users of embedded platforms to reduce the code size of *mm
  libraries and *mm-using applications, at the small cost of losing some rarely-used
  API. Alternatives exist for that API, as show in the examples.

Gdk:
* GC: Added set_clip_rectangle() overload that takes const argument.
  (Michael J M Thompson)
* Added static functions for using Cairo, in general.h.
  (Murray Cumming)

Pango:
* AttrList: Added operator bool.

Documentation:
* Book:
  - DrawingArea: Updated for Cairo.
  - HTML appearance greatly improved.
  - Updated screenshots.
  (Jonathan Jongsma)
  - Added ComboBox chapter and removed
    Combo section. (Murray Cumming)
  - Improved RadioButton example. (Pierre Thierry)
* Reference:
  - Added RadioButton::get/set/reset_group()
    documentation.
  - Add documentation for manage().
    (Murray Cumming)
  - Improved Box documentation. (Pierre Thierry)
* Examples:
  - Added an example that uses events_pending()
  to update the UI (Gareth Foster, Murray Cumming)
  - Added IconView example. (R. Douglas Barbieri)

2.8.1:

* Build: Check for GTK+ 2.8.
* ScrolledWindow: get_*scrollbar_visible():
  get_hscrollbar_visible() returned
  vscrollbar_visible() and vice-versa. Fixed.
  Bug #317309 (Bartek Kostrzewa)
* UIManager: get_action_groups():
  Memory management fix.
  Bug #31865 (Colin Law)
* Fix SUN Solaris Forte build problem.
  Bug #314283 (Felipe Zipitria)
* Documentation corrections.
  Bug #311176 (Marco Scholten)

2.8.0:

API additions since 2.6:

Gtk:
* AboutDialog: Added set/get_wrap_license() and property.
* CellRenderer: Added "sensitive" property.
* ComboBoxText, ComboBoxEntryText:
  - Deprecated clear() in favour of new clear_items() method,
  because clear() exists in the base CellLayout class and is
  very different.
  - Added remove_text() to remove items one at a time.
* Dialog: Added get_response_for_widget().
* EntryCompletion: Added properties, get/set_popup_set_width(),
  get/set_popup_single_width().
* FileChooser: Added get/set_do_overwrite_confirmation(
* Iconview: Added get_item_at_pos(), get_visible_range(), get/set_cursor(),
  scroll_to_path().
* TreeRowReference: Added get_model().
* TreeView:
  - Added unset_model().
  - Added const versions of get_path_at_pos(),
  get_cell_area(), get_background_area(), get_visible_rect(),
  widget_to_tree_coords(), tree_to_widget_coords().
  - Added get_visible_range().
* TreeView::Column: Added queue_resize().
* Sizegroup: Added ignore_hidden property.
* Stock: Added FULLSCREEN, LEAVE_FULLSCREEN, and INFO stock items.
* Widget: Added drag_source_set_icon(const Glib::ustring& icon_name).
* Window:
  - Added urgency_hint property, and get/set_urgency_hint().
  Added present(timestamp) overload.

Gdk:
* Colormap: Deprecated alloc_colors() and  free_colors().
  Add free_color() for use with alloc_color().
* Cursor: Added get_image() and a Cursor(name) constructor.
* DragContext:Added set_icon(const Glib::ustring& name).
* Pixbuf: Added a save_to_buffer() overload without the options
  parameters.
* Window: Added move_region().

(Murray Cumming, Jonathon (Jongsma), Ishmal, Daniel Glöckner, Alexander Nedotsukov, Philip Langdale, The Written Word)

2.7.4:

Gtk:
* Generated properties accessors.
  (Murray Cumming)
* Settings::get_default(): Do not generate
  a second wrapper. (Regis Duchesne)
* TreeView: Added unset_model().
* SUN Forte and Tru64 build fixes.
  (The Written Word.)
* Documentation fixes. (Jonathon Jongsma)

2.7.3:

Gtk:
* FileChooser: Added get/set_do_overwrite_confirmation().
* TreeRowReference: Added get_model().
* TreeView: Added const versions of get_path_at_pos(),
  get_cell_area(), get_background_area(), get_visible_rect(),
  widget_to_tree_coords(), tree_to_widget_coords().
  Added get_visible_range().
* TreeView::Column: Added queue_resize().
Gdk:
* PixbufLoader:create_with_type(): Really return the
  created GdkPixbufLoader.
Win32 build:
* Provide an extra hint to work around a DLL export/import bug
  with MSVC++ and TreeViewColumn (Ishmal)


2.7.2:

Build fix: Removed an extra; that caused a warning.

Gdk:
* Pixbuf: Added a save_to_buffer() overload without the options
  parameters.

2.7.1:

Gdk:
* Colormap: Deprecated alloc_colors() and  free_colors().
  Add free_color() for use with alloc_color().
* Cursor: Added get_image() and a Cursor(name) constructor.
* DragContext:Added set_icon(const Glib::ustring& name).
* Window: Added move_region().

Gtk:
* AboutDialog: Added set/get_wrap_license() and property.
* CellRenderer: Added "sensitive" property.
* ComboBoxText, ComboBoxEntryText:
  - Deprecated clear() in favour of new clear_items() method,
  because clear() exists in the base CellLayout class and is
  very different.
  - Added remove_text() to remove items one at a time.
* Dialog: Added get_response_for_widget().
* EntryCompletion: Added properties, get/set_popup_set_width(),
  get/set_popup_single_width().
* Iconview: Added get_item_at_pos(), get_visible_range(), get/set_cursor(),
  scroll_to_path().
* Sizegroup: Added ignore_hidden property.
* Stock: Added FULLSCREEN, LEAVE_FULLSCREEN, and INFO stock items.
* Widget: Added drag_source_set_icon(const Glib::ustring& icon_name).
* Window: Added urgency_hint property, and get/set_urgency_hint().
  Added present(timestamp) overload.


gtkmm 2.7 wraps new API in GTK+ 2.7, and is API/ABI-compatibile with gtkmm 2.4 and 2.6.
The new API is unstable, until this become the API/ABI-stable gtkmm 2.8 when
GTK+ 2.7 becomes the API-stable GTK+ 2.8.

2.6.1:

* CellRenderer: Prevent an infinite loop.
  (Murray Cumming)
* MSVC++ .Net 2003 build fixes. (Cedric Gustin)
* Documentation:
  - Hide deprecated widgets from the list of widgets.
  (Murray Cumming)
  - Correct the description of the IO input example.
  (Claudio Saavedra)


2.6.0:

gtkmm 2.6 wraps new API in GTK+ 2.6, and is API/ABI-compatibile with gtkmm 2.4.

Changes compared to gtkmm 2.4.x:

Gtk:
* New widgets: AboutDialog, CellRendererCombo,
  CellRendererProgress, CellView, FileChooserButton, IconView,
  MenuToolButton
* Action: Added get_accel_path(), set_visible().
* ActionGroup: Added translate_string().
* Button: Added set/get_image().
* CellRenderer:
  - Added editing_started signal.
  - Added stop_editing() which replaces the
  now-deprecated editing_cancelled()
* CellRendererText: Added language, ellipsize, and
  ellipsize-set properties.
* Clipboard:
* - Added set_image(), wait_is_image_available(),
  wait_for_image(), request_image(), wait_is_target_available(),
  set_can_store(), and store().
* ComboBox:
  - Added get_wrap_width(), get_row_span_column(),
    get_column_span_column(), get_add_tearoffs(), set_add_tearoffs(),
    get_focus_on_click(), set_focus_on_click(),
   get_popup_accessible(), unset_row_separator_func().
* ComboBoxEntry: Added get_entry().
* ComboBoxText: Added set_active_text(), clear().
* Dialog:
  - Added set_secondary_text() for HIG-compliant dialogs.
  - Added set_alternative_button_order().
* Entry: Added layout_index_to_text_index() and
  text_index_to_layout_index().
* EntryCompletion: Added insert_prefix(), set_inline_completion(),
  get_inline_completion(), set_popup_completion(),
  get_popup_completion(), get_text_column()
* FileChooser:
  - Added FileChooserError exception class.
  - Added get/set_show_hidden().
* FileChooserButton: Added get/set_width_chars().
* FileFilter: Added add_pixbuf_formats().
* IconTheme:
  - Added get_icon_sizes().
  - Added IconThemeError exception class.
* Image: Added set_from_icon_name(), get/set_pixel_size(),
  get_icon_name().
* Label: Added get/set_max_chars_width(), set/get_single_line_mode(),
  get/set_width_chars(), get/set_ellipsize().
* Main: Added Main constructor that takes a Glib:: OptionContext,
  and add_gtk_option_group(option_context).
* MessageDialog: Added set_secondary_text().
* PixbufLoader: Added size_prepared signal.
* Plug: Added default constructor.
* ProgressBar: Added set/get_ellipsize().
* SelectionData: Added targets_include_image(), get/set_pixbuf(),
  and get/set_uris().
* Scale: Now works with libglademm.
* Style: Added create() method.
* TextView: Added get_iter_at_position().
* TreeSortable: Added DEFAULT_UNSORTED_COLUMN_ID constant.
* TreeView: Added get/set_fixed_height_mode(), get/set_hover_selection(),
  get/set_hover_expand(),
* TreeModel::itereator: Add forward_search() and backward_search()
  overloads without the limit argument.
* IconInfo: Added operator bool(), needed to check
  the result of IconTheme::lookup_icon().
* Label: Added get/set_angle().
* TreeView: Added append_column_numeric(), and
  append_column_numeric_editable().
* Widget: Made set_parent(), and unparent() public instead
  of protected. Added a size_request() overload which is const
  and returns a value.
* Window: Added drag_dest_add_text_targets(),
  drag_dest_add_uri_targets(), drag_dest_add_image_targets(),
  drag_source_add_text_targets(), drag_source_add_uri_targets(),
  and drag_source_add_image_targets().
* New Stock items.
* Documentation:
  - Extra reference documentation.
  - Properties are now documented.

Gdk:
* Display: Added supports_selection_notification(),
  request_selection_notification(), supports_clipboard_persistance(),
  store_clipboard().
* Pixbuf:
  - Added rotate_simple(), flip(), save_to_buffer().
  - Added create_from_file() overload that takes
  height and width.
* PixbufFormat: Added is_scalable(), is_disabled(),
  set_disabled(), get_license().
* Window: Added enable_synchronized_configure(),
  configure_finished(), set_focus_on_map().

Pango:
* New classes: Renderer
* Color: Added operator bool().
* Context: Added get/set_matrix(), get_font_map().
* FontMetrics: Added get_underline_position(),
  get_underline_thickness(), get_strikethrough_position(),
  get_strikethrough_thickness().
* Layout: Added get/set_ellipsize().

Atk:
* Relation: Added add_target().
* RelationSet.hg: add_relation_by_type().
* Text: Added get_range_extents(), get_bounded_ranges().

gtkmm 2.6 is the result of hard work from the following developers:
Murray Cumming, Bryan Forbes, and Albert Chin, Cedric Gustin, Roger Leigh, Ronald Lembcke, Gene Ruebsamen, Claudio Saavedra, Marco Scholten, Roel Vanhout, Chris Vine.


2.5.7:

* Gdk::DragContext: Avoid infinite loop. (Ronald Lembcke)
* Gtk::TargetList: Fix typo to ctually define this. (Ronald Lembcke).
* Examples now build with the IRIX MipsPro, and AIX compilers.
* Check for the correct atk version in configure.
  (Murray Cumming)
* Documentation:
  - Properties are now documented, using the text from the
    GTK+ documentation.
  - Added MessageDialog documentation.
  - Added CellRendererText::edited() documentation. (Antonio Coralles)
  - examples: book/treeview/editable_cells/:
    Demonstrated data-entry validation.
  (Murray Cumming)
  -
2.5.6:

* Now builds with the following compilers, in addition to
the existing GNU g++, and Intel compilers:
- SUN Forte CC 5.5
- IBM AIX xlC v7
- Tru64 C++ V6.5-042
- IRIX MIPSpro 7.4.2m
  (Older versions of all these compilers might also work.)
  (Murray Cumming, www.thewrittenword.com)
* Now builds with MSVC++ .Net 2003 (gtkmm 2.4 already did).
  (Cedric Gustin)

Gtk:
* Plug: Added default constructor. (Bryan Forbes)

Documentation:
- examples/book/custom/custom_widget/:
  Now it works. (Marco Scholten)

2.5.5:

Gtk:
* Remove default signal handlers for new signals in 2.6,
  because adding virtual methods to existing classes would
  break ABI. (Murray Cumming, Bryan Forbes)
* Stock: Wrapped several new stock items. (Bryan Forbes)
* AboutDialog: Added logo_icon_name property. (Murray Cumming)
* Clipboard: Added set_can_store() overload that takes no
  arguments. (Murray Cumming)
* ComboBox: Added unset_row_separator_func(). (Murray Cumming)
* FileChooserDialog:
  - Inherit from FileChooser interface. (Murray Cumming)
  - Added constructors which allow specifying backend. (Bryan Forbes)
* IconView: Added the properties. (Murray Cumming)
* Main: Added Main constructor that takes a Glib::OptionContext(),
  and Main::add_gtk_option_group(option_context).
  (Murray Cumming, Bryan Forbes)
* TreeIter: Add forward_search() and backward_search()
  overloads without the limit argument.
  (Rob Page, Murray Cumming)

Pango:
* Color: Added operator bool().
* Renderer: Added get_color().
  ((Murray Cumming)

Documentation:
* Added some reference documenation for the new classes,
  plus several older classes.
* Corrected documentation tarball and the link to it.
* examples:
  - Added book/dialogs/aboutdialog example.
  - Added book/buttons/filechooserbutton example.
  - Used ProgressCellRenderer in book/treeview/list example.
(Murray Cumming)

2.5.4:

Gtk:
* Action: Added get_accel_path(). (Murray Cumming)
* CellRendererText: Added language, ellipsize, and
  ellipsize-set properties. (Bryan Forbes)
* TreeView: Added hover_expand and hover_selection
  properties.

Gdk:
* Display: Added supports_selection_notification(),
  request_selection_notification(), supports_clipboard_persistance(),
  store_clipboard().
* Pixbuf: Added rotate_simple(), flip(), save_to_buffer().
* PixbufFormat: Added is_scalable(), is_disabled(),
  set_disabled(), get_license().
* Window: Added enable_synchronized_configure(),
  configure_finished(), set_focus_on_map().

Atk:
* Relation: Added add_target().
* RelationSet.hg: add_relation_by_type().
* Text: Added get_range_extents(), get_bounded_ranges().
  (Murray Cumming)

2.5.3:

* Builds against the final GTK+ 2.6 API.

Gtk:
* CellRenderer.hg: Added stop_editing() which replaces the
  now-deprecated editing_cancelled().
* CellView: Inherit from CellLayout. Removed set_value().
  Added convenience constructors.
* FileChooserButton.hg: Added action parameters to constructors.
* IconView: Added get/set_columns(), get/set_item_width(),
  get/set_spacing(), get/set_row_spacing(), get/set_column_spacing(),
  get/set_margin().
* Label: Added get/set_max_chars_width(), and property.
* TextView: Added get_iter_at_position().

Gdk:
* Pixbuf: Added create_from_file() overload that takes
  height and width. (Murray Cumming)

Documentation:
* Reference API: Re-extracted C docs, so that the new API
  will be automatically documented. (Murray Cumming)
* examples:
  - input: Use Glib::IOChannel. (Claudio Saavedra)

2.5.2:

Gtk:
* Button: Added set/get_image().
* CellView: Removed set_cell_data().
* Dialog: Added set_alternative_button_order().
* FileChooserButton:
  - Now inherits from HBox, not Button.
  - Removed get/set_active().
* IconInfo: Added operator bool(), needed to check
  the result of IconTheme::lookup_icon().
* Label: Added get/set_angle().
* TreeView: Added append_column_numeric(), and append_column_numeric_editable(),
  which allow more control over the formatting of numeric data than
  append_column() and append_column_editable().
  (Murray Cumming)

Pango:
* Added Renderer.
* Context: Added get/set_matrix().
* FontMetrics.hg: Added get_underline_position(),
  get_underline_thickness(), get_strikethrough_position(),
  get_strikethrough_thickness().
  (Murray Cumming)

Documentation:
* example/book/input/: This now works. (Chris Vine)
* Book:
  - TreeView selection: Use selected_foreach_iter()
  instead of selected_foreach(). (Teus Benschop)
  - Fixed some typos. (Claudio Saavedra)


2.5.1:

Gtk:
* AboutDialog:
  - Added more get and set methods and properties.
  - Wrapped signals.
* ActionGroup: Added translate_string().
* Added CellRendererCombo, with example.
* Added CellRendererProgress.
* Clipboard: Added set_image(), wait_is_image_available(),
  wait_for_image(), request_image(),
  wait_is_target_available(), set_can_store(), and store()
* ComboBoxEntry: Added get_entry().
* ComboBoxText: Added set_active_text(), clear().
* Dialog: Added alternative_button_order().
* FileChooser: Added FileChooserError exception class.
* FileChooserButton: Added get/set_width_chars().
* FileFilter: Added add_pixbuf_formats().
* IconTheme:
  - Added get_icon_sizes().
  - Added IconThemeError exception class.
* IconView:
  - Added get_selected_items(), foreach().
  - Added set_text_column(), and set_pixbuf_column() overrides
    that take ModelColumns instead of ints.
  - Wrapped signals.
* Image: Added set_from_icon_name(), get/set_pixel_size(),
  get_icon_name().
* Label: Added set/get_single_line_mode(), get/set_width_chars().
* MessageDialog: Added set_secondary_text().
* Added MenuToolButton.
* PixbufLoader: Added size_prepared signal.
* ProgressBar: Added set/get_ellipsize().
* SelectionData: Added targets_include_image(), get/set_pixbuf(),
  and get/set_uris().
* Style: Added create() method.
* Widget: Made set_parent(), and unparent() public instead
  of protected. Added a size_request() overload which is const
  and returns a value.
* Window: Added drag_dest_add_text_targets(),
  drag_dest_add_uri_targets(), drag_dest_add_image_targets(),
  drag_source_add_text_targets(), drag_source_add_uri_targets(),
  and drag_source_add_image_targets().

Pango:
* Context: Added get_font_map().

* Documentation:
  - Partly-updated "input" example. Bug
  - Added IconView and CellRendererCombo examples.
(Murray Cumming)

2.5.0:

gtkmm 2.5 wraps new API in GTK+ 2.5, and is API/ABI-compatibile with gtkmm 2.4.
The new API is unstable, until this become the API/ABI-stable gtkmm 2.6 when
GTK+ 2.5 becomes the API-stable GTK+ 2.6.

* Pango: Layout: Added set_ellipsize(), get_ellipsize(), and
  EllipsizeMode enum.
* Gtk:
  - Added IconView, FileChooserButton, and CellView widgets.
  - Action: Added set_visible().
  - Entry: Added layout_index_to_text_index() and
    text_index_to_layout_index().
  - EntryCompletion: Added insert_prefix(), set_inline_completion(),
    get_inline_completion(), set_popup_completion(), get_popup_completion(),
    get_text_column()
  - CellRenderer: Added editing_started signal.
  - ComboBox: Added get_wrap_width(), get_row_span_column(),
    get_column_span_column(), get_add_tearoffs(), set_add_tearoffs(),
    get_focus_on_click(), set_focus_on_click(), get_popup_accessible().
  - Label: Added set_ellipsize(), get_ellipsize().
  - FileChooser: Added set_show_hidden(), get_show_hidden().
  - TreeSortable: Added DEFAULT_UNSORTED_COLUMN_ID constant.
  - TreeView: Added set_fixed_height_mode(), get_fixed_height_mode(),
    set_hover_selection(), get_hover_selection(), set_hover_expand(),
    get_hover_expand().
(Murray Cumming)

2.4.5:

* Gtk::Settings::get_default(): Correct reference-count error.
  (Murray Cumming)
* Gtk::ActionGroup, EntryCompletion, UIManager: Make constructors
  protected instead of private (Christopher Palm).
* Examples: TreeView:
  - Added popup example, from gtkmm 2.2.
  - drag_and_drop: Correct vfuncs.
* Documentation:
  - libglademm memory management.
  - Tell people to check pkg-config for 2.4, not 2.2.
  - Gtk::TreeSortable: Document sort function return value.
  (Murray Cumming)

2.4.4:

* More gcc 3.4 build fixes. (Daniel Elstner)
* Gtk::StockItem: Use the global translation domain when no other
  translation domain has been specified. (Daniel Elstner)
* Gtk::Action, ToggleAction, RadioAction, IconTheme: Constructors are now
  protected so that you can derive from these classes.
* Gtk::Container: Avoid warning about unimplemented GtkContainer::remove
  vfunc when deriving directly from Gtk::Container.
  (Murray Cumming)

2.4.3:

* Win32: gdkmm: Link against the correct libpangomm library.
  (Cedric Gustin)
* Gtk::TreeModel::iterator: Correct the operator--() implementation, so that
  it actually works. Remember, this is very slow compared to operator++().
  (Daniel Elstner)
* Gtk::ComboBoxText, Gtk::ComboBoxEntryText: Implement the constructors that
  take C instances.
  (Murray Cumming)


2.4.2:

Gtk:
* ComboBox::get_active(): Properly initialize the iterator.
  (Murray Cumming)
* ComboBoxTextEntry: Don't add the text column twice. (Teemu Tervo)
* ComboBoxText, ComboBoxEntryText::get_active_text(): Fix potential
  crash. (Murray Cumming)
* TreeView::get_path_at_pos(): Correct memory mangement.
  (Murray Cumming, David)
* Use GTHREAD_CFLAGS when appropriate. (Daniel Elstner)
* gtkmm.h: Add comboboxentry.h and comboboxentrytext.h.
  (Daniel Elstner)

Reference Documentation:
* FileChooser: Mention the need to convert to UTF8. (Daniel Elstner)


2.4.1:

* Build fixes for gcc 3.4.0. (Murray Cumming)
* Install gdkmmconfig.h in the correct place.
  (Murray Cumming)
* Install atkmm/private headers in the correct place.
  (Alexander Nedotsukov)

Changes in gtkmm 2.4:

- Highlights:

  There are several new widgets/classes, with examples:

  * New File Chooser:
    FileChooser, FileChooserWidget, FileChooserDialog, FileFilter.

  * Action-based Toolbar/Menu API:
    UIManager, Action, ToggleAction, RadioAction.

  * New Combo Box:
    ComboBox, ComboBoxEntry, ComboBoxText, CellLayout.

  * Auto-complete for Entry:
    EntryCompletion.

  * Other new classes:
    IconInfo, IconTheme TargetList.

  * New ATK, Pango, and GDK API wrapped.

- Existing API improved:
  * Use of improved libsigc++ 2 API.
  * Removed useless key-binding signals.
  * Alignment: Added set/get_padding().
  * Entry: Added set/get_alignment().
  * Settings: New properties.
  * ListStore/TreeStores: Added insert_after(), which should be faster than insert().
  * TreeView: Added move_column_to_start()
  * TreeModel: Deriving is now easier, because the virtual functions now use C++ types.
  * TreeModel::iterator: Added operator--(), which is slow.
  * See the NEWS file for detailed API changes.
  * Various bugfixes - see ChangeLog.

The following people made gtkmm 2.4 happen:
  Bradley Bell
  Murray Cumming
  Bryan Forbes (lots of very significant work)
  Cedric Gustin
  Oli Kessler
  Ole Laursen
  Andrew E. Makeev
  Hagen Moebius
  Frank Naumann
  Elijah Newren
  Billy O'Connor
  Gene Ruebsamen
  Martin Schulze
  Enrico Scholz
  Sebastian Rittau
  Takashi Takekawa
  Matthew Walton



2.3.8:

* Gtk:
  - Action: Added set_sensitive() and set_tooltip(). (Murray Cumming)
  - Settings: Added some properties. (Bryan Forbes)
  - TargetList: Added a create() method.  (Bryan Forbes)
  - TreeModel: Rename 2 of the foreach() methods, to foreach_iter() and foreach_path(),
    because they are ambiguous with libsigc++ 2. (Murray Cumming)
  - ListStore/TreeStore:  Added insert_after(), because it is apparently faster with
    many rows. (Murray Cumming)
  - IconTheme: Corrected refcounting of get_default() and get_for_screen().
    (Bryan Forbes)


2.3.7:

* Gtk:
  - Action:
    - create_tool_item(), create_menu(), and create_icon() return specific types.
      (Bryan Forbes)
    - Constructors: Give 0 instead of "" to GTK+ for empty strings, to make
      stock items work. (Murray Cumming)
  - Container: Keep managed child widgets alive when remove()ing them.
    (Murray Cumming)
  - IconTheme: Wrapped the changed signal. (Murray Cumming)
  - FileFilter: It's a Gtk::Object, not a Glib::Object. (Murray Cumming)
  - TreeView: Added move_column_to_start(). (Andrew E. Makeev)
  - UIManager: Fixed typo in disconnect_proxy signal name. (Bryan Forbes)
  - many: Do the extra reference for several get_*() methods.
    (Bryan Forbes, Murray Cumming)


* Documentation:
  - Reference documentation: Corrected some mention of null parameters, and g_free(),
    in generated-from-C docs. (Murray Cumming)
  - Book: Corrected typos and updated libsigc++ syntax. (Elijah Newren)
  - FAQ: Don't mention gtkmm 1.2 so much. (Elijah Newren)
  - Examples: Adde book/menus_and_toolbars, to show UIManager. (Murray Cumming)


2.3.6:

* Build fixes:
  - Partial Sun Forte C++ build fixes.
    (Murray Cumming, Michael v.Szombathely)
  - gcc 3.4 (cvs) build fixes
    (Murray Cumming, Matthew Tuck)
  - win32 (cygwin) build fixes:
    (Cedric Gustin)
  - Doxygen is, again, not required when building from tarballs.
    (Murray Cumming)

* Gtk: RadioButton, RadioMenuItem: Added group_changed signal.
  (Murray Cumming)

* Documentation:
  _Lots_ of added, and improved reference documentation.
  (Hagen Moebius)

2.3.5:

* Gtk:
  - ComboBox: Added popup() and popdown(). (Murray Cumming)
  - ComboBoxEntry: Added a set_text_column() overload that takes a
	ModelColumnBase instead of an int.
  - Added ComboBoxEntryText, like ComboBoxText. (Murray Cumming)
  - Entry: Added set/get_alignment().
  - FileChooser:
    - Removed set_folder_mode() and get_folder_mode(),
      which are no longer in GTK+. (Bryan Forbes)
    - Added set/get_preview_label(). (Murray Cumming)
  - Added IconInfo, TargetList (Bryan Forbes)
  - IconTheme: methods now use IconInfo. (Bryan Forbes)
  - Added Gtk::Stock::DIALOG_AUTHENTICATION stock item.
    (Bryan Forbes)
  - Scale: Added get_layout() and get_layout_offsets().
  - Toolbar
    - Added append(), prepend(), insert() overloads which take
      slots, so that signal connecting requires less code.
    - Removed old STL-style API, because the APIs do not
      co-exist well together at the GTK+ level.
    (Bryan Forbes)
  - TreePath: Corrected template typo found by gcc 3.4
    (Matthew Tuck)
  - Widget: Added add_mnemonic_labels(), remove_mnemonic_label(),
    list_mnemonic_labels(), draw_insertion_cursor().
    (Murray Cumming)
  - Window: Added "role" property. (Bryan Forbes)

  - Several const corrections. (Murray Cumming)
  - Fixes to the libsigc++2 port. (Martin Schulze, Bryan Forbes)
  - Added --enable-examples configure option. (Bryan Forbes)

  - Documentation:
    - Added some TreeView reference documentation.
      (Billy O'Connor)

* Gdk:
  - Drawable::draw_glyphs() now takes a c++ Pango::GlyphString.
    (Bryan Forbes)
  - Window
    - get_children() now returns a C++ container instead of a GList.
      (Bryan Forbes)
    - get_internal_paint_info() now takes C++ parameters.
      (Bryan Forbes)
    - removed peek_children() because it's the same as get_children().
      (Murray Cumming)

* Pango:
  - FontFace: Added list_sizes().
  - AttrIter: Added get_attrs().
  - FontFamily: Added is_monospace().
  - FontSet: Added foreach()
  - Language: Added includes_script().
  - Layout: Added set/get_auto_dir().

2.3.4:

* Gtk:
  - Now uses libsigc++ 2 (Murray Cumming)
  - Frame: Methods use C++ Gtk::Allocation instead of C GtkAllocation.
    (Bryan Forbes)
  - Added IconTheme. (Bryan Forbes).
  - Added TargetList. (Bryan Forbes)
  - TargetEntry: Use a C++ TargetFlags enum instead of the C enum.
    (Bryan Forbes)
  - Widget
    - drag_dest_find_target(), drag_dest_get_target_list(), drag_begin():
    Use C++ TargetList instead of C GtkTargetList. (Bryan Forbes)
    - Use C++ Gtk::Allocation instead of GtkAllocation, and
      Gtk::Requisition instead of GtkRequisition in methods.
    (Bryan Forbes)
   - Socket: Use C++ Gdk::NativeWindow type for method parametrs.
    (Bryan Forbes)

* Gdk:
  - Colormap: Use C++ Gdk::Color instead of C GdkColor for method parameters
    (Bryan Forbes)
  - Device: Use C++ InputSource enum instead of the C GdkInputSource enum.
    (Bryan Forbes)
  - Display: Use ustring for target parameters instead of GdkAtom.
    (Bryan Forbes)
  - Added C++ NativeWindow typedef and used it instead of GdkNativeWindow
    (Bryan Forbes)

* examples: book/dialogs/filechooser: Added buttons.
  (Matthew Walton)

2.3.3:

- CellLayout: signals take a C++ CellRenderer* instead of a C
  GtkCellRenderer*.
- Widget:
  - signal_drag_data_get and signal_selection_get now use the C++
    SelectionData type.
  - Methods now take C++ Gdk::Region& instead of C GdkRegion*.
- SelectionData: Added set() method overload with fewer parameters.
- TreeDragSource: The drag_get_data vfunc now uses the C++
  SelectionData type.
- TreeIter (TreeModel::iterator): Added operator--().
- Added const version of many ListHandle<> get_*() methods.
  (Murray Cumming)

2.3.2:

* Gtk:
  * AccelMap: Added lock_path() and unlock_path().
  * Button: Added get/set_alignment().
  * CellLayout: Added reorder().
  * Clipboard: Added wait_for_targets(), and a simpler request_targets().
  * MenuShell: Added cancel().
  * ListStore, TreeStore: Added set_model_columns() for use by derived
    classes.
  * TreeModel: vfuncs now use C++ types, and are documented.
  * TreeModelFilter: Wrapped set_modify_func().
  * Window: Added get_group() and set_accept_focus().

* Gdk:
  * Colormap: Added get_system().
  * Device: Added get_name(), get_source(), get_mode() and get_has_cursor()
  * Display: Added set_double_click_distance() and get_default_group().
  * DragContext: Added get_targets().
  * Added rgb_*() methods.

* Pango:
  * LayoutLine: Added get_length(), get_start_index(), and get_layout().

* Atk:
  * Added Document, Hyperlink, Hypertext, and StreamableContent classes.

* Portability:
  * Atk::Text build fix for Intel compiler. (Takashi Takekawa)

* Documentation:
  * devhelp file now installs correctly, with working hyperlinks.
  * Documented Gtk::AccelMap methods.
  * Documented Atk classes.
  * TreeView, TextView, and associated classes are almost fully documented.
  (Murray Cumming)

* Also:
  - build fix. (Billy O'Connor)
  - spec file fix. (Eric Bourque)


2.3.1:

* Gtk:
  * Action, ToggleAction, RadioAction:
    - Added create() method overloads without stock_id.
    - ToggleAction::create() has extra bool is_active parameter.
  * EntryCompletion: Wrapped match_selected signal.
  * Expander: Added get/set_markup()
  * Menu: Added set_monitor()
  * Menu::AccelKey is now Gtk::AccelKey
  * MessageDialog: Added set_markup().
  * Added FileChooser (interface), FileChooserWidget, FileChooserDialog, FileFilter, with example.
  * ComboBox example
  * ComboBoxText now works, with example.
  * RadioToolButton: constructors properly implemented. (Murray Cumming, Billy O'Connor)
  * Toolbar: Old API deprecated. New API wrapped. Expect more change here.
  * TreeModel:: Add virtual iter_is_valid() method, now used by TreeModel::iterator operator bool().
  * TreeViewColumn: Added get_cell_position().
  * Widget: Wrapped get_accessible and screen_changed signals.
* Gdk:
  * Pixbuf: Added get_formats()

* Added Atk::init() and Pango::init(), to use when you don't want all of gtkmm.
* Documentation: Corrected installation and links with glibmm documentation.
* Deprecation: Define GTKMM_DISABLE_DEPRECATED to prevent use of deprecated API in your application.
  (Murray Cumming)

2.3.0:

* Removed key-binding signals. (Murray Cumming)

* Use of Gdk::Device and Gtk::SelectionData instead of C equivalents
  (Murray Cumming)

* New classes:
  Gtk::
    Action, ActionGroup, CellLayout, ComboBox, ComboxText, ComboBoxEntry, ColorButton, EntryCompletion,
    Expander, FontButton, RadioAction, RadioToolButton, ToggleAction, ToggleToolButton, ToolItem, ToolButton,
    UIManager

* New API for existing classes:
  Gtk::Alignment: get/set_padding(). Useful for indenting Gtk::Frame contents.
  Gtk::Button: get/set_focus_on_click()
  Gtk::ButtonBox: get_child_secondary().
  Gtk::Calendar:
    - display_options() is now set_display_options().
    - New properties.
  Gtk::CheckMenuItem: get/set_draw_as_radio()
  Gtk::Entry: get/set_completion()
  Gtk::EventBox: get/set_visible_window(), get/set_above_child()
  Gtk::IconSource: get/set_icon_name()
  Gtk::Menu: attach()
  Gtk::MessageDialog:
    Constructors: Added bool use_markup paramater after message parameter.
      This is an API change, and I'd leak to hear suggestions for alternatives.
  Gtk::TextBuffer: select_range()
  Gtk::TextIter (also known as Gtk::TextBuffer::iterator):
    Added *_visible_* versions of forwards/backwards methods.
  Gtk::TextView:
  - get/set_overwrite(), get/set_accepts_tab()
  - Added WRAP_WORD_CHAR wrap mode.
  Gtk::TreeViewColumn (also known as Gtk::TreeView::Column):
    Added get/set_expand().
  Gtk::Widget:
  - queue_resize_no_redraw(), get/set__no_show_all()
  - Added unset_fg(), unset_bg(), unset_font(), unset_text(), unset_base().
  - Added add_modal_grab(), remove_modal_grab(), get_current_modal_grab().
    (Ole Laursen)
  - Added set_window() and set_allocation() for implementing new native widgets.
    (Detlef Reichl)
  Gtk::Window: set_default_icon(), set_keep_above(), set_keep_below()

  Gdk::Cursor: new constructor: Cursor(const Glib::RefPtr<Display>& display, const Glib::RefPtr<Pixbuf>& pixbuf, int x, int y)
  Gdk::Display: flush(), supports_cursor_alpha(), supports_cursor_color(), get_default_cursor_size(),
    get_maximal_cursor_size
  Gdk::PixbufLoader: create() now has extra bool mime_type parameter.
  Gdk::Window: set_keep_above(), set_keep_below().
  (Murray Cumming)


2.2.2:

 * OptionMenu: Fixed segfault when Menu remembers destroyed OptionMenu.
   (Murray Cumming)
 * Gtk::Image::get_pixbuf(): Fixed reference counting error.
   (Enrico Costanza)
 * Pango::AttrList::insert(), insert_before(), change()):  Pass a copy of
   the attribute parameter. (Martin Schulze)
 * Menu: Fixed memory leak when removing MenuItems.
   (Murray Cumming)
 * Build fixage (Enrico Scholz, Cedric Gustin)
 * Win32:
   - Dispatcher ported to Win32, we think.
     (Andrew Makeev, Cedric Gustin, Murray Cumming)
 * Examples:
   - Updated book/idle and book/timeout.
   (Gene Ruebsamen, Murray Cumming)
 * Documentation:
   - Win32 installation instructions. (Gene Ruebsamen)
   - Glib::Module documented (Ross Burton)
   - Updated idle/timeout chapter. (Gene Ruebsamen)
   - Correct all automatic-from-GTK+ documentation that mentions
     _free() functions by mistake. (Murray Cumming)
   - Corrected typo in gtk_window_set_default(). (Oli Kessler)
   - gobj() methods documented.
   - Documented Glib::ListHandle, Glib::ListHandle, Glib::SListHandle.
     (Murray Cumming)

Changes in gtkmm 2.2:

Highlights:
- New GTK+ 2.2 API wrapped:
  * Gtk::ListStore and TreeStore move(), reorder(), iter_is_valid()
  methods added.
  * Gdk::DisplayManager, Display, and Screen added.

- Existing API improved:
  * atkmm rewritten and usable.
  * Gtk::Clipboard rewritten and now usable, with examples and documentation.
  * Gtk::TreeView drag-and-drop now usable, with examples, and documentation.
  * Gtk::TreeModelSort wrapped.
  * Gtk::Toolbar has a non-STL-style interface, like the other containers.
  * glibmm: Added string utility functions, get_appname(), file_open_tmp()
    and file_open_contents(). Glib::Markup added - this is not a real XML
    parser.
  * Various bugfixes - see ChangeLog.

The following people made gtkmm 2.2 happen:
Ross Burton
Murray Cumming
Daniel Elstner
Walter H. van Holst
Mark Jones
Gary Peck
Daniel Sundberg
Naofumi Yasufuku



2.2.0:

* Added Gdk::Window::pointer_grab(), pointer_ungrab(), keyboard_grab()
  and keyboard_ungrab(). (Murray Cumming)

2.1.3:

* Changed library binary version so libtool knows that
  2.2 is API compatible with 2.0. We did this wrong in the past
  so people MUST do this:

    rm -rf <prefix>/lib/lib{glib,pango,atk,gdk,gtk}mm-[12].0.so.[345]*

  where <prefix> is something like /usr/local or /opt/gnome2
  This will remove previous bad versions of 2.1.x.
* atkmm: Lots of new interfaces wrapped. (Daniel Elstner).
* Gtk::TextView:: Fixed bytes/length confusion in TextBuffer's
  insert_text callback. (Daniel Elstner)

Documentation:
  C->C++ docs conversion improved. (Daniel Elstner)

2.1.2:

* Gtk::Clipboard API finished, with examples, and a book chapter:
  http://www.gtkmm.org/gtkmm2/docs/tutorial/html/ch16.html
  (Murray Cumming, Daniel Elstner)
* Gtk::TreeView: Some drag-and-drop API improvements, with examples.
  (Murray Cumming)
* Gtk::TreeModelSort added. (Daniel Elstner)
* Glib::RefPtr: Added swap(). (Daniel Elstner)
* Gtk::ColorSelection: catch exceptions. (Daniel Elstner)
* Gdk::Pixmap: Prevent rare segfault in creation. (Daniel Elstner)
* Gtk::AccelGroup::activate(): Implemented as a wrapper of
  gtk_accel_groups_activate().  (Daniel Elstner)
* Glib::file_open_tmp() and Glib::file_open_contents() implemented.
  (Daniel Elstner)
* win32: Glib::Dispatcher compilation fix. (Naofumi Yasufuku)

2.1.1:
* Gtk::Clipboard API usable, and demonstrated in examples/book/clipboard
  (Murray Cumming)
* new Gtk::ListStore and TreeStore move(), reorder(), iter_is_valid()
  methods added. (Daniel Elstner)
* Gtk::FileSelection: get_history_pulldown() added. (Mark Jones)
* Added Gtk::Widget::modify_bg_pixmap(). (Daniel Elstner)
* Gtk::RcStyle: Added accessors for public struct fields. (Daniel Elstner)
* Gtk::Style: Added accessors. (Daniel Elstner)
* Gtk::ColorSelection: Added palette methods. (Daniel Elstner)
* Gtk::Label::get_layout(): Corrected refcounting (Daniel Elstner)
* Prevent leak when constructors throw exceptions. (Daniel Elstner)
* Added Glib::get_application_name() and set_application_name()
  (Daniel Elstner)
* spec file improved (Gary Peck)

* Documentation updated automatically from latest C API docs.
  (Daniel Elstner)


2.1.0:

* atkmm: Major API corrections. It was unusable before, so we felt free to break
  the API. (Daniel Elstner)
* Gtk::Clipboard: Now inherits from Glib::Object, so it should be used with
  Glib::RefPtr<>. This was unusable before, so we felt free to break the API.
  (Murray Cumming)
* Gtk::TreeModel::RowReference: It's now a "boxed type" so it can be copied.
  (Murray Cumming)
* Gtk::TreeView: some convenience method overloads added. (Daniel Elstner)
* gdkmm: New classes and methods added, mostly to support multi-head.
  (Murray Cumming)
* gtkmm: New methods, for multi-head and some new TreeView methods.
  (Daniel Sundberg, Murray Cumming)
* glibmm/stringutils.h: New utility functions. (Daniel Elstner)
* Gtk::Toolbar: Now has non-STL-style interface - e.g. append().
  (Murray Cumming)
* Glib::Markup added. You probably want to use a real XML parser instead.
  (Daniel Elstner)
* Spec file for RPMs corrected. (Walter H. van Holst)

Documentation:
* Widget-specific and Internationalization chapters completed.
* Book now has inline example code. (Murray Cumming, Daniel Elstner)
* New book/dialogs example. (Murray Cumming)
* examples: warnings fixed. (Daniel Elstner)

Also in 2.0.2:
* Lifetime fix: rare segfault involving destruction and hide() fixed.
  (Daniel Elstner)
* TreeView::append_editable(): Now works with bool model columns.
  (Murray Cumming)
* reference-counting fixed in some vfuncs. (Daniel Elstner)


gtkmm-2-0 branch created. This is HEAD, for gtkmm 2.2

2.0.1:

* Lifetime: Fixed segfault during destruction of non-scrollable children
  in ScrolledWindow. (Murray Cumming, Daniel Elstner)
* Signals: Honor the blocked flag of the SigC::Connection.
  (Daniel Elstner)
* Gtk::WindowGroup: Added missing create() method.
  (Daniel Elstner)
* Win32:
  - Uses -mms-bitfields option for use with GTK+ with MinGW gcc3
  - Temporarily #undef some badly named win32 macros.
  (Naofumi Yasufuku)

* Documentation:
  - Built HTML is now distributed in the tarball.
    (Murray Cumming, Daniel Elstner)
  - Documentation is installed in <prefix>/share/doc/gtkmm-2.0/
    (Daniel Elstner)
  - "Programming with gtkmm": widget-specific sections updated.
    (Murray Cumming)


2.0.0

* Now builds with gcc even with -Werror warnings. (Daniel Elstner)
* Various low-level cleanups/improvements. (Daniel Elstner)
* SUN-specific workarounds removed now that SUN fixed their
  compiler (Michael v. Szombathely)

API Changes:
* Gtk::Box::pack_start() and pack_end():
  removed default argument values for the bool, bool overloads,
  to improve type-safety of the more useful PackOptions overload.
  (Daniel Elstner)
* Gtk::Menu_Helpers::StockMenuElems can be used to create
  submenus. (Christof Pettig)
* Gtk::AspectFrame: Added a constructor that uses AlignmentEnum.
  (Murray Cumming)
* Some minor Pango API corrections (Daniel Elstner)
* Glib::ustring::clear(): Added. (Daniel Elstner)
* Glib::Ascii::tolower() and Glib::Ascii::toupper() added.
  (Daniel Elstner)


Documentation:
* Book:
    Updated almost all widget-specific sections.
    Used links to reference docs and to example source code.
    Added screenshots.
* FAQ: Updated and converted to DocBook XML.
* examples: Rewrote many examples - see examples/book/
  (Murray Cumming)
* Glib::ustring non-standard methods documented.
  (Daniel Elstner)


2002-10-17: 1.3.26:

* GCC 2.95 build fixed. (Daniel Elstner)

2002-10-17: 1.3.25:

* Now requires libsigc++ 1.2.0
* Gtk::Entry::get_layout(): refcounting fixed. (Daniel Elstner)
* gcc 3.2 warnings fixes. (Daniel Elstner)
* Gtk::TextBuffer::iterator::operator bool() now works.
 (Daniel Elstner)

API changes:
* Gtk::TextBuffer:
  * create_mark() Added overload for anonymous marks.
  * iterator: Return values instead of references, for UTF8.
  * insert_interactive() and erase_interactive now return a pair,
    with a bool to indicate success, like std::map::insert().
  * insert_range()renamed to insert().
  * insert_range_interactive() renamed to insert_interactive().
  * delete_text() renamed to erase()
  * delete_interactive_text() renamed to erase_interactive()
  * delete_selection() renamed to erase_selection().
  * insert_child_anchor() now returns an iterator.
  * signal_insert_text() renamed to signal_insert().
  * signal_delete_range() renamed to signal_erase().
  * assign(): New alias method for set_text().
  (Daniel Elstner)
* Gtk::TreeView:
  * Added scroll_to_row() and scroll_to_column()
  * Added unset_hadjustment(),unset_vadjustment(), and
      unset_expander_column().
    Added set_cursor() overload taking a TreePath.
    * enable_drag_model_source() now takes a Gtk::TargetEntry instead
      of the C type.
  (Daniel Elstner)
* Glib::IOChannel StreamIOChannel: new wrappers.
  (Tassos Bassoukos, Martin Schulze, Daniel Elstner)
* Glib::IOSource: Added create() overload that takes IOChannel.
  (Martin Schulze).

* Documentation:
  * Book: Some Sections on common widgets updated and rearranged,
    with screenshots. Example code is now linked instead of being
    inline.
  * examples:
      Several examples rewritten and moved into examples/book.
  (Murray Cumming)
  * demos: warnings in TextBuffer demo fixed. (Daniel Elstner)

2002-10-09 1.3.24:

* Lifetime: On-stack child widgets are not destroyed during destruction of their
  containers. (Murray Cumming)
* Gtk::TextMark::get_iter(): Corrected reference counting (Mike McEwan)

API changes:
* Glib::Source: Can now wrap existing GSource objects.
  (Martin Schulze)
* Glib::TimeVal: Convenience methods added. (Stephan Puchegger)
* Glib::IConv: Added reset(). (Daniel Elstner)
* Glib::Dispatcher: new constructor accepts an arbitrary Glib::MainContext.
  (Stephan Puchegger)
* Gdk: Added screen_width() and screen_height(). (Murray Cumming)


2002-09-13 1.3.23:

Documentation:
* We now reuse ATK, GDK, and Pango reference documentation:
  e.g: http://www.gtkmm.org/gtkmm2/reference/html/namespacePango.html
  (Martin Schulze)
* README.SUN added (Michael v. Szombathely)

API breakage:
* pangomm: New classes, and some corrections to existing classes.
  (Martin Schulze)
  Excuse: Pangomm isn't used very much.
* Gtk::TreeView::set_column() takes a Widget& instead of a GtkWidget*.
  (Murray Cumming)
  Excuse: If anybody was using it already, they would have told us.
* Gtk::TextBuffer::get_text(): Added overload that takes no iterators.
  (Murray Cumming)
  Excuse: It's API addition.
* Gtk::Style: Wrapped GTK+ vfuncs.
  (Murray Cumming)
  Excuse: It's API addition.


2002-08-28 1.3.22:

* Win32:
  - Don't include strings.h on Win32.
  - Use -fnative-struct, as used by GTK+ DLLs.
  - Install win32 import libraries.
  (Naofumi Yasufuku)
  - Don't try to register non-wrapped classes. (Murray Cumming)

* Sun Forte build fixes. (Michael v. Szombathely)

API breakage:
* pangomm:
  - Added Rectangle, Language, Color, Item, Glyph, Attributes, Attr, AttrItem.
  - Used these wrappers in other class methods.
  - Added some wrapper methods.
  (Martin Schulze)
  Excuse for breakage: pangomm isn't used much directly so this shouldn't break much.
* Added Gdk::Window::set_cursor(void) to reset the cursor. (Murray Cumming)
  Excuse: It's additional API so it doesn't break anything.

2002-08-18 1.3.21:
* Lifecycle: Prevented double-destroying of GtkObjects. (Murray Cumming)
* Pango::Layout: Added constructor and create() method. (Martin Schulze)
* Gtk::Scale: set_draw_value() and get_draw_value() parameters are now bools.
  (Ole Laursen)

Documentation:
* Additions to PORTING. (Elke Meier).
* PORTING is now distributed. (Bradley Bell)
* docs/internal: Added documentation_generation.tx.t (Murray Cumming)
* More reference docs for Scale, VScale, and HScale. (Ole Laursen)


2002-08-14 1.3.20:
* Gtk::TreeView classes:
  - TreeView::append_column_editable() Workaround for gcc 2.95.3 compilation
    bug. (Martin Schulze)
  - TreeModel::foreach() return value marshalled properly. (Gergo Erdi)

* lifecyle: C++ deletion really destroys GtkObjects again. (Murray Cumming)
* Glib::Object: removed warnings when using libglademm. (Murray Cumming)
* Gtk::manage(): Now emits warnings when you try to use it on a top-level
  Window. (Murray Cumming)

* examples:
  - Removed old menu and combo examples.
  - Corrected use of Gtk::manage() on top-level windows.
  - Added cleaner combo example in example/book/combo.
  - rulers fixed. (Martin Schulze)

* API changes:
  - Gtk::Combo: Added ComboDrowDown class - it wraps the deprecated GtkList
    widget that is used in the GtkCombo interface. gtkmm coders can now set
    individual item strings and use widgets for Combo items. See
    examples/book/combo. (Martin Schulze)
  - Gdk::Drawable: draw_rectangle() and draw_arc(): Changed filled arg from
    int to bool. (Michael Koziarski)
  - Gdk::Color: *_p() renamed to get_*_p(). (Andreas Holzmann)
  - Gtk::TextMark: Added get_iter() as a convenience. (Martin Schulze)
  - Gtk::TextBuffer: delete_at_cursor() and insert_at_cursor() return the
    iterator, to be consistent with the other methods. (Martin Schulze)
  - Gtk::TextBuffer: paste_clipboard(), insert_child(), and
    create_child_anchor() parameters are now const. (Martin Schulze)
  - Gtk::Bin::add_label(): Added override, using enum. (Gergo Erdi)
  - Gtk::IconFactory and Gtk::StockItem: Changed string parameters to
    Gtk::StockID to allow use of Gtk::BuiltinStockID. (Murray Cumming)


2002-08-06 1.3.19:
* Gtk::TreeView classes:
  - Added TreeModel::RowReference wrapper - it remains valid even when the
    rows are sorted.
  - All methods that take a Model::iterator can also take a Model::Row.
    (Murray Cumming)
  - Added TreeView::append_column_editable() method. It creates columns whose
    cells automatically store new values in the model when they are edited.
    See documentation:
    http://www.gtkmm.org/gtkmm2/tutorial/html/ch10s02.html#id2837147
  - Added TreeModel::foreach() wrapper.
  - Added TreeView::remove_all_columns().
  - treestore demo: Parent rows don't show toggle cells anymore.
    (Daniel somebody)
* Box::pack_start() and pack_end() API:
  - Restore the old (bool, bool) methods as overload, so it's easier to
    port to gtkmm2.
  - Changed the ORed flags to a simpler set of 3 mutually-exclusive enums.
  (Michael Babcock)
* Menu API:
  - Main Menu items are now accelerated automatically.
  - Popup menus need to be accelerated at the appropriate time - handy
    accelerate() overloads were created for this.
  - AccelMap: New wrapper.
   (Andreas Holzmann)
  - ImageMenuElem items now show their icons automatically.
   (Murray Cumming)
* Lifecycle:
  - Top-level windows are now properly destroyed, and definitely can't be
    manage()d.
  - Added test for this (Michael v. Szthombathely)
  - Prevented some double-destruction of signal connections.
  - Prevented recreation of 2nd C++ instances by Glib::wrap() during
    destruction of the C instances.
  - Prevented calling of signal handlers of destroyed C++ instances.
  (Murray Cumming, Valgrind)
  - Corrected refounting of some get*() methods. (Christof Pettig)
* Sun Forte compiler fixes:
  - Examples use more lengthy code when Sun's compiler can't handle the
    templated TreeView methods.
  - Explicit specification of templated Glib::wrap() specializations.
  (Michael v. Szthombathely, Murray Cumming)
* gcc 3.1 fixes (Jarek Dukat)
* Added vast number of const get_*() const overloads. (Jarek Dukat)
* Added alignment enum, used in overloads as an alternative to 0.5, 1.0, etc.
  (Murray Cumming)
* Gtk::Style: Added const overloads of get_*gc() methods.
* Documentation:
  - Allow use of a local DocBook stylesheet, for people who aren't connected.
  (Marcelo E. Magallo)
  - Added Gtk::Main::run(window) overload reference docs.
    (Moreten Brix Pedersen)
  - Added RefPtr<> reference docs. (Ole Laursen)
  - Prevented reuse of C docs that talk about free-ing stuff. (Murray Cumming)
* autogen fix for GTKMM_VC_PERL_VERSION problem. (Marcel E. Magallo)
* Corrected library versioning of the internal gtk_extra_defs library.
  (Bradley Bell)
* FontSelection example fixed. (Morten Brix Pedersen)


2002-07-14 1.3.18:

* documentation:
    ( See http://www.gtkmm.org/gtkmm2/ )
    book: Added TreeView chapter.
          Added custom signals section.
          (Murray Cumming)
    reference: Added Menus and TextView groups.
               Added vast amounts of class documentation, and method
               documentation reused from GTK+.
               (Murray Cumming, James Henstridge, Morten Brix Pedersen)
    PORTING: Additions and clarifications. (Jarek Dukat, Morten Brix Pedersen)
    examples: Added menus and custom signals examples. (Murray Cumming)
              Corected original menu examples. (Liam Girdwood)
    internals: Corrected _DEPS description. (Marcelo Magallon)
* Gtk::TreeView classes:
  - Models columns can be accessed by number, for dynamically-created models.
  - Added overrides to take TreeModel::Rows as well as TreeModel::iterators.
  - Row: Added operator bool().
  (Murray Cumming)
* Gtk::TextView classes
   - Added TextBuffer:: typedefs for Tag, TagTable and Mark.
   - TextBuffer: insert() methods now return the new iterator instead of
     modifying the input iterator, to be more STL-like.
   - Renamed get_start_iter() and get_end_iter() to begin() and end().
   - Made get() methods const.
   (Murray Cumming)
* Gtk::Table: The STL-style list now works. It probably never worked before,
  even in gtkmm 1.2. (Murray Cumming)
* Gtk::RadioButton::Group: Simplified copying/passing semantics.
* Gtk::Menu: Show stock menu item icons. (Christof Petig)
* Glib::IConv: constructor handles errors and throws appropriate exceptions.
  (Jarek Dukat)
* Sun Forte compiler fixes. (Murray Cumming)
* vfunc wrapper generation simplification. (Murray Cumming)
* Gtk::Invisible: Correct constructor bug discovered by
  Tony <a_a_c@bellsouth.net> (Murray Cumming)
*  gcc 3.1 fixes. (Jarek Dukat, Gergo Erdi)


2002-06-22 1.3.17:

* Win32 support. (Cedric Gustin, Daniel Elstner)
* STL-style interfaces: Use of references rather than pointers as value types,
  to avoid double indirection when dereferencing iterators. (Martin Schulze)
* vfunc wrappers: All overrideable vfuncs now have the "_vfunc" suffix, and
  they all have separate invoker methods, which are usually wrappers of the C
  invoker functions. (Daniel Elstner)
* Gtk::Box STL-style interface uses Gtk::AttachOptions instead of bools,
  for consistency. (Jarek Dukat)
* Added examples/gdk, which shows gdkmm drawing code. (Alain Rouge)
* Added Gdk::RgbCMap wrapper. (Murray Cumming)
* Added Pango::GlyphString wrapper. (Murray Cumming)
* Many more get_*() methods are now const. (Jarek Dukat)
* Gtk::TextBuffer::create_mark() reference-count bug fixed. (Andrew E Makeev)
* Gdk::Drawable: Compilation fix for Sun's Forte compiler. (Michael v. Szombathely)
* Added Glib::Module wrapper. (Murray Cumming)
* Improved gtkmmproc documentation. (Murray Cumming)
* Distribute CHANGES files. (Morten Brix Pedersen)


2002-06-17: 1.3.16:

* Distribute cell renderer example header files.  Doh!  (Daniel Elstner)
* Rename several remove_foo() methods to unset_foo(), to avoid confusion with
  container operations.  (Daniel Elstner)
* Gtk::FileSelection::set_filename(): Change argument type to std::string, to
  follow the GTK+ inconsistency fix -- both get_filename() and set_filename()
  work with on-disk encoding now.  (Daniel Elstner)
* Glib::Mutex::Lock and friends: Replace the bool acquire_immediately
  parameter with overloaded ctors.  See the docs, it should be easier now.
  (Daniel Elstner)

2002-06-15: 1.3.15:

* Major low-level GObject changes to allow on-the-fly GType registration. This allows
  creation of custom TreeView CellRenderers in C++, and should allow implementation of
  GTK+ Interfaces in C++. See examples/cellrenderercustom/
  (Daniel Elstner)
* Gtk::Notebook: Restored the STL-style interface, but this time properly.
   (Martin Schulze)
* Gtk::TreeSortable: set_sort_func() now uses SigC C++ Slots instead of C callbacks.
   (Jarek Dukat)
* Glib::Dispatcher:  A special libsigc++ signal for easy inter-thread communication through
   a pipe. See examples/thread/dispatcher and
   http://www.gtkmm.org/gtkmm2/reference/html/classGlib_1_1Dispatcher.html#_details
  (Daniel Elstner)
* Added optimisation that allows us to use C++ types even in default signal handlers, so
  there should soon be no C types anywhere in the gtkmm interface. (Daniel Elstner)
* Added comments to the C<->C++ callback hookups. (Murray Cumming)
* Gtk::MenuShell and MenuBar implementation cleanup. (Daniel Elstner)
* Gdk::Pixmap/Bitmap implementation simplified. (Daniel Elstner)
* Gtk::Widget:
   - new enum Gtk::WidgetFlags.
   - width() renamed to get_width(). Likewise height().
  (Daniel Elstner)
* Gdk::Drawable: More use of C++ types, and constness fixes. (Daniel Elstner)
* Gtk::Style: Wrap gtk_paint_*() functions. (Daniel Elstner)
* Gtk::Stock:
  - Implement Gtk::Stock::add().
  - StockItem: Allow checking for null.
  (Daniel Elstner)
* Gtk::Paned::pack(): Uses the AttachOptions enum instead of unreadable bools.
  (Daniel Elstner)
* Removed need for wrap_specific_type(). (Daniel Elstner)
* Removed Gtk::Kit typedef. Just use Gtk::Main. (Daniel Elstner)

2002-05-12: 1.3.14:

* Gtk::TreeView and friends:
  - Namespaced TreeIter, TreePath, TreeViewColumn, etc, as TreeModel::iterator,
    TreeModel::Path, TreeView::Column, etc. (Murray Cumming)
  - Separated TreeModel::iterator into iterator and Row, obtained by
    dereferencing the iterator. This is more STL-like. (Daniel Elstner)
  - Some Model methods moved to Row, and set_value()/get_value() replaced by
    array-style operator[]. (Daniel Elstner)
  - Added overrides to allow for simple model-to-view column mapping without
    repetitive specifying of TreeViewColumns and CellRenderers and attributes.
    Examples and demos therefore greatly simplified. (Murray Cumming)
  - TreeModel::iterator comparison problems fixed. (Daniel Elstner)
  - Added Path(iterator&) constructor.
  - All get_*() methods are now const. (Murray Cumming)
* Gtk::Box::pack_start() and pack_end(): Now uses AttachOptions flags instead
  of two bool paratemers, to make code more readable and to be consistent with
  Gtk::Table::attach(). (Murray Cumming)
* Gtk::Notebook: STL-style interface remoeved because GTK+ doesn't expose
  enough internals anymore. The simple append/prepend interface remains.
  (Murray Cumming)
* Some enums placed inside their related classes. (Daniel Elstner)
* Glib::FileError enums renamed to avoid clashes with C #defines on some
  platforms (Daniel Elstner)
* Fixed refcount problem with manage() ed child widget destruction.
  (Murray Cumming)
* test suite started. (Daniel Elstner)
* Glib::Value and properties simplifications. (Daniel Elstner)
* Gtk::Dialog: Dialogs are now hidden when run() finishes. (Murray Cumming)

2002-05-01 gtkmm 1.3.13:

* Mostly just a release to sync with a new gnomemm release.
* Some glibmm code is now autogenerated with gtkmmproc (Daniel Elstner)
* Improvements to enum generation (Daniel Elstner)
* Improvements to glibmm character conversions (Daniel Elstner)
* gtk-demo segfault fixed. (Martin Schulze)

2002-04-27 gtkmm 1.3.12:

* Many many fixes for Sun's Forte C++ compiler.
  (Michael v. Szombathel, Daniel Elstner, Murray Cumming)
* StockID API improved and used more consistently.
  (Martin Schultze, Daniel Elstner)
* Glib::ustring conversion improvements (Daniel Elstner)
* gtkmmproc improved for use in bonobomm. (Murray Cumming)
* Gdk::Point wrapper improved. (Martin Schulze)
* Gtk::Adjustment constructor fixed. (Murray Cumming)
* Gtk::TreeView:methods that took function pointers now take SigC::Slots.
  (Murray Cumming)
* Less #including of C headers in gtkmm headers, so less pollution of the
  global namespace. (Murray Cumming)
* Menu API more complete and consistent. (Martin Schultze)
* Gtk::Dialog::get_action_area() now does. (Murray Cumming)
* GType changes to allow libglade/libglademm cooperation. (Murray Cumming)
* Reference documentation:
  - Stock IDs in HTML:
  http://gtkmm.org/gtkmm2/reference/html/namespaceGtk_1_1Stock.html#a6
  - Makefile dependencies fixed for faster docs building.
* General API review.

2002-04-13 gtkmm 1.3.11:

* gdkmm.h: No longer includes non-existent files. (Daniel Elstner)
* Build: Non-cvs users don't need perl. (Daniel Elstner)
* glibmm: pkg-config now reports libgobject for linking. (Murray Cumming).

2002-04-11 gtkmm 1.3.10:

* Now builds with {G,GDK,GTK}_DISABLE_DEPRECATED - some methods removed;
  entirely removed Gdk::Font and Gtk::Progress. (Daniel Elstner)
* Reference documentation:
  - Some automatic C->C++ conversion when reusing C reference documentation:
  - enums and flags grouped together.
  - html post-processed to produce "int& someint" instead of "int &someint".
  - Some example code merged into the refernce docs.
  (Daniel Elstner)
* Gtk::TreeView:
  - Gtk::TreeIter is a bit more like a STL iterator.
  - Gtk::ListStore has a more STL-like interface.
  - Gtk::TreeModelColumn - new class used to contain column type and number.
  - Gtk::TreeModelColumnRecord - new class to contain all TreeModelColumns.
  - examples/demos updated accordingly.
  (Daniel Elstner)
* gtkmm now uses its own enums, in the Gtk namespace. (Daniel Elstner)
* Gtk::ProgressBar: removed deprecated Adjustment stuff, leaving just the
  new fraction-orientated interface. (Daniel Elstner)
* Some .hg format changes needed by bonobomm. (Murray Cumming)
* new Glib::IOSource for watching file descriptor. (Martin Schultze)

2002-03-27 gtkmm 1.3.9:

* Custom Signal Proxies simplified, implementing only custom C callback
  functions and specifying them to the signal proxy constructors.
  (Daniel Elstner)
* Complete recoding of Boxed Types wrappers, not using generic _copy
  and _free methods functions when they aren't necessary, and sometimes
  inheriting directly from the underlying struct. (Daniel Elstner)
* gtk-demo compilation fixed. (Daniel Elstner)
* gtk-demo stock browser part rewritten and working. (Matthew Walton)
* Properly implemented enum and flags property proxies. (Daniel Elstner).
* Reference documentation:
  - some gtk+ docs are now merged in automatically, but we don't yet
    have acccess to the stuff in gtk+'s tmpl/*.sgml files.
    (Murray Cumming)
  - Added class documentation, based on docs in GTK+.
  - Custom headers and footers.  (Paolo Pinto)
* Added Gtk::TreeSortable, Gtk::TreeDragDest, and Gtk::TreeDragSource
  interface wrappers.  (Murray Cumming)
* Gdk::Pixbuf: render* method args are now const-correct, which allows
  casting of temporary instances. (Murray Cumming)
* Gtk::MessageDialog: changed argument order in constructors, to
  allow sensible defaults. (Murray Cumming)

2002-03-11 gtkmm 1.3.8:

* Generated C++ source code is now distributed, so that we can use extra
  dependencies, such as perl modules, when generating the C++ source.
  (Daniel Elstner)
* Signals now use C++ types. We've said it before, but this time we meant it.
  (Murray Cumming)
* Added an exception hierarchy, used to wrap GError. Used in
  Gdk::Pixbuf and demonstrated in demos/pixbuf-demo. (Daniel Elstner).
* Drag and Drop now wrapped, with examples, and the first draft of a chapter in
  the tutorial:
  http://gtkmm.sourceforge.net//gtkmm2/tutorial/html/ch12.html
  (Murray Cumming)
* Revised Gtk::Menu API - accelerators now work. (Andreas Holzmann)
* Glib::ustring can now be used directly with standard streams, converting
  to the current locale where necessary. (Daniel Elstner)
* Added wrappers for glib conversion functions. (Daniel Elstner)
* Initial GtkClipboard wrapper. (Murray Cumming)
* Simplified checks for standard library features (Daniel Elstner)



2002-02-24 gtkmm-1.3.7:

* operator=() for BoxedTypes improved. (Daniel Elstner)
* pangomm api review, and use of generic intermediate ListHandle containers.
  for method arguments instead of just std::list. (Gergo Erdi)
* Gdk::Cursor constructor now public. (Andreas Holzmann)
* property.get_value() improved. (Andreas Holzmann)
* New wrappers for Atk::Relation, Atk::RelationSet, and Atk::StateSet.
  (Murray Cumming)
* Glib::ustring documentation and case conversion methods.
  (Daniel Elstner)
* Improvements to ListHandle generic intermediate containers.
  (Daniel Elstner)
* Gtk::TreeModel: several methods now take C++ arguments instead of C types.
  (Murray Cumming)
* Build fails on failed m4 conversions. (Daniel Elstner)


2002-02-20 gtkmm-1.3.6:

No major changes - mostly just a workaround for gcc 2.95.4.

* gcc 2.95.4 seems to have a problem with a use
of RefPtr::operator bool() in textbuffer.cc, so
we've used is_null() as a workaround. This is mysterious.
* configure.in mentioned a Makefile.am that isn't distributed.
* Added examples/book, which will contain examples from the

2002-02-18 gtkmm-1.3.5:
* Tutorial converted to latest DocBook XML, with some improvements of the text.
  (Murray Cumming)
* Examples can be built all at once. Some use of deprecated widgets removed.
  (Murray Cumming)
* Gdk::Cursor: Gdk::Color args are now const. (Andreas Holzmann)
* Toolbar: StockElem can now be used to add stock items to toolbars.
  (Andreas Holzmann)
* Gdk::Bitmap now derives from Gdk::Pixmap, allowing a Bitmap to be used
  anywhere that a Pixmap can be used. This is the intention in GTK+.
  (Murray Cumming, Andreas Holzmann)
* Gtk::TextBuffer improvements (Daniel Elstner)
* More wrapping of Atk::Object (Murray Cumming)
* Documentation overview page:
  http://gtkmm.sourceforge.net/gtkmm2/
  (Paulo Pinto)

2002-01-26 gtkmm-1.3.4:

* Removed deprecated widgets such as CList, CTree, Text, etc. (Murray Cumming)
* Some exception handling: Use Glib::add_exception_handler() to specify a method to be called in the unlikely event that a signal handler throws an exception. If it's not used then gtkmm will report the problem and then segfault normally. Previously the exception would just be swallowed by the underlying C code and you'd have an uniformative segfault.
  (Karl Nelson)
* Menu Elements: Menu Elements can now be stored in STL containers. Fixed rare memory leak
  (Karl Nelson)
* Improved, clearer, more versatile intermediate handle types, for lists/vectors/arrays of strings/widgets etc.
  (Daniel Elstner)
* Improved reference documentation: Signal accessors show the names of the signal handler arguments, and Widgets, Containers, and Dialogs can be seen grouped toether on their own special pages.
  (Murray Cumming)
* Improved Gtk::TreeView and Gtk::TextView API, using more C++ types. (Murray Cumming, Daniel Elstner).


2002-01-10 gtkmm-1.3.3:

* Interface methods use C++ types:
    Interfaces now have a something_vfunc() which uses C types and which can be overridden to change the behaviour, and something() which uses C++ types and can be used to invoke the virtual function. This seems like the best mix of efficiency and convenience. (Murray Cumming)
* Property change notification:
    Added changed signal to property proxies. For instance, you can now do:
      something.property_example().signal_changed().connect( ... ).
   (Murray Cumming)
* Simplified inheritance hierarchy:
   Glib::ObjectBase derives from SigC::Object, thus Glib::Object no longer needs to derive from SigC::Object by using Multiple Inheritance. (Daniel Elstner)


2001-12-28 gtkmm-1.3.2:

* No more gint, gdouble, gfloat, glong:
   We use normal C++ types instead. (Murray Cumming)
* Signals are now used via accessors, and SigC::slot() requires a reference to the instance instead of a pointer.
    For instance,
    gtkmm 1.2: button.clicked.connect(SigC::slot(this, &Something::somemethod));
    gtkmm 1.3: button.signal_clicked().connect(SigC::slot(*this, &Something::somemethod));
  (Karl Nelson)
* Properties are used via accessors. For instance:
    someobject.property_something().set_value(2);
  (Karl Nelson)
* Removed any uses of Glib::nstring:
  We provide an additional method instead of allowing a null value. e.g. remove_something() instead of
  set_something(0). (Daniel Elstner)
* Improved gtkmmproc installation:
    For use by, for instance, libgnomeuimm and libgnomecanvasmm. (Murray Cumming)
* Menu wrappers updated for GTK+2. (Murray Cumming)
* Another gtkmmproc overhaul. It now detects more .defs format errors, warns about as yet unwrapped functions,
  and is faster. (Karl Nelson)
* More api review and fixes. (Murray Cumming, Daniel Elstner, Gergo Erdi, Karl Nelson)

Note also that we use a newer version of libsigc++-1.1 which contains some segfault-related fixes.


2001-11-28	gtkmm-1.3.1.

* Properties ( e.g. someobject.property_something.set_value(2); ) (Murray Cumming)
* ListHandler (Use almost any std container where GTK+ takes/returns a GList*) (Daniel Elstner)
* TreeView and TextView wrappers, including multiply-inherited 'Interface' classes, such as Gtk::TreeModel
  (Murray Cumming)
* gtk-demo: C++ version of the big new gtk+ demo that shows its own source code.
  This demonstrates TreeView, TextView, and Pango, among other things. (Murray Cumming)
* Reference documentation, using doxygen:
  http://gtkmm.sourceforge.net/gtkmm2/reference/html/
  (Murray Cumming)
* Gtk::Window no longer self-destructs. The bool return value of Gtk::Window::signal_delete_event now
  determines whether the window will be hidden, not whether it will be destroyed. (Daniel Elstner)
* Gtk::Main::run(Gtk::Window& window):
  Allows you to specify a main application window. The application will quit when that window is hidden.
  (Murray Cumming)
* Lots and lots of API review. See our progress here:
  http://cvs.gnome.org/bonsai/cvsblame.cgi?file=gtkmm-root/base/api_status.txt&rev=&root=/cvs/gnome
  (Murray Cumming, Daniel Elstner, Gergo Erdi)
* We can now use either automake 1.4p5 (like the rest of GNOME2) or automake 1.5 (Daniel Elstner)
* Glib::ustring, which interoperates with std::string now has even more of the std::string interace.
  (Daniel Elstner)
* Fixed the library names and the names reported by pkgconfig, for better co-existence with gtkmm 1.2.
  (Gergo Erdi)

Known problems:
  gtk-demo crashes on exit with warnings.
  gtk-demo "stock browser" doesn't work yet.
  Gtk::TreePath(ustring) constructor seems to have problems - see the TODO comments in demos/gtk-demo/example_treeview_editable_cells.cc



2001-10-26	gtkmm-1.3.0.

Initial release, introducing:
* Glib::ustring
* Glib::RefPtr
* signal_ prefix
* Renamed default signal handlers (on_ prefix).
* Rewritten gdkmm
